
      subroutine findmin(n,y,ismoo, imin1,imax2,imax3,imaxfin,
     _     modif_y)
C     ==== finds local minimum and maxima after smoothing an array ====
      parameter(maxn=3000,mxsmoo=20) ! 

C     INPUTS:
      integer*4   n
      real*4      y(*) ! size must not be greater than maxn
      integer*4   ismoo  ! smoothing
      logical*4   modif_y

C     OUTPUTS:
      integer*4   imin1,imax2,imax3
C     !! y is replaced by ysmoo if ( modif_y .eq. .true. ) !!

C     INTERNAL:
      real*4      ysmoo(maxn),x(maxn)
      parameter(pi=3.14159265359)

      logical*4   test

c      data test/.true./ !.false./ !
      common /testcomm/ test  ! evaluated in plates MAIN programme

      if(n.gt.maxn)print*,'findmin ERROR: n,maxn=',n,maxn
      if(ismoo.gt.mxsmoo)print*,'findmin ERROR: ismoo,mxsmoo=',
     _     ismoo,mxsmoo


      if(ismoo.ge.1)then
         fact=1.0/sqrt(2.0*pi) /real(ismoo)
      endif
      
      ymin=9e9
      ymax=-9e9
      if(test)print*,'ismoo=',ismoo
      do i=1,n
         if(ismoo.ge.1)then
            ysmoo(i)=0.0
            do j=max(1,i-2*ismoo),min(i+2*ismoo,maxn) ! -> 2 sigma
               dd= real(j-i)
               xx= exp(-0.5*dd*dd/real(ismoo*ismoo))
               ysmoo(i)=ysmoo(i)+ xx*y(j)   

c     if(test)print*,'j,dd=',j,dd
c     ysmoo(i)=ysmoo(i)+y(i)
c     fact=1.0/real(2*ismoo+1)
               
            enddo

            ysmoo(i)=ysmoo(i)*fact ! only needed for testing
         else
            ysmoo(i)= y(i)
         endif
         ymin=min(ymin,y(i))
         ymax=max(ymax,y(i))

      enddo


      if(test)then

         ymax=min(ymax,600.0) ! for omcc.tex fourier paper.
         do i=1,n
            x(i)=real(i)
         enddo

         call pgbegin(0,'?',1,1)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgscf(2)
         call pgslw(3)
         call pgwindow(0.0,real(n), ymin,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsls(2)
         call pgline(n,x,y)
         call pgsls(1)
         call pgline(n,x,ysmoo)
         call pgsls(1)
         call pglabel('i','y, ysmoo',' ')
      endif



c     --------------------------------------------------------------
c     _      - first min.
      i=1+ismoo ! modified for  r.a. (idirn=2), not checked for  redsh

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min1: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin1=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax2=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax3=i
      
c     ---- last max

      i=n-ismoo/2
c      i=n-ismoo
      dmin=ysmoo(i)
      do while(i.gt.1 .and. ysmoo(i-1).lt.dmin)
         dmin=min(dmin,ysmoo(i-1))
         i=i-1
         if(test)print*,'minfin: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      iminfin=i

      dmax=ysmoo(i)
      do while(i.gt.1 .and. ysmoo(i-1).gt.dmax)
         dmax=max(dmax,ysmoo(i-1))
         i=i-1
         if(test)print*,'maxfin: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imaxfin=i

c     --------------------------------------------------------------


      if(test)then
         call pgsch(3.0)
         call pgslw(6)
         call pgpoint(1,x(imin1),ysmoo(imin1),22)
         call pgpoint(1,x(imax2),ysmoo(imax2),22)
         call pgpoint(1,x(imax3),ysmoo(imax3),4)
         call pgpoint(1,x(imaxfin),ysmoo(imaxfin),14) ! 22)

         call pgsch(0.9)
         call pgslw(1)
         call pgptxt(x(imin1),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imin1')
         call pgptxt(x(imax2),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax2')
         call pgptxt(x(imax3),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax3')
         call pgptxt(x(imaxfin),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,
     _        'imaxfin')

         call pgend
      endif

      if(modif_y)then
         do i=1,n
            y(i)=ysmoo(i) ! warning: y is modified !
         enddo
      endif

      return
      end



      subroutine fimax4(n,y,ismoo, imax1,imax2,imax3,imax4,
     _     modif_y)
C     ==== finds local minimum and maxima after smoothing an array ====
      parameter(maxn=3000,mxsmoo=20) ! 

C     INPUTS:
      integer*4   n
      real*4      y(*) ! size must not be greater than maxn
      integer*4   ismoo  ! smoothing
      logical*4   modif_y

C     OUTPUTS:
      integer*4   imax1,imax2,imax3,imax4
C     !! y is replaced by ysmoo if ( modif_y .eq. .true. ) !!

C     INTERNAL:
      real*4      ysmoo(maxn),x(maxn)
      parameter(pi=3.14159265359)

      logical*4   test

c      data test/.true./ !.false./ !
      common /testcomm/ test  ! evaluated in plates MAIN programme

      if(n.gt.maxn)print*,'findmin ERROR: n,maxn=',n,maxn
      if(ismoo.gt.mxsmoo)print*,'findmin ERROR: ismoo,mxsmoo=',
     _     ismoo,mxsmoo


      if(ismoo.ge.1)then
         fact=1.0/sqrt(2.0*pi) /real(ismoo)
      endif
      
      ymin=9e9
      ymax=-9e9
      if(test)print*,'ismoo=',ismoo
      do i=1,n
         if(ismoo.ge.1)then
            ysmoo(i)=0.0
            do j=max(1,i-2*ismoo),min(i+2*ismoo,maxn) ! -> 2 sigma
               dd= real(j-i)
               xx= exp(-0.5*dd*dd/real(ismoo*ismoo))
               ysmoo(i)=ysmoo(i)+ xx*y(j)   

c     if(test)print*,'j,dd=',j,dd
c     ysmoo(i)=ysmoo(i)+y(i)
c     fact=1.0/real(2*ismoo+1)
               
            enddo

            ysmoo(i)=ysmoo(i)*fact ! only needed for testing
         else
            ysmoo(i)= y(i)
         endif
         ymin=min(ymin,y(i))
         ymax=max(ymax,y(i))

      enddo


      if(test)then

         ymax=min(ymax,600.0) ! for omcc.tex fourier paper.
         do i=1,n
            x(i)=real(i)
         enddo

         call pgbegin(0,'?',1,1)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgscf(2)
         call pgslw(3)
         call pgwindow(0.0,real(n), ymin,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsls(2)
         call pgline(n,x,y)
         call pgsls(1)
         call pgline(n,x,ysmoo)
         call pgsls(1)
         call pglabel('i','y, ysmoo',' ')
      endif

c     _      - first min.
      i=1+ismoo ! modified for  r.a. (idirn=2), not checked for  redsh

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min1: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin1=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax1=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax2=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax3=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax4=i
      

      if(test)then
         call pgsch(2.0)
         call pgslw(4)
         call pgpoint(1,x(imax1),ysmoo(imax1),4)
         call pgpoint(1,x(imax2),ysmoo(imax2),6)
         call pgpoint(1,x(imax3),ysmoo(imax3),7)
         call pgpoint(1,x(imax4),ysmoo(imax4),14)

         call pgsch(0.9)
         call pgslw(1)
         call pgptxt(x(imax1),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax1')
         call pgptxt(x(imax2),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax2')
         call pgptxt(x(imax3),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax3')
         call pgptxt(x(imax4),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,
     _        'imax4')

         call pgend
      endif

      if(modif_y)then
         do i=1,n
            y(i)=ysmoo(i) ! warning: y is modified !
         enddo
      endif

      return
      end






      subroutine fimax4_2(n,y,nfull,ioff,yfull,
     _     ismoo, imax1,imax2,imax3,imax4,
     _     modif_y)
C     ==== finds local minimum and maxima after smoothing an array ====
      parameter(maxn=3000,mxsmoo=20) ! 
c     ---- Version modified BFR 24/05/01 in order to allow smoothing
c     below the "first" point of the array if this is possible ----

C     INPUTS:
      integer*4   n
      real*4      y(*) ! size must not be greater than maxn
      integer*4   nfull ! size of "full" array including points "below" the limit
      integer*4   ioff  ! index in yfull where y starts
      real*4      yfull(*)   ! the "full" array

      integer*4   ismoo  ! smoothing
      logical*4   modif_y

C     OUTPUTS:
      integer*4   imax1,imax2,imax3,imax4
C     !! y is replaced by ysmoo if ( modif_y .eq. .true. ) !!

C     INTERNAL:
      real*4      ysmoo(maxn),x(maxn)
      parameter(pi=3.14159265359)

      parameter(tol=1e-4)

      logical*4   test

c      data test/.true./ !.false./ !
      common /testcomm/ test  ! evaluated in plates MAIN programme

      if(n.gt.maxn)print*,'findmin ERROR: n,maxn=',n,maxn
      if(ismoo.gt.mxsmoo)print*,'findmin ERROR: ismoo,mxsmoo=',
     _     ismoo,mxsmoo


      if(ismoo.ge.1)then
         fact=1.0/sqrt(2.0*pi) /real(ismoo)
      endif
      
c     ---- check comparison of y and yfull ----
      ydiff=0.0
      do i=1,n
         ydiff=ydiff+ y(i)-yfull(i+ioff)
c         print*,'y(i),yfull(i+ioff)=',y(i),yfull(i+ioff) !! test only !!
      enddo
      if(n.ge.1)ydiff=ydiff/real(n)
      if(abs(ydiff).gt.tol)then
         print*,'fimax4_2: WARNING: ydiff=',ydiff
c      else
c         print*,'fimax4_2: ydiff OK =',ydiff
      endif
         

      ymin=9e9
      ymax=-9e9
      if(test)print*,'ismoo=',ismoo
      do i=1,n
         if(ismoo.ge.1)then
            ysmoo(i)=0.0
c            do j=max(1,i-2*ismoo),min(i+2*ismoo,maxn) ! -> 2 sigma
            do j=max(1-ioff,i-2*ismoo),min(i+2*ismoo,maxn) !!24/05/01
               dd= real(j-i)
               xx= exp(-0.5*dd*dd/real(ismoo*ismoo))
c               ysmoo(i)=ysmoo(i)+ xx*y(j)   
               ysmoo(i)=ysmoo(i)+ xx*yfull(j+ioff)   !24/05/01

c     if(test)print*,'j,dd=',j,dd
c     ysmoo(i)=ysmoo(i)+y(i)
c     fact=1.0/real(2*ismoo+1)
               
            enddo

            ysmoo(i)=ysmoo(i)*fact ! only needed for testing
         else
            ysmoo(i)= y(i)
         endif
         ymin=min(ymin,y(i))
         ymax=max(ymax,y(i))

      enddo


      if(test)then

         ymax=min(ymax,600.0) ! for omcc.tex fourier paper.
         do i=1,n
            x(i)=real(i)
         enddo

         call pgbegin(0,'?',1,1)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgscf(2)
         call pgslw(3)
         call pgwindow(0.0,real(n), ymin,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsls(2)
         call pgline(n,x,y)
         call pgsls(1)
         call pgline(n,x,ysmoo)
         call pgsls(1)
         call pglabel('i','y, ysmoo',' ')
      endif

c     _      - first min.
      i=1+ismoo ! modified for  r.a. (idirn=2), not checked for  redsh

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min1: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin1=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax1=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax2=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax3=i

      dmin=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).lt.dmin)
         dmin=min(dmin,ysmoo(i+1))
         i=i+1
         if(test)print*,'min2: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imin2=i

      dmax2=ysmoo(i)
      do while(i.lt.n-1 .and. ysmoo(i+1).gt.dmax2)
         dmax2=max(dmax2,ysmoo(i+1))
         i=i+1
         if(test)print*,'max3: i,y(i),ysmoo(i)=',i,y(i),ysmoo(i)
      enddo
      imax4=i
      

      if(test)then
         call pgsch(2.0)
         call pgslw(4)
         call pgpoint(1,x(imax1),ysmoo(imax1),4)
         call pgpoint(1,x(imax2),ysmoo(imax2),6)
         call pgpoint(1,x(imax3),ysmoo(imax3),7)
         call pgpoint(1,x(imax4),ysmoo(imax4),14)

         call pgsch(0.9)
         call pgslw(1)
         call pgptxt(x(imax1),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax1')
         call pgptxt(x(imax2),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax2')
         call pgptxt(x(imax3),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,'imax3')
         call pgptxt(x(imax4),ysmoo(imin1)+0.05*(ymax-ymin),
     _        0.0,0.0,
     _        'imax4')

         call pgend
      endif

      if(modif_y)then
         do i=1,n
            y(i)=ysmoo(i) ! warning: y is modified !
         enddo
      endif

      return
      end









      subroutine rebin(n,y,irebin)
C     ---- rebins histogram with bigger bins, to help with finding
C     maxima, i.e. this is a sort of `rough' smoothing ----

C     INPUTS:
      integer*4 n,irebin
      real*4  y(*)  ! also an OUTPUT

C     !! warning: values of y are modified
      
      if(irebin.lt.2)print*,'rebin WARNING: irebin=',irebin

      if(irebin.eq.0)then
         return
      else
         

         do i=0,n/irebin-1

            ymean= 0.0
            do j=1,irebin
               ymean=ymean+y(i*irebin+j)
            enddo
            ymean=ymean/real(irebin)

            do j=0,irebin-1
               y(i*irebin+j)= ymean
            enddo
         enddo

C     ---- note that last few bins (remainder after division) are not rebinned

      endif
      return
      end

