      program plot_cf
c     ==== compare smoothed correlation functions, as fn of Om_m and
C     Om_Lambda, as output by plotcorrnall.f ====

      parameter(mxfile=3)
      character*64  infile(mxfile)

c      parameter(mxbin=300,mxc=30,mxerr=3)
      parameter(mxbin=1050,mxc=30,mxerr=3) ! Oct 2001
      real*4   robs(mxbin)
      real*4   om_0(mxc),cc_0(mxc)
      real*4   corr(mxbin,mxc,mxc,mxerr,mxfile)!! WARNING: icc ,iom

      parameter(mxfeat=4) ! max number of "features"
      integer*4  jmax(mxfeat)
      integer*4  imax(mxfeat)
      real*4   rmax(mxfeat,mxfile,mxc,mxc)

      integer*4  ioff2dF(mxfeat)

      parameter(mxstat=3)
      real*4   stat(mxc,mxc,mxstat) !! WARNING: iom,icc 
      real*4   xnoise(mxc,mxc) !! WARNING: iom,icc 
      parameter(nfine=1)
      real*4   statfine(mxc*nfine,mxc*nfine,mxstat) !! WARNING: iom,icc 

      logical*4  modif_n ! modify curves when looking for maxima ?

      logical*4     putquinlabel ! put quintessence labels ???
      logical*4     putrminlabel
      logical*4     dopgconf ! call pgconf( ) for filling contours

      logical*4     donoisecorr ! correction for noise as fn(om_0,cc_0) ?

      logical*4     do_wt ! use weights for rlss estimate ??


c     ---- contour plotting variables ----
      parameter(mxcont=20)
      real*4   cont(mxcont),tr(6),trfine(6)

      character*2  chistat
      character*4  ch4
      character*6  ch6
      character*8  ch8
      character*20  ch20



      data infile/
     _     'c_smooth.dat',
     _     'c_smooth.dat',
     _     'c_smooth1.6z2.2.dat'
c     _     'c_smooth0.6z1.1.dat',
c     _     'c_smooth1.1z1.6.dat',
c     _     'c_smooth1.6z2.2.dat'
     _     /

      data putquinlabel/.false. /!.true./! 
      data putrminlabel/.true./! .false. /!

      data dopgconf/.false. /!.true./! 

      data donoisecorr/.false. /!.true./! 

      data do_wt/.false. /!.true./! 

c     ---- adjustable key parameters  ----

      drobs=5.0 ! \hMpc

c      nfile=2
      ifile1=1!3!2!
      ifile2=2!3!1!
      print*,'ifile1,ifile2,mxfile=',ifile1,ifile2,mxfile
      imax1=1!3!2!
      imax2=1! 2!3!

c     8 * 5\hMpc = 40\hMpc  to start looking for maxima
      ioff2dF(1)= 600 !40! 22! 40 !38 ! 36! 8 ! 
      ioff2dF(2)= 30
      ioff2dF(3)= 40

      do im=imax1,imax2
         ioff2dF(im)=ioff2dF(im)/ ( nint(drobs/5.0) )
         print*,'im,ioff2dF(im)=',im,ioff2dF(im)
      enddo

      ib_fin= 900! 60!40 !70!


      izero= 3  ! no extra smoothing

      tol=1e-5

c     ---- donoisecorr variables ----
      z1noise= 0.6
      z2noise=2.2
      noiseL=240.0
      H_0=100.0
      

c     ---- read in correlation functions ----
      do ifile=ifile1,ifile2

         open(1,file=infile(ifile),access='sequential',
     _        form='unformatted',status='old')
         read(1)ncc,nom,(cc_0(icc),icc=1,ncc),
     _        (om_0(iom),iom=1,nom)
         print*,'ncc,nom,cc_0(ncc),om_0(nom)='
         print*,ncc,nom,cc_0(ncc),om_0(nom)
         
         read(1)nbins,
     _        (robs(i),i=1,nbins)
         do iom=1,nom
            do icc=1,ncc
               read(1)
     _              (corr(i,icc,iom,1,ifile),i=1,nbins),
     _              (corr(i,icc,iom,2,ifile),i=1,nbins),
     _              (corr(i,icc,iom,3,ifile),i=1,nbins)
            enddo
         enddo
         close(1)
         print*,'Have read ',infile(ifile)
         print*,'nbins,(corr(i,1,1,1,ifile),i=1,10)='
         print*,nbins,(corr(i,1,1,1,ifile),i=1,10)
c         print*,nbins,(corr(i,1,1,2,ifile),i=1,10)
c         print*,nbins,(corr(i,1,1,3,ifile),i=1,10)

      enddo



c     ---- correction of istat=2 statistic by noise expected ----
      if(donoisecorr)then
c         if(putquinlabel)stop 'quintessence not yet programmed'
c     ---- initialise characteristic z interval ----
         zmean= (z1noise+z2noise)/2.0
         iom=1
         icc=ncc
         
         if(.not.(putquinlabel))then         
            qq= om_0(iom)/2.0-cc_0(icc)

            d1= pdWein(qq,H_0,cc_0(icc), zmean)
            d2= d1+ noiseL
            zmean2= zofpdW(qq,H_0,cc_0(icc), d2)
         endif

         if(putquinlabel)then
            ccflat=1.0-om_0(iom)
            d1= pdWeiq(om_0(iom),H_0,ccflat, cc_0(icc), zmean)
            d2= d1+ noiseL
            zmean2= z_pdWq(om_0(iom),H_0,ccflat,cc_0(icc), d2)
         endif

         d12_0= sqrt(d2-d1)

c     ---- another option ----
         zmean=z1noise
         zmean2=z2noise
         if(.not.(putquinlabel))then         
            d1= pdWein(qq,H_0,cc_0(icc), zmean)
            d2= pdWein(qq,H_0,cc_0(icc), zmean2)
         else
            d1= pdWeiq(om_0(iom),H_0,ccflat,cc_0(icc), zmean)
            d2= pdWeiq(om_0(iom),H_0,ccflat,cc_0(icc), zmean2)
         endif

         d12_0= sqrt(d2-d1)

         do icc=1,ncc           ! ,ncc-1
            do iom=1,nom        !,nom-1

               if(.not.(putquinlabel))then         
                  qq= om_0(iom)/2.0-cc_0(icc)

                  d1= pdWein(qq,H_0,cc_0(icc), zmean)
                  d2= pdWein(qq,H_0,cc_0(icc), zmean2)
               endif

               if(putquinlabel)then
                  ccflat=1.0-om_0(iom)
                  d1= pdWeiq(om_0(iom),H_0,ccflat, cc_0(icc), 
     _                 zmean)
                  d2= pdWeiq(om_0(iom),H_0,ccflat, cc_0(icc), 
     _                 zmean2)
               endif

               xnoise(iom,icc)= sqrt(d2-d1)/d12_0
c               print*,'om_0(iom),cc_0(icc),xnoise=',
c     _              om_0(iom),cc_0(icc),xnoise
            enddo
         enddo
      endif !     if(donoisecorr)then


c     ---- find maxima as a way to characterise the corrn fns ----


      modif_n=.false.

      do ifile=ifile1,ifile2

c     call fimax4( nb_sm-ioff2dF,
c     _     c_tr(ioff2dF,icc,iom,icheck,1), izero,
c     _     imax1,imax2,imax3,imax4, modif_n)

         do icc=1,ncc
            do iom=1,nom

               do im=imax1,imax2
                  call fimax4_2( nbins-ioff2dF(im),
     _                 corr(ioff2dF(im),icc,iom,1, ifile), 
     _                 nbins,ioff2dF(im)-1,
     _                 corr(1,icc,iom,1, ifile), 
     _                 izero,
     _                 jmax(1),jmax(2),jmax(3),jmax(4), modif_n)
                  imax(im)=jmax(1)
               enddo

c     imaxlis(1)=imax1+ioff2dF-1
               if(icc.eq.12)then    !.and.iom.eq.8)then
                  print*,'icc,iom=',icc,iom
               endif
               do im=imax1,imax2
                  rmax(im,ifile,icc,iom)= 
     _                 robs(imax(im)+ioff2dF(im)-1)
c                  if(icc.eq.12)then !.and.iom.eq.8)then
c                     print*,'ifile,im,rmax(im,ifile)=',
c     _                 ifile,im,rmax(im,ifile)
c                  endif
                  
               enddo
            enddo               !         do iom=1,nom
         enddo                  !  do icc=1,ncc

      enddo ! do ifile=ifile1,ifile2

      sides=2.0

c     ==== istat=1 -> hypothesis that local maxima occur at same positions ====

      rlss68=0.0
      rlss68sig=0.0
      nrlss68=0
      wt68=0.0

      rlss95=0.0
      rlss95sig=0.0
      nrlss95=0
      wt95=0.0

      omtot68=0.0
      omtot68sig=0.0

      omtot95=0.0
      omtot95sig=0.0

      pp68=1.0-0.683
      pp95=1.0-0.954

      do icc=1,ncc
         do iom=1,nom
            stat(iom,icc, 1) = 0.0
            pp=1.0
            do im=imax1,imax2
               do ifile=ifile1,ifile2-1
c                  if(icc.eq.12)then !.and.iom.eq.8)then
c                     print*,'ifile,im,rmax(im,ifile),',
c     _                    'rmax(im,ifile+1)=',
c     _                    ifile,im,rmax(im,ifile),
c     _                    rmax(im,ifile+1)
c                  endif

                  xx=(rmax(im,ifile,icc,iom) 
     _                 -rmax(im,ifile+1,icc,iom))/drobs

c                  if(icc.eq.12)then !.and.iom.eq.8)then
c                     print*,'ifile,xx,pp=',ifile,xx,pp
c                  endif
                  pp=pp* sides* (1.0-erffun(abs(xx)))

c                  if(icc.eq.12)then !.and.iom.eq.8)then
c                     print*,'ifile,xx,pp=',ifile,xx,pp
c                  endif
               enddo
            enddo
            stat(iom,icc,1)= pp

            if(pp.gt.pp68)then
               do ifile=ifile1,ifile2
                  nrlss68=nrlss68+1
                  if(do_wt)then
                     wt=pp
                  else
                     wt=1.0
                  endif

                  rlss68=rlss68+ rmax(imax1,ifile,icc,iom)*wt
                  rlss68sig=rlss68sig+ 
     _                 rmax(imax1,ifile,icc,iom)*
     _                 rmax(imax1,ifile,icc,iom) *wt

                  omtot68=omtot68+ (om_0(iom)+cc_0(icc))*wt
                  omtot68sig=omtot68sig+ 
     _                 (om_0(iom)+cc_0(icc))*
     _                 (om_0(iom)+cc_0(icc)) *wt

                  wt68=wt68+wt
               enddo
            endif

            if(pp.gt.pp95)then
               do ifile=ifile1,ifile2
                  nrlss95=nrlss95+1
                  if(do_wt)then
                     wt=pp
                  else
                     wt=1.0
                  endif

                  rlss95=rlss95+ rmax(imax1,ifile,icc,iom)*wt
                  rlss95sig=rlss95sig+ 
     _                 rmax(imax1,ifile,icc,iom)*
     _                 rmax(imax1,ifile,icc,iom)*wt

                  omtot95=omtot95+ (om_0(iom)+cc_0(icc))*wt
                  omtot95sig=omtot95sig+ 
     _                 (om_0(iom)+cc_0(icc))*
     _                 (om_0(iom)+cc_0(icc)) *wt

                  wt95=wt95+wt
               enddo
            endif

         enddo
      enddo

      if(nrlss68.gt.1)then
c         rlss68=rlss68/real(nrlss68)
c         rlss68err=sqrt( rlss68sig/real(nrlss68)- rlss68*rlss68 )
         rlss68=rlss68/wt68
         rlss68err=sqrt( rlss68sig/wt68- rlss68*rlss68 )
         print*,'best rlss: rlss68, rlss68err=',rlss68,rlss68err

         omtot68=omtot68/wt68
         omtot68err=sqrt( omtot68sig/wt68- omtot68*omtot68 )
         print*,'best omtot: omtot68, omtot68err=',
     _        omtot68,omtot68err
      endif

      if(nrlss95.gt.1)then
c         rlss95=rlss95/real(nrlss95)
c         rlss95err=sqrt( rlss95sig/real(nrlss95)- rlss95*rlss95 )
         rlss95=rlss95/wt95
         rlss95err=sqrt( rlss95sig/wt95- rlss95*rlss95 )
         print*,'best rlss: rlss95, rlss95err=',rlss95,rlss95err

         omtot95=omtot95/wt95
         omtot95err=sqrt( omtot95sig/wt95- omtot95*omtot95 )
         print*,'best omtot: omtot95, omtot95err=',omtot95,omtot95err
      endif


c     ==== istat=2 -> hypothesis that local maxima occur at same positions ====

      xxmax=-9e9
      do icc=1,ncc
         do iom=1,nom
            stat(iom,icc, 2) = 0.0
            xx=0.0
            do ifile=ifile1,ifile2
               do ib=ioff2dF(imax1),ib_fin-1
                  uncert=
     _                 abs( corr(ib,icc,iom,3,ifile) ! normalise by uncert
     _                 -corr(ib,icc,iom,2,ifile) ) / 2.0
                  if(uncert.lt.tol)then
                     print*,'Warning: icc, iom, ifile, ib, uncert=',
     _                    icc, iom, ifile, ib, uncert
                     uncert=99.9
                  endif

                  xx=xx + abs(
     _                 corr(ib,icc,iom,1,ifile)     ! difference
     _                 -corr(ib+1,icc,iom,1,ifile) )  !/uncert

               enddo
            enddo

            if(donoisecorr) xx=xx/xnoise(iom,icc)

            stat(iom,icc, 2)= xx
            xxmax=max(xxmax,xx)
         enddo
      enddo

      do icc=1,ncc
         do iom=1,nom
            stat(iom,icc,2)= exp(log(stat(iom,icc,2) /xxmax)*1.0)
         enddo
      enddo

c     ==== istat=3 -> differences in \xi

      xxmax=-9e9
      do icc=1,ncc
         do iom=1,nom
            stat(iom,icc, 3) = 0.0
            xx=0.0
            do ifile=ifile1,ifile2-1
               do ib=ioff2dF(imax1),ib_fin-1
                  uu1=
     _                 abs( corr(ib,icc,iom,3,ifile) ! normalise by uncert
     _                 -corr(ib,icc,iom,2,ifile) ) / 2.0
                  uu2=
     _                 abs( corr(ib,icc,iom,3,ifile+1) ! normalise by uncert
     _                 -corr(ib,icc,iom,2,ifile+1) ) / 2.0
                  uncert=uu1*uu1+uu2*uu2

                  if(uncert.lt.tol*tol)then
                     print*,'Warning: icc, iom, ifile, ib, uncert=',
     _                    icc, iom, ifile, ib, uncert
                     uncert=99.9
                  else
                     uncert=sqrt(uncert)
                  endif

                  xx=xx + abs(
     _                 corr(ib,icc,iom,1,ifile)     ! difference
     _                 -corr(ib,icc,iom,1,ifile+1) )  /uncert


               enddo
            enddo
            stat(iom,icc, 3)= xx
            xxmax=max(xxmax,xx)
         enddo
      enddo

      do icc=1,ncc
         do iom=1,nom
            if(xxmax.gt.tol)then
               stat(iom,icc,3)= 
     _              exp(log(stat(iom,icc,3) /xxmax)*6.0)
            endif
         enddo
      enddo

      nstat=3

c     ==== stdout print of stat ====
      do istat=1,3
         print*,'istat=', istat 
         do icc=ncc,1,-1
            write(6,'(20i3)')
     _           ( int(stat(iom,icc,istat)*100.0-1.0),iom=1,nom )
         enddo
         print*,'--------------'
      enddo



c     ==== figures ====
      om1=om_0(1)
      om2=om_0(nom)
      cc1=cc_0(1)
      cc2=cc_0(ncc)

      if(nom.gt.1)then
         dom_di= (om_0(nom)-om_0(1))/real(nom-1)
      else
         dom_di=99.9
      endif
      tr(1)= om_0(1) - dom_di   !! om horiz cc vert
      tr(2)= dom_di

      trfine(1)=tr(1)
      trfine(2)=tr(2)/real(nfine)
      
      if(ncc.gt.1)then
         dcc_di= (cc_0(ncc)-cc_0(1))/real(ncc-1)
      else
         dcc_di=99.9
      endif
      tr(4)= cc_0(1) - dcc_di   !! om horiz cc vert
      tr(6)= dcc_di

      trfine(4)=tr(4)
      trfine(6)=tr(6)/real(nfine)

      tr(3)=0.0
      tr(5)=0.0

      trfine(3)=0.0
      trfine(5)=0.0
      

      do istat=1,nstat

      
      if(istat.eq.1)then
         ncont= 10
         do i=1,ncont-1
            cont(i)=  
     _           sides*(1.0-erffun( real(i-1) ))  
         enddo
         cont(1)=1.01
         cont(ncont)=-0.01
      else
         ncont= 20
         do i=1,ncont-1
            cont(i)=  1.0-real(i-1)*0.05
         enddo
         cont(1)=1.01
         cont(ncont)=-0.01
      endif

      print*,'(cont(i),i=1,ncont)=',(cont(i),i=1,ncont)

      if(nfine.gt.1)then
c         do istat=1,nstat
            do icc=1,ncc-1
               do iom=1,nom-1

                  do jfine=1,nfine
                     iccf=nfine*(icc-1)+jfine
                     
                     frac_cc=real(iccf-1)/real(nfine) 

                     do ifine=1,nfine
                        iomf=nfine*(iom-1)+ifine
                        frac_om=real(iomf-1)/real(nfine) 

                        statfine(iomf,iccf, istat)=
     _                       (1.0-frac_cc)*(1.0-frac_om)
     _                       *  stat(iom,icc, istat)
     _                       +frac_cc* (1.0-frac_om) 
     _                       *  stat(iom,icc+1, istat)
     _                       +(1.0-frac_cc)*frac_om 
     _                       *  stat(iom+1,icc, istat)
     _                       +frac_cc* frac_om 
     _                       *  stat(iom+1,icc+1, istat)
                     enddo
                  enddo !do jfine=1,nfine
               enddo ! do iom
            enddo ! do icc

            iccf=nfine*ncc
            iomf=nfine*nom
            statfine(iomf,iccf,istat)= stat(nom,ncc,istat)
c         enddo ! do istat=1,nstat

c         else
c            do icc=1,ncc
c               do iom=1,nom
c                  xx=stat(iom,icc,istat)
                  


         endif                  ! if(nfine.gt.1)



      nccfine= (ncc-1)*nfine + 1
      nomfine= (nom-1)*nfine + 1


         write(chistat,'(i2)')istat
         if(chistat(1:1).eq.' ')chistat(1:1)='0'

c         call pgqinf('VERSION',ch20,20)
c         print*,'!! pgplot VERSION=',ch20 ,' !!'

         call pgbegin(0,
c     _        '?',
     _        'stat'//chistat//'.ps/vps',
     _        1,1)

         call pgvsize(1.0,6.0,1.5,6.5)
c         call pgvsize(1.0,11.0,1.5,11.5)
         call pgscf(2)
         call pgsch(1.5)
         call pgslw(3)
         
         call pgwindow(om1,om2,cc1,cc2)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)

c     --- big labels ---
         call pgvsize(1.4,5.6,1.8,6.2)
         call pgqch(qch)
         call pgsch(qch*1.6)

         if(.not.(putquinlabel))then
            call pglabel('\\gW\\dm ','\\gW\\d\\gL',' ') ! Peebles 1993
         else
            call pglabel('\\gW\\dm ','w\\dQ',' ') ! Peebles 1993
         endif
         
         call pgvsize(1.0,6.0,1.5,6.5)
c         call pgvsize(1.0,11.0,1.5,11.5)
         call pgsch(qch)


         if(istat.eq.2)then
c     fg= noir, bg = blanc
            fg=-0.8 !1.0
            bg=0.9! 0.8!0.9! 0.425 !0.3

c            fg=0.4 !1.0
c            bg=0.95! 0.425 !0.3
            call pggray(stat(1,1,istat),mxc,mxc,
     _        1,nom,1,ncc,fg,bg,tr)
            call pgbox('bcnts',0.,0,'bcnts',0.,0)
         endif



c         if(.not.(dopgconf))then

            if(istat.eq.1)then

               fg=-1.0          !0.0
               bg=0.3
               ncont=4

               call pgqci(qci)
c     call pgsci(15)
               call pggray(stat(1,1,istat),mxc,mxc,
     _              1,nom,1,ncc,fg,bg,tr)
               call pgsci(qci)
               call pgbox('bcnts',0.,0,'bcnts',0.,0)
            endif

c            call pgcont(stat(1,1,istat),mxc,mxc,
c     _           1,nom,1,ncc,cont,ncont,tr)


c         else                   !      .not.(   if(.not.(dopgconf))then )
c     --- shift contours relative to RM00a ---
            icshift=1           ! 0 !  

            do ic1=1+icshift,ncont-1
               ic2=ic1+1
               print*,'icont,cont(ic1),cont(ic2)=',
     _              icont,cont(ic1),cont(ic2)
               
               if(ic1.eq.1+icshift)then
                  call pgsfs(3) 
               else
                  call pgsfs(4) 
               endif

               call pgqlw(qlw)
               if(ic1.le.2+icshift)then
                  call pgslw(1)
               elseif(ic1.eq.3)then
                  call pgslw(3)
               elseif(ic1.ge.4)then
                  call pgslw(5)
               endif
               
               if(istat.eq.1)then
                  if(nfine.eq.1)then
c     call pgshs(45.0,0.4,0.0)
c     call pgconf(stat(1,1,istat),
c     _                 mxc,mxc,
c     _                 1,nom,1,ncc,cont(ic2),cont(ic1),tr)

c     fg=cont(ic2)
c     bg=cont(ic1)
c     if(ic1.eq.1)then
c     call pgsci(0)
c     elseif(ic1.eq.2)then
c     call pgsci(15)
c     elseif(ic1.eq.3)then
c     call pgsci(14)
c     elseif(ic1.eq.4)then
c     call pgsci(13)
c     else
c     call pgsci(0)
c     endif
c     call pgsci(1)


c     call mypgconf(stat(1,1,istat),
c     _                 mxc,mxc,
c     _                 1,nom,1,ncc,cont(ic2),cont(ic1),tr)
c     _                 1,nom,1,ncc,cont(ncont),cont(ic1),tr)

                  else
                     call mypgconf(statfine(1,1,istat),
     _                    mxc*nfine,mxc*nfine,
     _                    1,nom*nfine,1,ncc*nfine,
     _                    cont(ic2),cont(ic1),trfine)
                  endif
               endif

               if(ic1.eq.1+icshift)then
                  call pgslw(qlw)
                  call pgcont(stat(1,1,istat),mxc,mxc,
     _                 1,nom,1,ncc,cont,ncont,tr)
               endif

               if(istat.le.2)then ! 99)then !
                  call pgqch(qch)
                  call pgsch(1.0)
                  call pgqlw(qlw)
                  call pgslw(2)
                  do ic=ic1,ic2
                     if(istat.eq.1)then
c                        call pgsch(0.5)
                        ch6='      '
                        write(ch6(1:5),'(f5.1)')(1.0-cont(ic))*100.0
                        ch6(6:6)='%'
c                        if(ic.eq.1)ch6='100%'
                        call pgconl(stat(1,1,istat),
     _                       mxc,mxc,
     _                       1,nom,1,ncc,cont(ic),tr, 
     _                       ch6,20,8)
                     else
                        write(ch4,'(f4.2)')cont(ic)
                        if(2*((ic+1)/2).eq.ic+1)then
c                        if(1+1.eq.2)then
                           call pgconl(stat(1,1,istat),
     _                          mxc,mxc,
     _                          1,nom,1,ncc,cont(ic),tr, 
     _                          ch4,20,6)!9)
                        endif
                     endif

                  enddo

                  call pgslw(qlw)
                  call pgsch(qch)
               endif
               
               call pgslw(3)
            enddo

c         endif                  !         if(.not.(dopgconf))then

            if(.not.(putquinlabel))then
               call pgslw(1)
               call pgmove(om1,1.0-om1) 
               call pgdraw(om2,1.0-om2)
            else
               call pgslw(1)
               call pgmove(om1,-1.0)
               call pgdraw(om2,-1.0)
            endif

            write(ch4,'(f4.0)')real(ioff2dF(imax1))*drobs+0.1

            if(putrminlabel)then
               call pgptxt(om1+0.5*(om2-om1),
     _              cc1+0.9*(cc2-cc1),
     _              0.0,0.0,
     _              'r\\dmin\\u='//ch4(1:3)//'h\\u-1\\dMpc')
            endif


         call pgend
         
      enddo ! istat =1,nstat

      end

