      program plotcorrnall
C     ---- based on plotcorrn, reads output from plates.f and
C     can either plot it as correlation functions and/or save statistics
C     based on these in  'plates.dat' format for analysis by plotdm.f 
C     ---- 

C     -- suggestions for improvements in clarity, etc. --
C     c_tr : reverse the ordering  icc,iom  to  iom,icc  for simplicity,
C     at the moment this is works correctly, but would be better to
C     make consistent.

      include 'mxcurve.dec'

      real*4   om_0(mxcurv),cc_0(mxcurv),H_0
c      real*4   pdWmax(mxcurv,mxcurv)

      integer*4 nbin(mxcurv,mxcurv)
      parameter(mxbins=2048 *8)

c     ---- for the 2pt spatial corrn function ----
      parameter(nthree=3)
      real*4        histog(mxbins,nthree)  ! 1=DD, 2=DR, 3=RR
      real*4        corrn(mxbins)
c      parameter(mxb_sm=300) !30)
      parameter(mxb_sm=1050)! 150)  !! old format pre-Sep 2000 !!
      parameter(mxsmoo=10) 
      real*4        corrnall(mxcurv,mxcurv,mxb_sm,mxboot)
      parameter(mxfile=2)! 18)! 6)

c     ---- five statistics:
c     1 mean, 
c     2 sigma, 
c     3 sderrm, 4 mean +sdem, 5 mean-sdem 
c     6 median
c     ---- 
      parameter(mxcstat=6, mxerr= mxfile + mxcstat) 
      real*4        corrnerr(mxb_sm,mxcurv,mxcurv,mxboot,mxerr)
      real*4        cmedian(mxfile+1,
     _     mxb_sm,mxcurv,mxcurv,mxboot)

      logical*4     do_wt
      real*4        wt0(mxfile),wt(mxfile),wt_tot

      real*4        c_tr(-(mxsmoo-1):mxb_sm,mxcurv,mxcurv,mxboot,
     _     mxcstat)

c      real*4        rbin(-(mxsmoo-1):mxbins)
      real*4        rbin(-(mxsmoo-1):mxb_sm)

      parameter(mxstat=20)
      real*4        stat(mxcurv,mxcurv,mxstat,mxboot)
      real*4        statcp(mxcurv,mxcurv) ! temporary copy
      real*4        statmax(mxstat)
      character*30  statlabel(mxstat)
      logical*4     do_sncontour(mxstat) ! choose S/N contour levels ?
      logical*4     do_prcontour(mxstat) ! choose erffun contour levels ?
      logical*4     do_sncut ! apply extra test for "S/N" to istat=4 ?

      logical*4     do_root2 ! stat: assume drlss(rbmax1) = drlss(rlss0) ?

      logical*4     maxlocal
      logical*4     plotfromzero
      logical*4     usemedian
      logical*4     putomlabel
      logical*4     putquinlabel
      logical*4     twodeclabel
      logical*4     biglabels
      logical*4     do_cp65     ! copy Rlss/2 contours to Rlss plot ?

      logical*4     newformat ! new format for reading corrnall*.dat ??
      logical*4     thirdformat   ! 3rd format for reading corrnall*.dat ??

      character*5   ch5a,ch5b
      character*64  ch_flnm, flnm_tmp
      integer*4     nchflnm

      character*64  flnmlis(mxfile)
      character*2   ch2
      character*4   ch4
      character*3   ch3, ch3a,ch3b,ch3c,  ch3d,ch3e
      character*256 flnm

      parameter(mxrlss=4)!3)
      real*4        xlab(mxrlss),ylab(mxrlss)
      real*4        sncut(mxrlss)
      logical*1     statcp2(mxcurv,mxcurv,mxboot,mxrlss) ! temporary copy

c      real*4        rbmaxlis(mxcurv,mxcurv,mxboot,mxrlss) ! temporary copy
c      real*4        cmaxlis(mxcurv,mxcurv,mxboot,mxrlss) ! temporary copy
      integer*4     imaxlis(mxrlss)

      logical*1     dummylog,dum,dum2,dum3
      logical*4     modif_y
      logical*4     modif_n
      logical*4     radcrit ! search peaks over smaller intervals? (rad noisy)

      logical*4     do_2dF
      logical*4     do_RLAGN ! Marecki et al. 2001
      logical*4     do_ssrms ! do rms instead of max uncertainty, for S/N ?
      logical*4     do_ssdrlss  ! do rms from 1-sigmadrlss limits ?
      logical*4     do_rdip ! 2dF: use dip instead of spike !

      parameter(ncubic=3)
      real*4        fact_cub(ncubic)    
      logical*4     do_cubic ! assume 3 bumps 1:sqrt(2):2 in length ??

      real*4        rzpt
      logical*4     do_zeropt   ! assume 3 bumps rzpt:rzpt+ip*rlss/2, ip=0,3

      logical*4     dowritec_sm ! write out smooth correlation fns

      logical*4     test, testcp
      logical*4     contourerror1 ! unusual error in pgconf !

      logical*4     RMBnoindivid ! plotting style of Roukema, Mamon, Bajtlik ?
      logical*4     RMBstyle ! plotting style of Roukema, Mamon, Bajtlik ?
      real*4        zscramprob
      integer*4     iomprint

c      data test/.true./ !.false./ !
      common /testcomm/ test  ! evaluated in plates MAIN programme

      data contourerror1/.true./ ! unusual error in pgconf !

      data RMBnoindivid/.true./     !.false./! 
      data RMBstyle/.true./ !
      data zscramprob/50.0/
      data iomprint/-99 /!19/ !14/! 19/!6/! 

c     ---- contour plotting variables ----
      parameter(mxcont=20)
      real*4   cont(mxcont),tr(6)

c      data ch_flnm/ '1_SGP'/
      data ch_flnm/ '1'/
c      data ch_flnm/ '0_21x21'/
      data nchflnm/1/

      data flnmlis/
c     _     12345678901234567890
c     ---- small (nom=1 =ncc, nctrl=2)
c     bootstrap ich=2,3 and uniform ich=4,5 tests at (0.4,0.6),
c     for the 4 subsamples ----
c     _     '0.dat',
c     _     '0.dat',
c     _     '1boot3.dat',
c     _     '1boot4.dat',
c     _     '1boot1.dat',
c     _     '1boot2.dat'
c     ---- the four subsamples (0.4,0.7), nctrl=20 ----
c     newformat=.true.
c     _     '1boot_0.40.7_3.dat',
c     _     '1boot_0.40.7_4.dat',
c     _     '1boot_0.40.7_1.dat',
c     _     '1boot_0.40.7_2.dat'
c     newformat=.true.
c     _     '1bootC_0.40.6_3.dat',
c     _     '1bootC_0.40.6_4.dat',
c     _     '1bootC_0.40.6_1.dat',
c     _     '1bootC_0.40.6_2.dat'
c
c     _     '_2dF_200boot__7.dat',
c     _     '_2dF_200boot__9.dat',
c
c     !! most of below require     newformat=.false. !!
c     
c     ---- the four subsamples, for discrete z's ----
c     _     '_1.82.1subsIovD.dat',
c     _     '_2.12.4subsIovD.dat',
c     _     '_1.82.1subsIovA.dat',
c     _     '_2.12.4subsIovA.dat',
c     ---- the declination subset (doubled for algorithmic simplicity) ---
c     _     '_1.82.4tab3IovD.dat',
c     _     '_1.82.4tab3IovD.dat',
c     _     '_1.82.4tab3IovA.dat',
c     newformat=.true.
c     _     '_1.82.4contIovD.dat',
c     _     '_1.82.4contIovD.dat',
c     _     '_1.82.4contIovA.dat',
c     _     '_1.82.4contIovA.dat'
c     ---- the four subsamples, including dediscretisation of z's,
c     but with 2 ra subdivisions instead of just one ----
c     _     '_1.82.1_2radiv_IovD.dat',
c     _     '_2.12.4_2radiv_IovD.dat',
c     _     '_1.82.1_2radiv_IovA.dat',
c     _     '_2.12.4_2radiv_IovA.dat'
c     ---- the four subsamples, including dediscretisation of z's ----
c     newformat=.false.
c     _     '_1.82.1_smIov_IovD.dat',
c     _     '_2.12.4_smIov_IovD.dat',
c     _     '_1.82.1_smIov_IovA.dat',
c     _     '_2.12.4_smIov_IovA.dat',
c     
c     _     '_2.12.4_sm0.15_IovD.dat',
c     _     '_1.82.1_sm0.15_IovD.dat'
c     _     '_2.12.4_sm0.15_IovA.dat',
c     _     '_1.82.1_sm0.15_IovA.dat'
c     _     '_1.82.4tab3IovA_rad.dat',
c     _     '_1.82.4tab3IovA_tan.dat',
c     _     '_1.82.4tab3IovD_rad.dat',
c     _     '_1.82.4tab3IovD_tan.dat'
c     newformat=.true.
c     _     '_1.82.4tan1.732IovD20.dat',
c     _     '_1.82.4tan1.732IovA20.dat',
c     _     '_1.82.4rad1.732IovD20.dat',
c     _     '_1.82.4rad1.732IovA20.dat',
c     _     '_1.82.4tan1.732IovD20.dat',
c     _     '_1.82.4tan1.732IovA20.dat'
c     
c     newformat=.true.  thirdformat=.true.
c     _     '_1.82.1IovA_150b.dat',
c     _     '_2.12.4IovA_150b.dat',
c     _     '_1.82.1IovD_150b.dat',
c     _     '_2.12.4IovD_150b.dat',
c     
c     _     '_2.12.4IovA_150b.dat',
c     _     '_2.12.4IovA_150b.dat'
c
c
c     ------ following are for 2dF, starting 19/07/00 ------
c     _     '_2dF_10cub__3.dat',
c     _     '_2dF_10cub__7.dat',
c     _     '_2dF_10cub__8.dat',
c     _     '_2dF_10cub_10.dat'
c     _     '_2dF_20cubLS93__3.dat', 
c     _     '_2dF_20cubLS93__7.dat',
c     _     '_2dF_10cub__8.dat',
c     _     '_2dF_20cubLS93__8.dat',
c     _     '_2dF_20cubLS93_10.dat'
c     _     '_2dF_20cub__7.dat',
c     _     '_2dF_20cub__8.dat',
c     _     '_2dF_20cub_10.dat',
c     _     '_2dF_20cub__9.dat' !! should replace by "3"
c     ------- following are for 2dF N=11755 catalogue ----
c     --- old versions done at IAP ---
c     _     '_2dF_12k20__3.dat',
c     _     '_2dF_12k20__4.dat',
c     _     '_2dF_12k20__6.dat',
c     _     '_2dF_12k20__2.dat',
c     _     '_2dF_12k20__5.dat',
c     _     '_2dF_12k20__1.dat'
c     _     'n2dF12k_6_0.82.1.dat',
c     _     'n2dF12k_3_0.82.1.dat',
c     _     'n2dF12k_4_0.82.1.dat',
c     _     'n2dF12k_6_0.82.1.dat',
c     _     'n2dF12k_6_0.82.1.dat',
c     _     'n2dF12k_6_0.82.1.dat'
c     _     'n1.8z2.4_10K_8.dat',
c     _     'n1.8z2.4_10K_1.dat',
c     _     'n1.8z2.4_10K_6.dat',
c     _     'n0.5z1.0_10K_8.dat',
c     _     'n0.5z1.0_10K_1.dat',
c     _     'n0.5z1.0_10K_6.dat',
c     _     'n0.6z1.4_10K_8.dat',
c     _     'n1.4z2.2_10K_8.dat',
c     _     'n0.6z1.4_10K_1.dat',
c     _     'n0.6z1.4_10K_6.dat',
c     _     'n1.4z2.2_10K_1.dat',
c     _     'n1.4z2.2_10K_6.dat',
c     _     'n0.6z1.4_10K_7.dat',
c     _     'n1.4z2.2_10K_7.dat',
c     _     'n1.4z2.2_10K_2.dat',
c     _     'n1.4z2.2_10K_3.dat',
c     _     'n1.4z2.2_10K_4.dat',
c     _     'n1.4z2.2_10K_5.dat',
c     _     'n0.6z1.4_10K_2.dat',
c     _     'n0.6z1.4_10K_3.dat',
c     _     'n0.6z1.4_10K_4.dat',
c     _     'n0.6z1.4_10K_5.dat'
c     _     'nall_10K_8.dat',
c     _     'nall_10K_1.dat',
c     _     'nall_10K_6.dat',
c     _     'nall_10K_7.dat',
c     _     'nall_10K_5.dat',
c     _     'nall_10K_2.dat',
c     _     'nall_10K_3.dat',
c     _     'nall_10K_4.dat'
c     ---- RLAGNs ----
     _     'nalls.dat',
     _     'nalls.dat'
c     ---- the 5K catalogue (i.e. 80% minimum coverage) ----
c     _     'n0.6z2.2_5K_8.dat',
c     _     'n0.6z2.2_5K_6.dat',
c     _     'n0.6z2.2_5K_7.dat',
c     _     'n0.6z2.2_5K_4.dat',
c     _     'n0.6z2.2_5K_1.dat',
c     _     'n0.6z2.2_5K_5.dat'
c     _     'n1.6z2.2_5K_8.dat',
c     _     'n1.6z2.2_5K_6.dat',
c     _     'n1.6z2.2_5K_7.dat',
c     _     'n1.6z2.2_5K_4.dat',
c     _     'n1.6z2.2_5K_1.dat',
c     _     'n1.6z2.2_5K_5.dat'  ,
c     _     'n1.1z1.6_5K_8.dat',
c     _     'n1.1z1.6_5K_6.dat',
c     _     'n1.1z1.6_5K_7.dat',
c     _     'n1.1z1.6_5K_4.dat',
c     _     'n1.1z1.6_5K_1.dat',
c     _     'n1.1z1.6_5K_5.dat'  ,
c     _     'n0.6z1.1_5K_8.dat',
c     _     'n0.6z1.1_5K_6.dat',
c     _     'n0.6z1.1_5K_7.dat',
c     _     'n0.6z1.1_5K_4.dat',
c     _     'n0.6z1.1_5K_1.dat',
c     _     'n0.6z1.1_5K_5.dat'   
     _     /
      data wt0/
     _     535.0,
c     _     681.0,
c     _     364.0,
c     _     323.0,
c     _     281.0,
c     _     194.0,
c     _     535.0,
c     _     681.0,
c     _     364.0,
c     _     323.0,
c     _     281.0,
c     _     194.0,
c     _     535.0,
c     _     681.0,
c     _     364.0,
c     _     323.0,
c     _     281.0,
     _     194.0/


      data putomlabel /.true./ !.false./!
      data putquinlabel /.false./!.true./  !
      data twodeclabel /.true./  !.false./ !
      data biglabels /.true./  !.false./!
      data do_cp65 /.false./!.true./  !

c     --- if foll. set to .true. and nrlss=3, causes out of bounds error ---
      data plotfromzero /.true. /!.false. / !

c     ---- for *smIov* ---
      data xlab/0.5,0.62,0.27, 0.0/
      data ylab/0.9,0.75,0.35, 0.0/

c     ---- for  tab3IovD  ---
c      data xlab/0.44,0.44,0.27, 0.0/
c      data ylab/0.57,0.57,0.35, 0.0/

c     ---- for  rad...20.dat  ---
c      data xlab/0.44,0.6,0.27, 0.0/
c      data ylab/0.57,0.6,0.35, 0.0/
c     ---- for  tan...20.dat  ---
c      data xlab/0.44,0.3,0.27, 0.0/
c      data ylab/0.57,0.1,0.35, 0.0/


      test=.true. !.false. !

      do_2dF=.true.             !.false. !
      do_RLAGN=.true.             !.false. !
      do_ssrms=.true.             !.false. !
      do_ssdrlss=.false. !.true.        !
      do_rdip=.false. !.true.             !

      do_cubic=.false. !.true.             !
      do_zeropt=.false.       !.true.             !
      if(do_cubic.and.do_zeropt)stop 'incompatible: cubic+zeropt'

      fact_cub(1)=1.0
      fact_cub(2)=sqrt(2.0)
      fact_cub(3)=2.0


      dowritec_sm=.true.             !.false.         !

      nchf2=30! 24! 19! 19
      nflnm=2!4! 3 !16! 4 !18! 6! 8!
      usemedian= .false.!.true. !
      do_wt= .false.        !.true. !


      do_sncut=.true. !.false.!
c      sncut0=1.0 ! S/N cutoff 
      newformat= .true. !.false.!
      thirdformat= .false.!.true.     !
      radcrit=.false. !.true.!  ! different criterion for rad/tan tests ?
      do_root2=.true. !.false.!

      nrlss=1!2! 3!
      if(nrlss.gt.mxrlss)print*,'WARNING: nrlss, mxrlss=',
     _     nrlss, mxrlss
      do irlss=1,nrlss

c     -- defaults for 'old' format --
         i1_sm=5
         delta=10.0


c     ----------------------------------------------------------------------
c     26-10, 20 : 130 +- 50 h^-1 Mpc
c     26-6, 12 : 130 +- 30 h^-1 Mpc
c     52-10, 20 : 260 +- 50 h^-1 Mpc
c     30-10, 20 : 150 +- 50 h^-1 Mpc
c     40-20, 40 : 200 +- 100 h^-1 Mpc
c     14-6, 12 : 70 +- 30 h^-1 Mpc
c     31-15, 30 : 80 -> 230 h^-1 Mpc
c     
c     ioffset=2, nb=58, plotfromzero=.true. : plot full range

         ioffset=2! 26-6             ! 31-15 !2              !  52-6! 50-10          !48-8! 34-26 !40-20!40-24 !  52-10!52-6 !14-6 ! 26-10!
c     i1_sm= i1_sm +ioffset
c     nb=nb_sm -ioffset
         nb=68! 52! 40! 16! 58! 12 !20                  !12 !  30 !58                  ! 

c         nb=148 ! for the "150b" set
         ismoo=  3 !2               !1!0! 
        ioffset=max(ioffset,ismoo) ! added BFR 17/05/2001
         nb=70-ioffset  ! added BFR 22/05/2001
         nb=1000-ioffset          ! added BFR 24/09/2001

c     ---- 2dF parameters ----
         ioff2dF= 28! 40! 8 !4!
c     ---- How many regular peaks are searched for ??? ----
         npksearch=1! 3! 2! 4   ! 
         if(do_cubic)npksearch=3
         if(do_zeropt.and.npksearch.le.1)stop 'npksearch too small'

         hh0= 0.01 !0.025 !0.01!
         dhh=  0.005 !0.0025! 0.005!

         rlss=130.0             ! *2.0        !/2.0 !!
         drlss=10.0             /2.0 ! 5.0 !!!*2.0        !

c     ---- for RMB 2001 ---
         if(do_2dF)then
            rlss= 244.0
            drlss= 17.0! 5.0 !
         endif

c     ---- for Marecki et al. 2001 ---
         if(do_RLAGN)then
            rlss= 4000.0
            drlss= 200.0
         endif


         rdip=65.0
         drdip=5.0

         if(do_root2)drlss=sqrt(2.0)*drlss

         if(nrlss.gt.1)then
            rlss0=130.0         !120.0! 
            drlss0=10.0         !/2.0
            if(do_root2)drlss0=sqrt(2.0)*drlss0

            if(irlss.eq.1)then
               if(.not.(radcrit))then
                  ioffset=14-6
                  nb=12
                  rlss= rlss0/2.0
                  drlss=drlss0/2.0
               else
                  ioffset=13-3  !24-16 !34-26 !
                  nb=6          !32! 52 !
                  rlss= rlss0/2.0
                  drlss=drlss0/2.0
               endif
            elseif(irlss.eq.2)then
               if(.not.(radcrit))then
                  ioffset=26-6 !40-20
                  nb=12 !40
                  rlss= rlss0
                  drlss=drlss0
               else
                  ioffset=40-20 ! 30-10! 26-6 !
                  nb=40         !20 !12 !
                  rlss= rlss0
                  drlss=drlss0
               endif
            elseif(irlss.eq.3)then
               ioffset=50-10
               nb=20
               rlss= rlss0*2.0
               drlss=drlss0*2.0
            endif
         endif


c     --- foll. was necessary for 65.0h^-1 Mpc because of background 
c     before the z's were de-discretised and mean-ed! ---
         maxlocal=.false.       !.true. !

         print*,'i1_sm,nb, ismoo=',i1_sm,nb, ismoo
         if(ismoo.gt.mxsmoo)print*,'ERROR ismoo, mxsmoo=',
     _        ismoo,mxsmoo

c     ----------------------------------------------------------------------


c     rlss=130.0!/2.0 !*2.0
c     drlss=10.0 !/2.0 ! 5.0 !
c     --- foll. necessary for 65.0h^-1 Mpc because of background ! ---
c     maxlocal=.true. !.false. !
c     nctrl=10

         do iflnm=1,nflnm
c     open(1,file='corrnall'//ch_flnm(1:nchflnm)//'.dat',
c     open(1,file='corrnall'//flnmlis(iflnm)(1:nchf2)//'.dat',


            if(.not.(do_2dF))then
               flnm_tmp='corrnall'//flnmlis(iflnm)(1:nchf2)
            else
               flnm_tmp='corr'//flnmlis(iflnm)(1:nchf2)
            endif

c            open(1,file='corrnall'//flnmlis(iflnm)(1:nchf2),
            open(1,file=flnm_tmp,
     _           access='sequential',
     _           form='unformatted',status='old')


            read(1)nom,ncc,(om_0(i),i=1,nom),
     _           (cc_0(i),i=1,ncc)
            read(1)i1_sm,nb_sm,delta ! added 29/05/00

            print*,'iflnm etc=',iflnm,nom,ncc,om_0(1),om_0(nom),
     _           cc_0(1),cc_0(ncc),i1_sm,nb_sm,delta

            if(newformat)then
               read(1)nb_sm,((((corrnall(icc,iom,ib,ich),
     _              icc=1,ncc),iom=1,nom),ib=1,nb_sm),
     _              ich=1,mxboot)
            else
               read(1)nb_sm,corrnall
            endif
            if(thirdformat)then
               read(1)( (nbin(icc,iom),icc=1,ncc), iom=1,nom )
c               nb_sm=nbin(ncc,1) !! depends on ordering of om_0,cc_0 !! 
            endif

            print*,'read in: nb_sm=',nb_sm
            close(1)
            
c     ---- check that all files are for identical parameters ---
            if( (iflnm.gt.1.and.
     _           (nom_old.ne.nom .or.
     _           ncc_old.ne.ncc .or.
     _           om_0_n_old.ne.om_0(nom) .or.
     _           cc_0_n_old.ne.cc_0(nom) .or.
     _           i1_sm_old.ne.i1_sm .or.
     _           nb_sm_old.ne.nb_sm .or.
     _           delta_old.ne.delta))
     _           )then
               print*,'iflnm=',iflnm
               print*,'WARNING: nom_old etc = ',
     _              nom_old,nom, ncc_old,ncc, om_0_n_old,om_0(nom),
     _              cc_0_n_old,cc_0(nom), i1_sm_old,i1_sm, 
     _              nb_sm_old,nb_sm,delta_old,delta
            endif

            nom_old=nom
            ncc_old=ncc
            om_0_n_old=om_0(nom)
            cc_0_n_old=cc_0(nom)
            i1_sm_old=i1_sm
            nb_sm_old=nb_sm
            delta_old=delta

c     ---- copy to corrnerr ! and cumulate statistics---
            do icheck=1,1 +2*nctrl
               do ib=1,nb_sm
                  do icc=1,ncc
                     do iom=1,nom
                        xx= corrnall(icc,iom,ib,icheck) 
                        corrnerr(ib,iom,icc,icheck,iflnm) = xx
                     enddo
                  enddo
               enddo
            enddo

            modif_y=.true.

            do icheck=1,1 +2*nctrl
               do icc=1,ncc
                  do iom=1,nom

c     ---- use the smoothing function and ignore the extrema: ----
                     testcp=test  ! store test and temporarily reset
                     test=.false.
                     call findmin(nb_sm,
     _                    corrnerr(1,iom,icc,icheck,iflnm), ismoo, 
     _                    imin1,imax2,imax3,imaxfin, modif_y)
                     test=testcp ! restore test

                     do ib=1,nb_sm
                        xx= corrnerr(ib,iom,icc,icheck,iflnm) 
                        if(.not.(do_wt))then
                           wt(iflnm)= 1.0
                        else
                           wt(iflnm)= 1.0/
     _                          (wt0(iflnm)*(wt0(iflnm)-1.0))
                        endif

                        if(iflnm.eq.1)then
                           corrnerr(ib,iom,icc,icheck,nflnm+1)= xx
     _                          * wt(iflnm)
                           corrnerr(ib,iom,icc,icheck,nflnm+2)=
     _                          xx*xx
     _                          * wt(iflnm)
                        else
                           corrnerr(ib,iom,icc,icheck,nflnm+1) = 
     _                          corrnerr(ib,iom,icc,icheck,nflnm+1)
     _                          + xx
     _                          * wt(iflnm)
                           corrnerr(ib,iom,icc,icheck,nflnm+2) = 
     _                          corrnerr(ib,iom,icc,icheck,nflnm+2)
     _                          + xx*xx
     _                          * wt(iflnm)
                        endif
                        cmedian(iflnm,ib,iom,icc,icheck) = xx
                     enddo

                  enddo
               enddo
            enddo

            print*,'Have read '//
     _           'corrnall'//flnmlis(iflnm)(1:nchf2)//'.dat and '//
     _           'cumulated some stats.'

         enddo                  ! of iflnm=1,nflnm
         
c         stop 'stop A'

c     --------------
         i1_sm= i1_sm +ioffset  ! not used ? !
c     nb=nb_sm -ioffset
c     --------------

         tol=1e-8
         xnflnm=1.0/real(nflnm)
         if(do_wt)then
            wt_tot=0.0
            wt_max=wt(1)
            do iflnm=1,nflnm
               wt_tot=wt_tot+wt(iflnm)
               wt_max=max(wt_max,wt(iflnm))
            enddo
            if(wt_tot.lt.tol)print*,'ERROR  wt_tot = ',wt_tot
ccc            xnflnm=xnflnm/wt_tot !!!! wrong wrong !!
            xnflnm=1.0/wt_tot
         endif

         if(nflnm.gt.1)then
            sdcorrect= sqrt(real(nflnm)/real(nflnm-1))
         else
            sdcorrect= 10.0
         endif
         sqnflnm=1.0/sqrt(real(nflnm))

         if(do_wt)then
            print*,'TESTTESTTEST for std err in the mean' ! test only 
            sqnflnm= 1.0/sqrt( wt_tot/wt_max )
            print*,'sqnflnm=', sqnflnm
         endif


         do icheck=1,1 +2*nctrl
            do ib=1,nb_sm
               do icc=1,ncc
                  do iom=1,nom
                     if(nflnm.gt.1)then
c     if(nflnm.ge.1)then
c     ---- mean = sum / num ----
                        xmean = corrnerr(ib,iom,icc,icheck,nflnm+1)
     _                       *xnflnm
                        corrnerr(ib,iom,icc,icheck,nflnm+1) = xmean

c     ---- sd = sqrt[ sum(squares) / num  - mean^2 ] *(sqrt(num/(num-1))) ----

                        yy= corrnerr(ib,iom,icc,icheck,nflnm+2)
     _                       *xnflnm - xmean*xmean

                        if(yy.le.tol)then
                           if(.not.(nflnm.eq.2))then
c     _                          flnmlis(1).eq.flnmlis(2)))then
                              print*,'WARNING: ',
     _                             'yy, xmean=',
     _                             yy, xmean
                           endif
                           corrnerr(ib,iom,icc,icheck,nflnm+2) 
     _                          = 0.99 !!hardwired
                        else
                           corrnerr(ib,iom,icc,icheck,nflnm+2) 
     _                          = sqrt(yy)
     _                          *sdcorrect
                        endif

c     csq=sqrt(csq/real(isq-1))
                     else
                        print*,'WARNING: only 1 (or less) file(s) !!!'
                     endif

c     ---- sd error in the mean, error bars ----
                     xx= corrnerr(ib,iom,icc,icheck,nflnm+2) 
     _                    *sqnflnm
                     corrnerr(ib,iom,icc,icheck,nflnm+3) = xx
                     corrnerr(ib,iom,icc,icheck,nflnm+4) = 
     _                    xmean +xx
                     corrnerr(ib,iom,icc,icheck,nflnm+5) = 
     _                    xmean -xx
                     
c     ---- median ----
                     call sort(nflnm, 
     _                    cmedian(1,ib,iom,icc,icheck))
c                     if(nflnm.eq.2)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       ( cmedian(1,ib,iom,icc,icheck)
c     _                       + cmedian(2,ib,iom,icc,icheck) )/2.0
c                     elseif(nflnm.eq.4)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       ( cmedian(2,ib,iom,icc,icheck)
c     _                       + cmedian(3,ib,iom,icc,icheck) )/2.0
c                     elseif(nflnm.eq.3)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       cmedian(2,ib,iom,icc,icheck)
c                     elseif(nflnm.eq.6)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       ( cmedian(3,ib,iom,icc,icheck)
c     _                       + cmedian(4,ib,iom,icc,icheck) )/2.0
c                     elseif(nflnm.eq.5)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       cmedian(3,ib,iom,icc,icheck)
c                     elseif(nflnm.eq.8)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       ( cmedian(4,ib,iom,icc,icheck)
c     _                       + cmedian(5,ib,iom,icc,icheck) )/2.0
c                     elseif(nflnm.eq.7)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       cmedian(4,ib,iom,icc,icheck)
c                     elseif(nflnm.eq.1)then
c                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
c     _                       cmedian(1,ib,iom,icc,icheck)
                     if( (nflnm/2)*2.eq.nflnm)then
                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
     _                       ( cmedian(nflnm/2,ib,iom,icc,icheck)
     _                       + cmedian(nflnm/2+1,ib,iom,icc,icheck) 
     _                       )/2.0
                     elseif( ((nflnm+1)/2)*2.eq.nflnm+1)then
                        corrnerr(ib,iom,icc,icheck,nflnm+6) = 
     _                       cmedian((nflnm+1)/2,ib,iom,icc,icheck)
                     else
                        print*,'WARNING: median not coded for ',
     _                       'nflnm=',nflnm
                     endif

                  enddo
               enddo
            enddo
         enddo


c     c     --- test only, by putting mean function into corrnall ---
c     do icheck=1,1 +2*nctrl
c     do ib=1,nb_sm
c     do icc=1,ncc
c     do iom=1,nom
c     c_tr??(iom,icc,ib,icheck,1) =
c     _                 corrnerr(ib,iom,icc,icheck,nflnm+1) 
c     enddo
c     enddo
c     enddo
c     enddo
         


c     print*,'Have read '//
c     _     'corrnall'//ch_flnm(1:nchflnm)//'.dat'


         print*,'nom,ncc,om_0(1),cc_0(1),',
     _        'nb_sm='
         print*,nom,ncc,om_0(1),cc_0(1),
     _        nb_sm
         print*,'nctrl,i1_sm,delta=',nctrl,i1_sm,delta

         print*,'(corrnall(1,1,ib,1),ib=1,30)='
         print*,(corrnall(1,1,ib,1),ib=1,30)

c     ----------------------------------------------------------------------


         ymax=-9e9
         ymin=9e9
         do icheck=1,1 +2*nctrl
            do icc=1,ncc
               do iom=1,nom
c     ---- smoothing is done to one smoothing length (sigma) oustide
c     of the interval being studied ---

                  do ib=max(-(mxsmoo-1),1-ismoo),min(nb+ismoo,nb_sm)
c     do ib=1,nb

c     rbin(ib)= (real(i1_sm-1+ib)-0.5)*delta
c     xx= corrnall(icc,iom, ib, icheck )

                     rbin(ib)= (real(ib+ioffset)-0.5)*delta
c     xx= corrnall(icc,iom, ib+ioffset, icheck )
                     xx= corrnerr(ib+ioffset, 
     _                    iom,icc, icheck, nflnm+1)
                     xx3= corrnerr(ib+ioffset, 
     _                    iom,icc, icheck, nflnm+3)
                     xx4= corrnerr(ib+ioffset, 
     _                    iom,icc, icheck, nflnm+4)
                     xx5= corrnerr(ib+ioffset, 
     _                    iom,icc, icheck, nflnm+5)
                     xx6= corrnerr(ib+ioffset, 
     _                    iom,icc, icheck, nflnm+6)

                     if(usemedian)then
                        c_tr(ib,icc,iom,icheck,1)= xx6 ! mean
                     else
                        c_tr(ib,icc,iom,icheck,1)= xx ! mean
                     endif
                     c_tr(ib,icc,iom,icheck,3)= xx3 ! sd.err.m.
                     c_tr(ib,icc,iom,icheck,4)= xx4 ! mean + sderrm
                     c_tr(ib,icc,iom,icheck,5)= xx5 ! mean - sderrm
                     ymax=max(ymax,xx)
                     if(xx.gt.-99.0)ymin=min(ymin,xx)

                     if(icc.eq.1.and.iom.eq.1 .and.2+2.eq.5 !! test only !!
     _                    .and.ib.ge.min(nb+ismoo,nb_sm)-10)then
                        print*,'max(-(mxsmoo-1),1-ismoo),'//
     _                       'min(nb+ismoo,nb_sm)=',
     _                       max(-(mxsmoo-1),1-ismoo),
     _                       min(nb+ismoo,nb_sm)
                        print*,'ib,ib+ioffset=',ib,ib+ioffset
                        print*,'xx,xx4,xx5=',xx,xx4,xx5
                        print*,'rbin(ib),c_tr(ib,icc,iom,icheck,1)='
                        print*,rbin(ib),c_tr(ib,icc,iom,icheck,1)
                     endif

                  enddo
               enddo
c     print*,'test : icheck, icc,iom,ib=',
c     _                 icheck, icc,iom,ib
            enddo
            print*,'end of evaluating rbin, c_tr loop.'
            
c     --- apply smoothing ---

            snmax=-9e9
            cmax1mx=-9e9
            cmin1mn=+9e9 ! added 03/05/01


            if(nrlss.gt.1)then
               nstat=14
            else
               nstat=13
            endif
            if(do_2dF)nstat=18

            do istat=1,nstat
               statmax(istat)=-9e9
               do_prcontour(istat)=.false.
            enddo


            do icc=1,ncc
               do iom=1,nom
c     print*,'before findmin'
c     call findmin(nb+2*ismoo, 
c     _              c_tr(1-ismoo,icc,iom,icheck,1), ismoo, 
c     call findmin(nb,
c     _              c_tr(1,icc,iom,icheck,1), ismoo, 
c     _              imin1,imax2,imax3,imaxfin, modif_y)

c     print*,'after findmin'

                  xnull=-99.9

                  cmax1=-9e9
                  ibmax1=-99
                  rbmax1= -99.9 !xnull
                  cmax2=-9e9

c     ---- added 03/05/01
                  cmin1= 9e9
                  ibmin1= 99
                  rbmin1= -99.9 !xnull
                  cmin2= 9e9


                  r1=rbin(1)    !100.0! 
                  r2=rbin(nb)   !300.0! 
                  ismoo2= ismoo ! 1!


c     --- find peak, it's frequency and value ---
c     print*,'will find peak, frequency, and value '
                  do ib=1,nb
                     if(rbin(ib).gt.r1.and.rbin(ib).lt.r2)then
c     if(rbin(ib).ge.r1.and.rbin(ib).le.r2)then
                        
                        xmean=0.0
                        im=0
                        if(maxlocal)then
                           do ic=max(-(mxsmoo-1),ib-3*ismoo), 
     _                          min(ib+3*ismoo,nb_sm)
                              if(abs(ic-ib).gt.ismoo2)then
                                 xmean=xmean + 
     _                                c_tr(ic,icc,iom,icheck,1)
                                 im=im+1
                              endif
                           enddo
                           if(im.lt.1)then
                              print*,'WARNING: im=',im
                              xmean=99.9
                           else
                              xmean=xmean/real(im)
                           endif
                           xtest=c_tr(ib,icc,iom,icheck,1) - xmean
                        else
                           xtest=c_tr(ib,icc,iom,icheck,1)
                        endif

                        if(xtest.gt.cmax1)then
                           ibmax1=ib
                           rbmax1=rbin(ib)
                           cmax1=c_tr(ib,icc,iom,icheck,1)
                           if(ib.gt.1.and.ib.lt.nb)then
                              cmax1sm= ( c_tr(ib,icc,iom,icheck,1)
     _                             +c_tr(ib-1,icc,iom,icheck,1)
     _                             +c_tr(ib+1,icc,iom,icheck,1) )
     _                             /3.0
                           else
                              cmax1sm=cmax1
                           endif
                        endif

c     --- added 03/05/01
                        if(xtest.lt.cmin1)then
                           ibmin1=ib
                           rbmin1=rbin(ib)
                           cmin1=c_tr(ib,icc,iom,icheck,1)
                           if(ib.gt.1.and.ib.lt.nb)then
                              cmin1sm= ( c_tr(ib,icc,iom,icheck,1)
     _                             +c_tr(ib-1,icc,iom,icheck,1)
     _                             +c_tr(ib+1,icc,iom,icheck,1) )
     _                             /3.0
                           else
                              cmin1sm=cmin1
                           endif
                        endif


                     endif
                  enddo
c     print*,'found peak, frequency, and value '
                  
c     --- store the  r  and xi  at the max --- (added 19/07/00) 
c                  rbmaxlis(iom,icc,icheck,irlss)=rbmax1
c                  cmaxlis(iom,icc,icheck,irlss)=cmax1
                  if(do_2dF)then
c                     ioff2dF= 8
                     testcp=test  ! store test and temporarily reset
                     test=.false.
                     izero=0           ! curve is already smoothed !
c                     izero=2  
c                     izero=3  
                     modif_n=.false.

                     call fimax4(nb_sm-ioff2dF, 
c                     call fimax4_2(nb_sm-ioff2dF, 
     _                    c_tr(ioff2dF,icc,iom,icheck,1), 
c     _                    nb_sm,   ! fimax4_2
c     _                    c_tr(1,icc,iom,icheck,1), ! fimax4_2
     _                    izero,
     _                    imax1,imax2,imax3,imax4, modif_n)

                     test=testcp ! restore test
                  endif

                  imaxlis(1)=imax1+ioff2dF-1
                  imaxlis(2)=imax2+ioff2dF-1
                  imaxlis(3)=imax3+ioff2dF-1
                  imaxlis(4)=imax4+ioff2dF-1

                  if(1+1.eq.3.and.istat.ge.15
     _                 .and.iom.eq.1.and.icc.eq.10)then
                     print*,'istat=15 imaxlis etc', 
     _                    iom,icc,imax1,imax2,imax3,imax4,ioff2dF
                     print*,'istat=15 imaxlis etc', 
     _                    iom,icc,
     _                    rbin(imaxlis(1)),
     _                    rbin(imaxlis(2)),
     _                    rbin(imaxlis(3)),
     _                    rbin(imaxlis(4))
                  endif

                     
c                  if(test)print*,'istat=15 imaxlis etc', 
c     _                 iom,icc,imax1,imax2,imax3,imax4,ioff2dF

                  rr15= rlss/2.0  ! istat=15: use assumed value of rlss
                  drr15= drlss /2.0
                  if(do_cubic)then
                     rr15=rlss/sqrt(2.0)
                     drr15=drlss/sqrt(2.0)
                  elseif(do_zeropt)then
                     rzpt= rbin(imaxlis(1))
                     rr15= rlss - rzpt
                  endif

c                  rr16= rbin(imaxlis(1))! istat=16: 1st peak as rlss/2 estimate 
                  rr16=0.0
                  if(do_cubic)then
                     rr16=rbin(imaxlis(1)) + 
     _                    rbin(imaxlis(2))/sqrt(2.0) + 
     _                    rbin(imaxlis(3))/2.0  
                  elseif(do_zeropt)then
                     do ip=2,npksearch
                        rr16=rr16+ 
     _                       (rbin(imaxlis(ip))-rzpt)
     _                       /real(ip-1)
                     enddo
                  else
                     do ip=1,npksearch
                        rr16=rr16+ rbin(imaxlis(ip))/real(ip)
                     enddo
                  endif! if(do_cubic)

                  if(do_cubic)then
                     rr16= rr16/(1.0+sqrt(2.0)+2.0)
                  elseif(do_zeropt)then
                     rr16=rr16/real(npksearch-1)                     
                  else
                     rr16=rr16/real(npksearch)
                  endif
                  print*,'free value of rlss: om,cc,rr16=',
     _                 om_0(iom),cc_0(icc),rr16

c                  xx= (rr16- rr15 )/drr15
                  sides=2.0
                  pp15=1.0
c                  pp15=sides* (1.0-erffun(abs(xx)))
                  pp16=1.0
c                  pp16=sides* (1.0-erffun(abs(xx)))
                  
c     --- estimate height ---
                  if(rbin(2).eq.rbin(1))print*,'ERROR rbin(2)=',rbin(2)
c                  iwid= (drlss/2.0)*1.1/ (rbin(2)-rbin(1))

                  if(do_cubic)then
                     fraction=0.4
                  else
                     fraction=0.5
                  endif
                  iwid= (rlss/2.0)*fraction *1.01/ (rbin(2)-rbin(1))
                  iwid15= (rr15)*fraction *1.01/ (rbin(2)-rbin(1))
                  iwid16= (rr16)*fraction *1.01/ (rbin(2)-rbin(1))

                  pp17=1.0
                  pp18=1.0


                  do ip=1,npksearch

                     if(do_cubic)then
                        xx= (rbin(imaxlis(ip))- rr15*fact_cub(ip))
     _                    /(drr15)
                     elseif(do_zeropt)then
                        xx= (rbin(imaxlis(ip))- rr15*real(ip-1)
     _                       -rzpt)
     _                       /(drr15)
                     else
                        xx= (rbin(imaxlis(ip))- rr15*real(ip))
     _                       /(drr15)
c     _                    /(real(ip)*drr15) 
                     endif

                     pp15= pp15* sides* (1.0-erffun(abs(xx)))
                     pp17= pp17* sides* (1.0-erffun(abs(xx)))

                     if(do_cubic)then
                        xx= (rbin(imaxlis(ip))- rr16*fact_cub(ip))
     _                       /(drr15)
                     elseif(do_zeropt)then
                        xx= (rbin(imaxlis(ip))- rr16*real(ip-1)
     _                       -rzpt)
     _                       /(drr15)
                     else
                        xx= (rbin(imaxlis(ip))- rr16*real(ip))
     _                       /(drr15)
                     endif
c     _                    /(real(ip)*drr15)
                     pp16= pp16* sides* (1.0-erffun(abs(xx)))
                     pp18= pp18* sides* (1.0-erffun(abs(xx)))

c                     if(1+1.eq.2.and.istat.ge.15
c     _                 .and.iom.eq.1.and.icc.eq.10)
c     _                    print*,'istat15etc: ',xx,drr15,pp15


                     hh = c_tr(imaxlis(ip), icc,iom,icheck,1) -
     _                    (
     _                    c_tr(imaxlis(ip)-iwid15,icc,iom,icheck,1)+ 
     _                    c_tr(imaxlis(ip)+iwid15,icc,iom,icheck,1)
     _                    )/2.0

                     qq15= erffun( (hh-hh0)/dhh )

                     hh = c_tr(imaxlis(ip), icc,iom,icheck,1) -
     _                    (
     _                    c_tr(imaxlis(ip)-iwid16,icc,iom,icheck,1)+ 
     _                    c_tr(imaxlis(ip)+iwid16,icc,iom,icheck,1)
     _                    )/2.0

                     qq16= erffun( (hh-hh0)/dhh )


c                  if(test)print*,'istat=17 etc', 
c     _                 iom,icc,iwid,ip,hh,hh0,dhh,qq

                     pp17=pp17*qq15
                     pp18=pp18*qq16

                  if(1+1.eq.3.and.istat.ge.15
     _                 .and.iom.eq.1.and.icc.eq.10)
     _                 print*,'istat=15 pp15 etc', 
     _                 iom,icc,ip,pp15,pp16,pp17,pp18


                  enddo
                  stat(iom,icc,15,icheck)=pp15
                  stat(iom,icc,16,icheck)=pp16
                  stat(iom,icc,17,icheck)=pp17
                  stat(iom,icc,18,icheck)=pp18

                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(15)= ' rlss assumed: r '
                     statlabel(16)= ' rlss free: r '
                     statlabel(17)= ' rlss assumed: r & \\gc'
                     statlabel(18)= ' rlss free: r & \\gc'

                     do_prcontour(15)=.true.
                     do_prcontour(16)=.true.
                     do_prcontour(17)=.true.
                     do_prcontour(18)=.true.
                  endif



c     --- find background statistics ---
                  csq=0.0
                  cmean=0.0


                  isq=0
c     do ib=1,nb
c     do ib=max(-(mxsmoo-1),ib-3*ismoo),  ! modif 13/06/00 03h00
c     _              min(ib+3*ismoo,nb_sm)
                  do ib=max(-(mxsmoo-1),ibmax1-3*ismoo), ! corrig 13/06/00 18h45
     _                 min(ibmax1+3*ismoo,nb_sm)

c     _                 rbin(ib).gt.r1.and.rbin(ib).lt.r2.and. ! modif 13/06/00 03:00
c     _                 rbin(ib).ge.r1.and.rbin(ib).le.r2.and. ! modif 13/06/00 03:00
                     if(
     _                    abs(ib-ibmax1).gt.ismoo2
     _                    )then
                        xx=c_tr(ib,icc,iom,icheck,1)
                        cmean=cmean + xx
                        csq=csq + xx*xx
                        isq=isq+1
                        if(xx.gt.cmax2)then
                           cmax2=xx
                        endif
                        
                     endif
                  enddo

                  tol=1e-8
                  if(isq.gt.1)then
                     cmean=cmean/real(isq)
                     yy= csq/real(isq-1) - cmean*cmean
                     if(yy.le.tol)print*,'WARNING: ',
     _                    'yy, cmean,csq/real(isq-1)=',
     _                    yy, cmean,csq/real(isq-1)

                     csq=sqrt( yy )
c     csq=sqrt(csq/real(isq-1))

                  else
                     cmean=99.9
                     csq=99.9
                  endif
c     print*,' found cmax1, cmax2=',cmax1,cmax2

c     ----------------------------------------------------------------------
                  if(do_2dF)then
                     ibmax1=imaxlis(1)
                     cmax1=
c     _                    c_tr(imaxlis(1), icc,iom,icheck,1) 
     _                    c_tr(ibmax1, icc,iom,icheck,1) 
                     rbmax1= rbin(ibmax1)
                  endif

                  call find2min(nb,c_tr(1,icc,iom,icheck,1),ibmax1,
     _                 imin1,imin2,xx1,xx2)

                  if(do_ssdrlss)then
                     imin1=max(imin1,ibmax1-
     _                    nint(drlss/(rbin(2)-rbin(1))))
                     imin2=min(imin2,ibmax1+
     _                    nint(drlss/(rbin(2)-rbin(1))))
                     xx1=c_tr(imin1,icc,iom,icheck,1)
                     xx2=c_tr(imin2,icc,iom,icheck,1)
                  endif


                  if(1+1.eq.3)then
                     write(6,'(a,i5,20f7.2)')
     _                    'test AAA ich=',ich,
     _                    (c_tr(ib,icc,iom,icheck,1),ib=imin1,imin2)
                  endif

c     --- find max sderrmean ---
                  ssmax=-9e9
                  ssrms=0.0
                  if(irlss.eq.1)then
                     issest=1
                  elseif(irlss.eq.2)then
                     issest=2
                  elseif(irlss.eq.3)then
                     issest=4
                  endif
c     issest=0
                  
c     do i=imin1,imin2
c     do i=ibmax1-ismoo,ibmax1+ismoo
                  do ib=ibmax1-issest,ibmax1+issest
                     xx=c_tr(ib,icc,iom,icheck,3)
                     if(xx.gt.ssmax)ssmax=xx
                  enddo
                  ss=0.0

                  if(ssmax.le.tol)then
                     print*,'WARNING: ssmax=',ssmax
                     ssmax=99.9
                  endif

                  if(do_ssrms)then
                     do ib=imin1,imin2
                        xx=c_tr(ib,icc,iom,icheck,3)
                        ssrms=ssrms+ xx*xx
                     enddo
                     if(imin2.gt.imin1)then
                        ssrms= sqrt(ssrms/real(imin2-imin1+1))
                     else
                        ssrms=9.9e9
                        print*,'WARNING: imin1,imin2=',imin1,imin2
                     endif
                  endif

                  sn2ratio= (cmax1-((xx1+xx2)/2.0)) /ssmax
                  if(do_ssrms)then
                     sn2ratio= (cmax1-((xx1+xx2)/2.0)) /ssrms
                  endif


                  write(6,'(a,i3,i4,5f8.3)')'==-== '//
     _                 'irlss,ich.,...,sn2ratio=',
     _                 irlss,icheck,cmax1,xx1,xx2,ssmax,sn2ratio
                  if(icheck.eq.1)then
                     sncut(irlss)=sn2ratio 
     _                          * 0.95 ! 05/06/01
     _                          !* 0.99
c     sncut(irlss)=2.0
                  endif

c     ----------------------------------------------------------------------

                  
                  stat(iom,icc,1,icheck)= cmax1
                  stat(iom,icc,2,icheck)= cmax2


                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(1)= '\\gc\\dmax\\u(1)'
                     statlabel(2)= '\\gc\\dmax\\u(2)'
                     do_sncontour(1)=.false.
                     do_sncontour(2)=.false.
                  endif

                  if(cmax2.gt.0.0)then
                     xx=cmax1/cmax2
                     stat(iom,icc,3,icheck)=  xx
                     snmax=max(snmax, xx)
                  else
                     stat(iom,icc,3,icheck)= xnull
                  endif

                  xx=(rbmax1 - rlss)/drlss
                  
                  if(do_rdip)then
                     xx= (rbmin1 - rdip)/drdip
                  endif

                  sides=2.0
c     stat(iom,icc,4,icheck)= exp(- xx*xx/2.0) !rbmax1 !


                  ss= sides* (1.0-erffun(abs(xx)))
c     if(irlss.eq.1.or.(.not.(do_sncut)))then
                  if(.not.(do_sncut)
     _                 .or.do_rdip
     _                 )then
                     stat(iom,icc,4,icheck)= ss
                  else
c     if(sn2ratio.gt.sncut0)then

                     if(sn2ratio.ge.sncut(irlss))then
                        stat(iom,icc,4,icheck)= ss
                     else
                        stat(iom,icc,4,icheck)= 0.0
                     endif

                  endif


                  if(nrlss.gt.1)then
                     if(irlss.eq.1)then
                        stat(iom,icc,14,icheck)= 
     _                       stat(iom,icc,4,icheck)
                     else
                        stat(iom,icc,14,icheck)= stat(iom,icc,14,icheck)
     _                       *stat(iom,icc,4,icheck)
                     endif
                     do_prcontour(14)=.true.

                     if(irlss.eq.1.and.icheck.eq.1)then
                        statcp(iom,icc)= stat(iom,icc,4,icheck)
                     endif

                  endif

                  do_prcontour(4)=.true.

c     if(test)write(6,'(a,2f7.2,i7,f7.1)')
c     _              'om_0,cc_0,ibmax1,rbmax1=',
c     _              om_0(iom),cc_0(icc),ibmax1,rbmax1
                  

                  stat(iom,icc,5,icheck)= cmax1/csq
                  stat(iom,icc,6,icheck)= cmax1sm/csq
                  
                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(3)= '\\gc\\dmax\\u(1)/\\gc\\dmax\\u(2)'
                     statlabel(4)= 'agrees with Rlss='

                     statlabel(14)= 'combined Rlss=...'
                     write(statlabel(4)(19:24),'(f6.1)')rlss

                     if(do_rdip)then
                        statlabel(4)= 'agrees with Rdip='
                        write(statlabel(4)(19:24),'(f6.1)')rdip
                     endif

                     statlabel(5)= '\\gc\\dmax\\u(1)/\\gs'
                     statlabel(6)= '\\gc\\dmax\\u(1,smoothed)/\\gs'

                     do_sncontour(3)=.true.
                     do_sncontour(4)=.false.
                     do_sncontour(5)=.false.
                     do_sncontour(6)=.false.
                  endif

                  cmax1mx=max(cmax1,cmax1mx)

                  xx=stat(iom,icc,3,icheck) 
                  if(xx.gt.0.0)then
                     yy= (rbmax1 -rlss)/(2.0*drlss)
                     stat(iom,icc,7,icheck)= xx 
c     _                 * 1.0/sqrt(2.0*3.14) 
     _                    *exp(-yy*yy) 
                  else
                     stat(iom,icc,7,icheck)= xnull
                  endif
                  if(.not.(
     _                 -abs(xnull)-1.0.le.stat(iom,icc,7,icheck)
     _                 .and.
     _                 stat(iom,icc,7,icheck).le.abs(xnull)+1.0 
     _                 ))then
                     print*,'Warning: ',
     _                    'stat(iom,icc,7,icheck)=' ,
     _                    stat(iom,icc,7,icheck)
                     stat(iom,icc,7,icheck)= xnull
                  endif



                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(7)= 'istat=7 : cmax1/cmax2 , rlss '
                     do_sncontour(7)=.true.
                  endif

                  xx=stat(iom,icc,5,icheck) 
                  if(xx.gt.0.0)then
                     yy= (rbmax1 -rlss)/(2.0*drlss)
                     stat(iom,icc,8,icheck)= xx 
c     _                 * 1.0/sqrt(2.0*3.14) 
     _                    *exp(-yy*yy) 
                  else
                     stat(iom,icc,8,icheck)= xnull
                  endif

                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(8)= 'istat=8 : cmax1/csq , rlss '
                     do_sncontour(8)=.true.
                  endif

c     --- ratio of peak to trough ---
                  ib2= nint(1.5*real(ibmax1))
                  if(ib2.le.nb)then
                     stat(iom,icc,9,icheck) = 0.0 ! cmax1sm !
     _                    - ( c_tr(ib2,icc,iom,icheck,1)
     _                    +   c_tr(ib2-1,icc,iom,icheck,1)
     _                    +   c_tr(ib2+1,icc,iom,icheck,1) )/3.0

                  else
                     stat(iom,icc,9,icheck) = cmax1sm 
                  endif
                  stat(iom,icc,10,icheck) = 
     _                 stat(iom,icc,9,icheck)/ csq

                  if(iom.eq.1.and.icc.eq.1)then
c     statlabel(9)= ' peak - trough '
c     statlabel(10)= ' (peak - trough)/\\gs '
                     statlabel(9)= '  - trough '
                     statlabel(10)= '  - trough/\\gs '
                     do_sncontour(9)=.false.
                     do_sncontour(10)=.true.
                  endif


                  stat(iom,icc,11,icheck)= cmax1 - cmean
                  stat(iom,icc,12,icheck)= (cmax1 - cmean)/csq
                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(11)= ' peak - mean '
                     statlabel(12)= ' (peak - mean)/\\gs '
                     do_sncontour(11)=.false.
                     do_sncontour(12)=.false. !.true.!
                  endif
                  

c     ---- mean of standard error in the mean over the interval ---
c     -- reciprocal is used just to simplify contouring 
                  serrtot=0.0
                  if(nb.gt.0)then
                     do ib=1,nb
                        xx= c_tr(ib,icc,iom,icheck,3)
                        serrtot=serrtot + xx*xx ! xx !
                     enddo
                     if(serrtot.gt.tol)then
                        serrtot=real(nb)/serrtot
c     serrtot=serrtot*serrtot
c     serrtot=sqrt(serrtot)
                        serrtot=serrtot*serrtot
                     else
                        serrtot=0.0
                     endif
                  endif


                  stat(iom,icc,13,icheck)= serrtot
                  if(iom.eq.1.and.icc.eq.1)then
                     statlabel(13)= ' 1/<s err in the mean> '
                     do_sncontour(13)=.false.
                  endif


c     ---- max of all statistics ---

                  do istat=1,nstat
                     xx=stat(iom,icc,istat,icheck) 
                     if(xx.gt.0.0)then
                        statmax(istat)= max( statmax(istat), xx)
                     endif
                  enddo



               enddo
            enddo

            print*,'statmax(3), snmax=',statmax(3), snmax
c     statmax(1)= cmax1mx

            if(1+1.eq.3)then
c     ---- "vt220 printout" ----
               print*,'-----------------------------------------------'
               print*,'S/N ratio:'
               do icc=ncc,1,-1
                  write(6,'(f5.2,a,9f5.1)')
     _                 cc_0(icc),' ',
     _                 (stat(iom,icc,3,icheck),iom=1,nom)
               enddo
               write(6,'(a5,a,9f5.2)')
     _              '     ',' ',(om_0(iom),iom=1,nom)
               print*,'-----------------------------------------------'
               print*,' '
               print*,'rbmax1 '
               do icc=ncc,1,-1
                  write(6,'(f5.2,a,21f5.0)')
     _                 cc_0(icc),' ',
     _                 (stat(iom,icc,4,icheck),iom=1,nom)
               enddo
               write(6,'(a5,a,21f5.2)')
     _              '     ',' ',(om_0(iom),iom=1,nom)
               print*,'-----------------------------------------------'
               print*,' '
c     print*,'sqrt( [S/N] ^2 + [(rbmax1-rlss)/drlss] ^2) '
               print*,' [S/N] * exp{[-(rbmax1-rlss)/(2.0*drlss)] ^2} '
               do icc=ncc,1,-1
                  write(6,'(f5.2,a,9f5.1)')
     _                 cc_0(icc),' ',
     _                 (stat(iom,icc,5,icheck),iom=1,nom)
               enddo
               write(6,'(a5,a,9f5.2)')
     _              '     ',' ',(om_0(iom),iom=1,nom)
               print*,'-----------------------------------------------'
               print*,' '

               print*,' istat=7 '
               do icc=ncc,1,-1
                  write(6,'(f5.2,a,21f5.1)')
     _                 cc_0(icc),' ',
     _                 (stat(iom,icc,7,icheck),iom=1,nom)
               enddo
               write(6,'(a5,a,21f5.2)')
     _              '     ',' ',(om_0(iom),iom=1,nom)
               print*,'-----------------------------------------------'
            endif


            om1=om_0(1)
            om2=om_0(nom)
            cc1=cc_0(1)
            cc2=cc_0(ncc)

            if(nom.gt.1)then
               dom_di= (om_0(nom)-om_0(1))/real(nom-1)
            else
               dom_di=99.9
            endif
            tr(1)= om_0(1) - dom_di !! om horiz cc vert
            tr(2)= dom_di

            if(ncc.gt.1)then
               dcc_di= (cc_0(ncc)-cc_0(1))/real(ncc-1)
            else
               dcc_di=99.9
            endif
            tr(4)= cc_0(1) - dcc_di !! om horiz cc vert
            tr(6)= dcc_di
            tr(3)=0.0
            tr(5)=0.0

            if(icheck.eq.1)then
               do istat=1,nstat
                  print*,'istat,statmax(istat)=',istat,statmax(istat)
               enddo
            endif

            do istat=1,nstat
c     ---- save out a statistic to a file ----
               
               if(istat.eq.4)then
                  write(ch3(3:3),'(i1)')irlss
                  open(1,file='stat04_'//ch3(3:3)//'.dat',
     _                 access='sequential',
     _                 form='unformatted',status='unknown')
                  write(1)nom,ncc,(om_0(i),i=1,nom),
     _                 (cc_0(i),i=1,ncc)
                  write(1)((stat(iom,icc,istat,icheck),
     _                 iom=1,nom),icc=1,ncc)
                  close(1)
                  print*,'have written  stat04.dat'
               endif


c     print*,' '
c     print*,'...... starting istat=',istat

               write(ch2,'(i2)')istat
               if(ch2(1:1).eq.' ')ch2(1:1)='0'
               
c     -- contours for plotting --
               ncont= 10

c     if(istat.eq.3.or.(istat.ge.5.and.7.le.istat))then
               if(do_prcontour(istat))then
                  do i=1,ncont-1
                     cont(i)=  
     _                    sides*(1.0-erffun( real(i-1) ))  
                  enddo
                  if(test)print*,'cont(1)=',cont(1)
                  cont(1)=1.01
                  if(test)print*,'cont(1)=',cont(1)
                  cont(ncont)=-0.01
                  
               elseif(do_sncontour(istat))then
                  cont(ncont)= 100.0
                  do i=1,ncont-1
                     cont(i)= 3.5 - (ncont-i)*0.5
                  enddo
               else
                  do i=1,ncont
                     cont(i)= statmax(istat)*1.01
     _                    * (real(i-1))/real(ncont-1)
                  enddo

               endif

               write(ch3c,'(i3)')icheck
               do i=1,3
                  if(ch3c(i:i).eq.' ')ch3c(i:i)='_'
               enddo

c     if(om1.ne.om2.and.cc1.ne.cc2)then
               if(nom.gt.1.and.ncc.gt.1)then

                  if(nrlss.gt.1)then
                     write(ch3(3:3),'(i1)')irlss
c     if(istat.eq.4)then
                     if(1+1.eq.5)then
                        call pgbegin(0,'?',1,1)
                     else
                        call pgbegin(0,'stat'//ch2//'_'//ch3(3:3)//
     _                       '_ich'//ch3c//'.ps/vps', !     !'S_N_.ps/vps', !'?', !
     _                       1,1)
                     endif
                  else          !if(istat.ne.9994)then

                     flnm_tmp='stat'//ch2//'_ich'//ch3c//'.ps/vps' !  

c                     if(istat.ge.15)flnm_tmp='?' !! test only !!

                     call pgbegin(0,flnm_tmp,1,1)

c     else
c     call pgbegin(0,'?',1,1)
                  endif
                  call pgvsize(1.0,6.0,1.5,6.5)
c     call pgscf(2)
                  call pgsch(1.5)
                  call pgslw(3)

                  call pgwindow(om1,om2,cc1,cc2)


                  call pgbox('bcnts',0.,0,'bcnts',0.,0)
c     call pglabel('\\gW\\d0','\\gl\\d0',' ') ! Yoshii

c     ----- labels section ----
                  if(biglabels)then
                     call pgvsize(1.4,5.6,1.8,6.2)
                     call pgqch(qch)
                     call pgsch(qch*1.6)
                  endif

                  if(nrlss.gt.1)then
                     if((irlss.eq.1.or.irlss.eq.3).and.
     _                    (.not.(istat.eq.14)))then
                        call pglabel(' ','\\gW\\d\\gL',' ') ! Peebles 1993
                     endif


                     if(irlss.le.3)then
c     if(irlss.eq.3)then
c     call pglabel('\\gW\\dm',' ',' ') !
                        call pglabel(' ','\\gW\\d\\gL',' ') ! Peebles 1993

                        call pgvsize(1.0,6.0,1.5,6.5)
                        call pgqlw(iqlw)
                        call pgslw(8)
                        call pgptxt(-0.1,-0.2,0.0,0.0,'a.') !'b.') 
                        call pgslw(iqlw)
                     endif
                     
                  else
                     if(.not.(putquinlabel))then
                        call pglabel('\\gW\\dm','\\gW\\d\\gL',' ') ! Peebles 1993
                     else
                        call pglabel('\\gW\\dm','w',' ') ! Peebles 1993
                     endif
                  endif
                  if(biglabels)then
                     call pgvsize(1.0,6.0,1.5,6.5)
                     call pgsch(qch)
                  endif
c     ----- end of labels section ----

                  print*,'istat=', istat
                  print*,'cont=',cont
                  print*,'tr=',tr
                  

c     istat=3

                  call pgcont(stat(1,1,istat,icheck),mxcurv,mxcurv,
     _                 1,nom,1,ncc,cont,ncont,tr)

                  if(do_cp65.and.
     _                 istat.eq.4.and.irlss.eq.2.and.icheck.eq.1)then
                     call pgqlw(iqlw)
                     call pgslw(8)
                     call pgcont(statcp(1,1),mxcurv,mxcurv,
     _                    1,nom,1,ncc,cont, 2, tr)

c     call pgcont(stat(1,1,14,icheck),mxcurv,mxcurv,
c     _              1,nom,1,ncc,cont, 2, tr)

                     call pgslw(iqlw)
                  endif


                  if(do_prcontour(istat))then
c     --- shift contours relative to RM00a ---
                     icshift=1  ! 0 !  

                     do ic1=1+icshift,ncont-1
                        ic2=ic1+1
c                        if(istat.ge.15)then  !! test only !!
                           print*,'icont,cont(ic1),cont(ic2)=',
     _                          icont,cont(ic1),cont(ic2)
c                        endif
                        if(ic1.eq.1+icshift)then
                           call pgsfs(3) 
                        else
                           call pgsfs(4) 
                        endif
                        if(ic1.le.2+icshift)then
                           call pgslw(1)
                        elseif(ic1.eq.3)then
                           call pgslw(3)
                        elseif(ic1.ge.4)then
                           call pgslw(5)
                        endif

c                        if(istat.ge.15)then  !! test only !!
c                           pause 'will call pgconf ...'
c                        endif


                        call pgconf(stat(1,1,istat,icheck),
     _                       mxcurv,mxcurv,
     _                       1,nom,1,ncc,cont(ic2),cont(ic1),tr)

c                        if(istat.ge.15)then !! test only !!
c                           print*,'have called pgconf ... ic1=',ic1
c                           pause ' next contour...'
c                        endif
                     enddo
                     call pgslw(3)

c     \\(2233)
                     
                     write(ch4,'(f4.0)')rlss
                     ch3a=ch4(1:3)
                     if(.not.(do_root2))then
                        write(ch3b,'(f3.0)')drlss
                     else
                        write(ch3b,'(f3.0)')drlss/sqrt(2.0)
                     endif

                     if(do_rdip)then
                        write(ch4,'(f4.0)')rdip
                        ch3a=ch4(1:3)
                        if(.not.(do_root2))then
                           write(ch3b,'(f3.0)')drdip
                        else
                           write(ch3b,'(f3.0)')drdip/sqrt(2.0)
                        endif
                     endif
                     
                     if(istat.eq.4.and.putomlabel)then
                        if(biglabels)then
                           call pgqch(qch)
                           call pgsch(qch*1.6)
                        endif
                        
                        call pgptxt(xlab(irlss),ylab(irlss),0.0,0.5,
     _                       ch3a//'\\(2233)'//ch3b(1:2)
c     _                    'rad' ! 'tan'!
     _                       )
                        if(biglabels)then
                           call pgqch(qch)
                        endif
                     endif

                     call pglabel(' ',' ',statlabel(istat))

                  else
                     ic1=ncont-4
                     ic2=ic1+2

c                  print*,'icont,cont(ic1),cont(ic2)=',
c     _                 icont,cont(ic1),cont(ic2)

                     call pgsfs(3) 
                     call pgslw(1)
c                     print*,'will call pgconf ...'
                     call pgconf(stat(1,1,istat,icheck),
     _                    mxcurv,mxcurv,
     _                    1,nom,1,ncc,cont(ic1),cont(ic2),tr)
c                     print*,'have called pgconf ...'

                     ic1=ncont-2
                     ic2=ic1+2

c                     print*,'icont,cont(ic1),cont(ic2)=',
c     _                    icont,cont(ic1),cont(ic2)
                     call pgsfs(4) 
                     call pgslw(1)


                     if(.not.((7.le.istat.and.istat.le.8)
     _                    .and.contourerror1))then
                        print*,'will call pgconf ...'
                        call pgconf(stat(1,1,istat,icheck),
     _                       mxcurv,mxcurv,
     _                       1,nom,1,ncc,cont(ic1),cont(ic2),tr)
                        print*,'have called pgconf ...'
                     endif
                  endif

                  call pglabel(' ',' ',statlabel(istat))

                  call pgend
               endif            !             if(om1.ne.om2.and.cc1.ne.cc2)then

            enddo               ! istat=1,nstat

         enddo                  ! commented out and back in BFR 13/07/00 IAP
         print*,'ymin,ymax (initial)=',ymin,ymax

c     ---- just print out some individual statistics ----
         if(nom*ncc.le.4)then
            print*,' ==-== some individual statistics ===='
            print*,' ==-== irlss=',irlss
            do icc=1,ncc
               do iom=1,nom
                  write(6,'(a,f7.2,f7.2)')
     _                 ' ==-== om_0(iom),cc_0(icc)=',om_0(iom),cc_0(icc)
                  do jj=1,2
                     if(jj.eq.1)then
                        istat=4
                     else
                        istat=14
                     endif
                     print*,' ==-== istat=',istat

c     -- will count number of bootstrap or random cases wher
c     the statistic is "better" than the case of the obs data --
                     ibet_b=0 
                     ibet_r=0
                     pp=stat(iom,icc,istat,1)*0.99
                     do icheck=1,1 +2*nctrl
                        write(6,'(a,i4,f8.3)')' ==-== icheck, '//
     _                       'stat(iom,icc,istat,icheck)=',
     _                       icheck, stat(iom,icc,istat,icheck)
                        if(jj.eq.1)then
                           if(2.le.icheck.and.
     _                          icheck.le.1+nctrl)then
                              if(stat(iom,icc,istat,icheck).gt.pp)then
                                 ibet_b=ibet_b+1
                                 statcp2(iom,icc,icheck,irlss)=.true.
                              else
                                 statcp2(iom,icc,icheck,irlss)=.false.
                              endif
                           elseif(2+nctrl.le.icheck.and.
     _                             icheck.le.1+2*nctrl)then
                              if(stat(iom,icc,istat,icheck).gt.pp)then
                                 ibet_r=ibet_r+1
                                 statcp2(iom,icc,icheck,irlss)=.true.
                              else
                                 statcp2(iom,icc,icheck,irlss)=.false.
                              endif
                           else
                              statcp2(iom,icc,icheck,irlss)=.true. 
                           endif
                        endif
                     enddo

                     if(nctrl.ge.1.and.jj.eq.1)then
                        pb= real(ibet_b)/real(nctrl)
                        pr= real(ibet_r)/real(nctrl)
                        print*,'==-== prob irlss = ',irlss
                        print*,'==-== prob boot better = ',pb
                        print*,'==-== prob ran  better = ',pr
c     --- cumulative ---
                        jbet_b=0 
                        jbet_r=0
                        kbet_b=0 
                        kbet_r=0
                        lbet_b=0 
                        lbet_r=0
                        do icheck=1,1 +2*nctrl
                           if(2.le.icheck.and.
     _                          icheck.le.1+nctrl)then
                              dummylog=.true.
                              do jrlss=1,irlss
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)jbet_b=jbet_b+1

                              dummylog=.true.
                              do jrlss=2,irlss
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)kbet_b=kbet_b+1

                              dummylog=.true.
                              do jrlss=1,irlss, 2
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)lbet_b=lbet_b+1
                              
                           elseif(2+nctrl.le.icheck.and.
     _                             icheck.le.1+2*nctrl)then
                              dummylog=.true.
                              do jrlss=1,irlss
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)jbet_r=jbet_r+1

                              dummylog=.true.
                              do jrlss=2,irlss
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)kbet_r=kbet_r+1

                              dummylog=.true.
                              do jrlss=1,irlss,2
                                 dummylog=dummylog.and.
     _                                statcp2(iom,icc,icheck,jrlss)
                              enddo
                              if(dummylog)lbet_r=lbet_r+1
                           else
                              continue
                           endif
                        enddo
                        if(irlss.gt.1)then
                           pb= real(jbet_b)/real(nctrl)
                           pr= real(jbet_r)/real(nctrl)
                           print*,'==-== prob 1..irlss = ',irlss
                           print*,'==-== cum prob boot better = ',pb
                           print*,'==-== cum prob ran  better = ',pr
                        endif
                        if(irlss.gt.2)then
                           pb= real(kbet_b)/real(nctrl)
                           pr= real(kbet_r)/real(nctrl)
                           print*,'==-== prob 2..irlss = ',irlss
                           print*,'==-== cum prob boot better = ',pb
                           print*,'==-== cum prob ran  better = ',pr
                        endif
                        if(irlss.gt.2)then
                           pb= real(kbet_b)/real(nctrl)
                           pr= real(kbet_r)/real(nctrl)
                           print*,'==-== prob 1,irlss,2  irlss=',irlss
                           print*,'==-== cum prob boot better = ',pb
                           print*,'==-== cum prob ran  better = ',pr
                        endif
                     endif

                  enddo
               enddo
            enddo
            print*,' ==== end of individual statistics ===='
         endif

      enddo                     !      do irlss=1,nrlss


      xmin=rbin(1)-delta/2.0
      if(plotfromzero)xmin=0.0! 4000.0! 
      xmax=rbin(nb)+delta/2.0


      ymin=-1.0 !-0.1 !-0.2 !
      ymax=1.0! 0.1 !3.0 !0.5!

      if(.not.(plotfromzero))then
         stop 'Will not make correlation function plots.'
      else
         print*,'Will make correlation function plots...'
      endif


      do icheck=1,1 +2*nctrl
         print*,'icheck=',icheck

         if(dowritec_sm)then
            open(1,file='c_smooth.dat',access='sequential',
     _           form='unformatted',status='unknown')
            write(1)ncc,nom,(cc_0(icc),icc=1,ncc),
     _           (om_0(iom),iom=1,nom)
            write(1)nb+ioffset,
     _           (rbin(i-ioffset),i=1,nb+ioffset)
            do iom=1,nom
               do icc=1,ncc
                  write(1)
     _                 (c_tr(i-ioffset,icc,iom,icheck,1),
     _                 i=1,nb+ioffset),
     _                 (c_tr(i-ioffset,icc,iom,icheck,4),
     _                 i=1,nb+ioffset),
     _                 (c_tr(i-ioffset,icc,iom,icheck,5),
     _                 i=1,nb+ioffset)
               enddo
            enddo
            close(1)
            print*,'Have written ','c_smooth.dat'
            print*,' '
c            stop 'will not make corrn fn plots'
         endif




         do icc=1,ncc
            if(iomprint.gt.0)then
               iom1=iomprint
               iom2=iomprint
            else
               iom1=1
               iom2=nom
            endif

            do iom=iom1,iom2
c               stop 'test AA'
               write(ch5a,'(f5.2)')om_0(iom)
               write(ch5b,'(f5.2)')cc_0(icc)

               write(ch3,'(i3)')icheck
               if(ch3(2:2).eq.' ')ch3(2:2)='0'
               
               flnm='xi_'//ch_flnm(1:nchflnm)//
     _              '_'//ch5a//ch5b//ch3//'.ps'
               do i=1,22
                  if(flnm(i:i).eq.' ')flnm(i:i)='_'
               enddo

c               stop 'test BB'
               write(ch5a(2:5),'(f4.1)')nint(om_0(iom)*10.0)/10.0
               write(ch5b(2:5),'(f4.1)')nint(cc_0(icc)*10.0)/10.0
               ich5b1=2
               ich5b2=5
               if(twodeclabel)then
                  write(ch5a(1:5),'(f5.2)')
c     _                 nint(om_0(iom)*20.0)/20.0
     _                 nint(om_0(iom)*100.0)/100.0
                  write(ch5b(1:5),'(f5.2)')
c     _                 nint(cc_0(icc)*20.0)/20.0
     _                 nint(cc_0(icc)*100.0)/100.0
                  ich5b1=1
               endif

c               pause 'will write another plot...'

               call pgbegin(0,flnm(1:25)//'/vps', ! '?', !
     _              1,1)
               call pgslw(3)
               call pgscf(2)
               call pgvsize(1.0,7.0,1.0,7.0)

c               stop 'test CC'
               call pgwindow(xmin,xmax,ymin,ymax)
               call pgsch(1.5)
               call pgbox('bcnts',0.,0,'bcnts',0.,0)
               call pgsch(1.0)

               if(icc.eq.1.and.iom.eq.1.and.2+2.eq.5 !! test only !!
     _              )then
                  do ib=nb-10,nb
                     print*,'ib=',ib
                     print*,'rbin(ib),c_tr(ib,icc,iom,icheck,1)='
                     print*,rbin(ib),c_tr(ib,icc,iom,icheck,1)
                  enddo
               endif

               if(plotfromzero)then

                  call pgqlw(iqlw)
                  call pgslw(3) ! (8)!
                  call pgline(nb+ioffset,
     _                 rbin(1-ioffset),
     _                 c_tr(1-ioffset,icc,iom,icheck,1))
                  call pgsls(1)
                  call pgslw(iqlw)

                  if(nflnm.gt.2)then
                     call pgqlw(iqlw)
                     call pgslw(3)
                     call pgline(nb+ioffset,
     _                    rbin(1-ioffset),
     _                    c_tr(1-ioffset,icc,iom,icheck,4))
                     call pgline(nb+ioffset,
     _                    rbin(1-ioffset),
     _                    c_tr(1-ioffset,icc,iom,icheck,5))
                     call pgslw(iqlw)
                  endif

                  call pgsls(1)
                  ioff=ioffset ! 0!
                  if(.not.(RMBnoindivid))then
                     do iflnm=1,nflnm
c     call pgpoint(nb+ioff,
c     _                    rbin(1-ioff),
c     _                    corrnerr(1-ioff+ioffset,iom,icc,
c     _                    icheck,iflnm),22)

                        call pgsls((mod(1+iflnm-1,5)+1))
                        call pgqlw(iqlw)
                        call pgslw(3)
                        call pgline(nb+ioff,
     _                       rbin(1-ioff),
     _                       corrnerr(1-ioff+ioffset,iom,icc,
     _                       icheck,iflnm))
                        call pgsls(1)
                        call pgslw(iqlw)

c     print*,'test: ',
c     _                    (rbin(1-ioff+i-1),
c     _                    corrnerr(1-ioff+i-1,iom,icc,icheck,iflnm),
c     _                    i=1,nb+ioff)
c     pause
                     enddo
                  endif !if(.not.(RMBnoindivid))then

c     ---- zscramprob (underestimation of \xi due to z-scrambling + filaments 
c     + small dimension(s) of survey volume ---- 
                  if(RMBstyle)then
                     call pgsfs(3)
                     call pgrect(0.0,zscramprob,ymin,ymax)
                  endif


               else
c                  stop 'test DD'
                  call pgline(nb,rbin(1),c_tr(1,icc,iom,icheck,1))
                  call pgsls(4)
                  call pgline(nb,rbin(1),c_tr(1,icc,iom,icheck,4))
                  call pgline(nb,rbin(1),c_tr(1,icc,iom,icheck,5))
               endif

               call pgsls(1)



c               stop 'test EE'
               call pgqch(qch)
               call pgsch(1.5)
               if(.not.(putquinlabel))then
                  call pgptxt(
c     _              xmin+(xmax-xmax)*0.3,
     _                 xmin+(xmax-xmin)*0.4,
     _                 ymin+0.9*(ymax-ymin), 0.0,0.0,
c     _              '\\gW\\d0\\u='//ch5a//', \\gl\\d0\\u='//ch5b//
c     _              '  ifld='//ch_flnm(1:nchflnm)//'  i='//ch3
c     _                 '\\gW\\dm\\u='//ch5a(2:5)//
     _                 '\\gW\\dm\\u='//ch5a(ich5b1:ich5b2)//
c     _                 ', \\gW\\d\\gL\\u='//ch5b(2:5)
     _                 ', \\gW\\d\\gL\\u='//ch5b(ich5b1:ich5b2)
     _                 )

               else
                  call pgptxt(
c     _              xmin+(xmax-xmax)*0.3,
     _                 xmin+(xmax-xmin)*0.4,
     _                 ymin+0.9*(ymax-ymin), 0.0,0.0,
c     _              '\\gW\\d0\\u='//ch5a//', \\gl\\d0\\u='//ch5b//
c     _              '  ifld='//ch_flnm(1:nchflnm)//'  i='//ch3
     _                 '\\gW\\dm\\u='//ch5a(2:5)//
     _                 ', w='//ch5b(2:5)
     _                 )
               endif

               ch3d=flnmlis(1)(2:4)
c               ch3e=flnmlis(1)(6:8)
               ch3e=flnmlis(nflnm)(6:8)
               if(RMBstyle)then
                  call pgptxt(
     _                 xmin+(xmax-xmin)*0.4,
     _                 ymin+0.1*(ymax-ymin), 0.0,0.0,
     _                 ch3d//' < z < '//ch3e)
               endif


               call pgslw(1)
               call pgsch(qch)
               call pgmove(0.0,0.0)
               call pgdraw(xmax,0.0)

               call pgwindow(0.0,1.1,-0.1,1.1) ! compare with contour plots
               call pgslw(8)    ! set _new_ line width
               call pgsch(1.5*7.0/6.0)
c               call pgptxt(-0.1,-0.2,0.0,0.0,'a.')             

               call pgslw(3)
               call pgvsize(1.2,6.8,1.4,6.5)
               call pglabel('r (in h\\u-1\\dMpc)','\\gc(r)',' ')

               call pgend

            enddo
         enddo
      enddo

      if(plotfromzero.and.nctrl.gt.0)then
         do jj=1,2
            do iom=1,nom
               do icc=1,ncc
                  write(ch5a,'(f5.2)')om_0(iom)
                  write(ch5b,'(f5.2)')cc_0(icc)

                  flnm='xi_'//ch_flnm(1:nchflnm)//
     _                 '_'//ch5a//ch5b//'.ps'

                  if(jj.eq.1)then
                     call pgbegin(0,'boot'//flnm(1:25)//'/vps', ! '?', !
     _                    1,1)
                  else
                     call pgbegin(0,'ran_'//flnm(1:25)//'/vps', ! '?', !
     _                    1,1)
                  endif
                  
                  call pgslw(3)
c     call pgscf(2)
                  call pgvsize(1.0,7.0,1.0,7.0)

                  call pgwindow(xmin,xmax,ymin,ymax)
                  call pgbox('bcnts',0.,0,'bcnts',0.,0)

                  call pgslw(3)
                  do icheck=(jj-1)*nctrl+2,(jj-1)*nctrl+1+nctrl
                     call pgline(nb+ioffset,
     _                    rbin(1-ioffset),
     _                    c_tr(1-ioffset,icc,iom,icheck,1))
                  enddo
                  call pgslw(3)
                  
                  call pglabel('r (in h\\u-1\\dMpc)','\\gc',' ')

                  call pgqch(qch)
                  call pgsch(1.5)

                  if(.not.(putquinlabel))then
                     call pgptxt(
     _                    xmin+(xmax-xmin)*0.4,
     _                    ymin+0.9*(ymax-ymin), 0.0,0.0,
     _                    '\\gW\\dm\\u='//ch5a(2:5)//
     _                    ', \\gW\\d\\gL\\u='//ch5b(2:5)
     _                    )
                  else
                     call pgptxt(
     _                    xmin+(xmax-xmin)*0.4,
     _                    ymin+0.9*(ymax-ymin), 0.0,0.0,
     _                    '\\gW\\dm\\u='//ch5a(2:5)//
     _                    ', w='//ch5b(2:5)
     _                    )
                  endif

                  if(jj.eq.1)then
                     call pgptxt(
     _                    xmin+(xmax-xmin)*0.2,
     _                    ymin+0.9*(ymax-ymin), 0.0,0.0,
     _                    'boot'
     _                    )
                  else
                     call pgptxt(
     _                    xmin+(xmax-xmin)*0.2,
     _                    ymin+0.9*(ymax-ymin), 0.0,0.0,
     _                    'ran '
     _                    )
                  endif

                  call pgslw(1)
                  call pgsch(qch)
                  call pgmove(0.0,0.0)
                  call pgdraw(xmax,0.0)
                  call pgend
               enddo
            enddo
         enddo
      endif

      end


      subroutine find2min(nmax,x,i0, ! inputs
     _     imin1,imin2,x1,x2)   !      outputs

c     ==== finds (and plots if test=.true. requested) the first
c     minima at imin1 below and imin2 above the index i0, in
c     the array  x ====

C     INPUTS:
      integer*4 nmax
      integer*4 i0 ! initial point (e.g. max)
      real*4   x(*) ! needs at least nmax

C     OUTPUTS:
      integer*4  imin1,imin2    ! the indices of the minima
      real*4   x1,x2            ! the values at those minima

C     INTERNAL:
      logical*4  test
      parameter(mxnloc=1000)
      real*4     rr(mxnloc)

      data test /.false./ !.true./!

      i=i0-1
      xmin=x(i0)
      if(i.ge.1)xtest=x(i)
      do while(i.ge.1.and.xtest.lt.xmin)
         xmin=x(i)
         i=i-1
         if(i.ge.1)xtest=x(i)
      enddo
      if(i.lt.1)i=1
      if(x(i).gt.x(i+1))i=i+1
      imin1=i
      x1=x(imin1)

      i=i0+1
      xmin=x(i0)
      if(i.le.nmax)xtest=x(i)
      do while(i.ge.1.and.xtest.lt.xmin)
         xmin=x(i)
         i=i+1
         if(i.le.nmax)xtest=x(i)
      enddo

      if(i.gt.nmax)i=nmax
      if(x(i).gt.x(i-1))i=i-1
      imin2=i
      x2=x(imin2)
      
      if(test)then
         if(mxnloc.lt.nmax)then
            print*,'ERROR : nmax,mxnloc=',
     _        nmax,mxnloc
            pause
         endif
         nbig= min(nmax,mxnloc)
         do i=1,nbig
            rr(i)= real(i)
         enddo
         ydel=0.5*(x(i0)-min(x1,x2))
         ymax=x(i0) +ydel
         ymin=min(x1,x2) - ydel

         call pgbegin(0,'?',1,1) !   begin pgplot
         call pgvsize(1.0,5.0,1.0,4.0) 
         call pgwindow(0.0,real(nbig), ymin,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0) !  make a box, tick marks, etc.

         call pgline(nmax,rr,x)
         call pgsch(2.0)
         call pgslw(4)
         call pgpoint(1,rr(imin1),x1,22)
         call pgpoint(1,rr(imin2),x2,14)

         call pgend
      endif

      return
      end


