      program load_ReadMe
C=============================================================================
C  F77-compliant program generated by readme2f_1.0, on 2001-May-01
C=============================================================================
*  This code was generated from the ReadMe file documenting a catalogue
*  according to the "Standard for Documentation of Astronomical Catalogues"
*  currently in use by the Astronomical Data Centers (CDS, ADC, A&amp;A)
*  (see full documentation at URL <A HREF="http://vizier.u-strasbg.fr/doc/catstd.htx">http://vizier.u-strasbg.fr/doc/catstd.htx</A>)
*  Please report problems or questions to   <A HREF="mailto:question@simbad.u-strasbg.fr">question@simbad.u-strasbg.fr</A>
C=============================================================================

      implicit none
*  Unspecified or NULL values, generally corresponding to blank columns,
*  are assigned one of the following special values:
*     _rNULL_    for unknown or NULL floating-point values
*     _iNULL_    for unknown or NULL   integer      values
      real*4     _rNULL_
      integer*4  _iNULL_
      parameter  (_rNULL_=-1.e37)     	! NULL real number
      parameter  (_iNULL_=-2147483647)	! NULL int  number

C=============================================================================
Cat. VII/223       The 2dF QSO Redshift Survey. V. The 10k catalogue   (Croom+ 2001)
*================================================================================
*The 2dF QSO Redshift Survey - V. The 10k catalogue.
*    Croom S.M., Smith R.J., Boyle B.J., Shanks T., Loaring N.S., Miller L.,
*    Lewis I.J.
*   &lt;Mon. Not. R. Astron. Soc. 322, L29 (2001)&gt;
*   =2001MNRAS.322L..29C
C=============================================================================

C  Internal variables

      integer*4 _i_

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

C  Declarations for '2qz10k.dat'	! List of object properties including position,
                                 identification and redshift

      integer*4 _nr_
      parameter (_nr_=20590)	! Number of records
      character*199 _ar_   	! Full-size record

      character*3   ____       (_nr_) ! [2QZ] Name of Survey
      character*16  Name       (_nr_) ! Name of the source in 2QZ
      integer*4     RAh        (_nr_) ! (h) Right ascension (J2000)
      integer*4     RAm        (_nr_) ! (min) Right ascension (J2000)
      real*4        RAs        (_nr_) ! (s) Right ascension (J2000)
      character*1   DE_        (_nr_) ! Declination sign
      integer*4     DEd        (_nr_) ! (deg) Declination (J2000)
      integer*4     DEm        (_nr_) ! (arcmin) Declination (J2000)
      real*4        DEs        (_nr_) ! (arcsec) Declination (J2000)
      real*8        RArad      (_nr_) ! (rad) Right ascension (J2000)
      real*8        DErad      (_nr_) ! (rad) Declination (J2000)
      real*4        bJmag      (_nr_) ! (mag) b_J_ magnitude
      real*4        u_bJ       (_nr_) ! (mag) u-b_J_ colour
      real*4        bJ_r       (_nr_) ! (mag) b_J_-r colour (1)
      integer*4     o_bJmag    (_nr_) ! Number of observations (2)
      real*4        z1         (_nr_) ! Redshift from first spectrum
      integer*4     q_z1       (_nr_) ! Quality flag for first spectrum (3)
      character*11  id1        (_nr_) ! Identification for first spectrum (4)
      character*10  date1      (_nr_) ! ("D/M/Y") Date of observation for first spectrum (5)
      integer*4     fld1       (_nr_) ! field and spectrograph for first spectrum (6)
      real*4        sn1        (_nr_) ! Signal-to-noise ratio for first spectrum (7)
      real*4        z2         (_nr_) ! ?=0 Redshift from second spectrum
      integer*4     q_z2       (_nr_) ! Quality flag for second spectrum (3)
      character*11  id2        (_nr_) ! Identification for second spectrum  (4)
      character*10  date2      (_nr_) ! ("D/M/Y") ?Date of observation for second spectrum (5)
      integer*4     fld2       (_nr_) ! field and spectrograph for second spectrum (6)
      real*4        sn2        (_nr_) ! Signal-to-noise ratio for second spectrum (7)
      real*4        zprev      (_nr_) ! ?=0 Redshift if previously known (8)
      real*4        F21cm      (_nr_) ! (mJy) ?=0 Flux at 1.4GHz from NVSS (9)
      real*8        FRASS      (_nr_) ! (mW/m2) ?=0 Flux at 0.1-2.4keV x 10^-13 from RASS (10)
      real*4        E_B_V      (_nr_) ! (mag) Reddening E(B-V) from Schegel et al. 1998 (11)
*Note (1): In the case of an object having only an upper limit in the r-band,
*    the b_J_-r colour is defined as (b_J_-r_lim_)-10. All r-band
*    detections have b_J_-r&gt;-1.5 while this definition gives all upper
*    limits b_J_-r&lt;-9.8.
*Note (2): The number of independent spectra taken.
*    The highest quality spectrum is always spectrum 1.
*Note (3): Both redshift and identification are given separate quality flags:
*      1 for a high-quality identification or redshift
*      2 for a low-quality identification or redshift
*      3 for an unclassifiable identification or redshift
*     The quality flag is set as
*         identification quality x 10 + redshift quality
*Note (4): There are six main classifications:
*    QSO   for a spectrum with broad emission lines
*    NELG  (narrow-emission line galaxy) for a spectrum with narrow
*            emission lines
*    gal   a galaxy spectrum with no emission lines
*    star  a Galactic star spectrum
*    cont  a high signal-to-noise (S/N&gt;10) spectrum with no identifiable
*            emission of absorption features
*    ??    an unclassifiable spectrum
*  Sub-classes are contained within parentheses after the main classifications:
*    DA    a DA white dwarf
*    DB    a DB white dwarf
*    DO    a DO white dwarf
*    DZ    a DZ white dwarf
*    CV    a star with string hydrogen Balmer emission lines
*    DAM   a DA white dwarf - M-dwarf binary
*    DBM   a DB white dwarf - M-dwarf binary
*    BAL   a broad absoprtion line QSO
*  For example QSO(BAL), star(DA), star(CV).
*  If the identification has a class 2 quality then there is a ?
*    appended to the end of the identification.
*Note (5): The date is given in the format dd/mm/yyyy.
*Note (6): The 2dF field number (&lt;1000) x 10 + the 2dF spectrograph number
*     (1 or 2). e.g. field number 218 and spectrograph 2 gives 2182.
*Note (7): Signal-to-noise calculated in a 400nm to 490nm band
*Note (8): The previously known redshift is taken from:
*     Quasars and Active Galactic Nuclei (9th Ed.) Veron-Cetty M.P.,
*     Veron P., 2000, ESO Scientific Report 19, Cat. &lt;VII/215&gt;
*Note (9): the 1.4GHz radio flux is taken from the  NRAO VLA Sky Survey (NVSS),
*     Condon et al., 1998AJ....115.1693C, Cat. &lt;VIII/65&gt;
*Note (10): The X-ray flux is taken from the ROSAT All Sky Survey, Voges et al.,
*     1999A&amp;A...349..389V, Cat. &lt;IX/10&gt;; Voges et al., 2000IAUC.7432....3V.
*     Counts/s in the 0.1 to 2.4keV band were converted to flux in
*     erg/s/cm^2^ (or equivalently mW/m^2^) assuming a photon index of -2
*     giving a conversion  factor of 5.6x10^-12.
*Note (11): The reddening for a source is taken from Schlegel et al.,
*     1998ApJ...500..525S

C=============================================================================

C  Loading file '2qz10k.dat'	! List of object properties including position,
*                                 identification and redshift

C  Format for file interpretation

    1 format(
     +  A3,1X,A16,1X,I2,1X,I2,1X,F5.2,1X,A1,I2,1X,I2,1X,F4.1,1X,F8.6,
     +  1X,F9.6,1X,F5.2,1X,F5.2,1X,F6.2,1X,I1,1X,F5.3,1X,I2,1X,A11,1X,
     +  A10,1X,I4,1X,F6.2,1X,F5.3,1X,I2,1X,A11,1X,A10,1X,I4,1X,F6.2,
     +  1X,F5.3,1X,F6.1,1X,F7.4,1X,F5.3)

C  Effective file loading

      open(unit=1,file='2qz10k.dat', status='old')
      write(6,*) '....Loading file: 2qz10k.dat'
      do _i_=1,20590
        read(1,'(A199)')_ar_
        read(_ar_,1)
     +  ____(_i_),Name(_i_),RAh(_i_),RAm(_i_),RAs(_i_),DE_(_i_),
     +  DEd(_i_),DEm(_i_),DEs(_i_),RArad(_i_),DErad(_i_),bJmag(_i_),
     +  u_bJ(_i_),bJ_r(_i_),o_bJmag(_i_),z1(_i_),q_z1(_i_),id1(_i_),
     +  date1(_i_),fld1(_i_),sn1(_i_),z2(_i_),q_z2(_i_),id2(_i_),
     +  date2(_i_),fld2(_i_),sn2(_i_),zprev(_i_),F21cm(_i_),
     +  FRASS(_i_),E_B_V(_i_)
c    ..............Just test output...........
        write(6,1)
     +  ____(_i_),Name(_i_),RAh(_i_),RAm(_i_),RAs(_i_),DE_(_i_),
     +  DEd(_i_),DEm(_i_),DEs(_i_),RArad(_i_),DErad(_i_),bJmag(_i_),
     +  u_bJ(_i_),bJ_r(_i_),o_bJmag(_i_),z1(_i_),q_z1(_i_),id1(_i_),
     +  date1(_i_),fld1(_i_),sn1(_i_),z2(_i_),q_z2(_i_),id2(_i_),
     +  date2(_i_),fld2(_i_),sn2(_i_),zprev(_i_),F21cm(_i_),
     +  FRASS(_i_),E_B_V(_i_)
c    .......End.of.Just test output...........
      end do
      close(1)

C=============================================================================
      stop
      end
