c      program testread2dF_0003206
      subroutine testread2dF_0003206

      include 'mxqso.dec'

      real*4 redsh_cp(mxqso)

c      call read2dF_0003206

      call read2dF_0104_10K
      
      print*,'Enter z1,z2 '
      read(5,*)z1,z2

      j=0
      do i=1,nqso
         redsh_cp(i)=redsh(i)
         if(z1.le.redsh(i).and.redsh(i).le.z2)j=j+1
c         print*,'redsh_cp : ',redsh_cp(i)
c         print*,'ra_,dec: ',i,ra_(i),dec(i)
      enddo
      print*,'N (z1 < z <z2) = ',j

      call sort(nqso,redsh_cp)
      print*,'nqso,(nqso+1)/2,redsh_cp( (nqso+1)/2 )='
      print*,nqso,(nqso+1)/2,redsh_cp( (nqso+1)/2 )
      
      end


      subroutine read2dF_0003206
c     ---- reads in 2dF data from data published in 
c     Shanks et al. (2000) astro-ph/0003206 ----
c     or from 
c     http://www.mso.anu.edu.au/~rsmith/QSO_Survey/Downloads/wedge.ps

      parameter(pi=3.1415926536,pi_180=pi/180.0)

      include 'mxqso.dec'

c     ---- options to either read in the ascii (postscript) file
c     to write it out in binary, or to read it in as binary ----

      logical*4  readascii,writebin,readbin  
      logical*4  dodec ! Try to find dec from the ra/dec points?
      logical*4  writedec,readdec
      logical*4  writeasc_out
      logical*4  readasc_out

      character*256 fileasc,filebin,filedec, fileasc_out
      character*40  line
      character*1   ps1,ps2,ch1
      character*5   ch5a,ch5b

      integer*4     ix(mxqso),iy(mxqso)
      integer*4     jx(mxqso),jy(mxqso)
      integer*4     jofi(mxqso) ! j values corresponding to i values
c      integer*4     ifld(mxqso) ! id # of "field" 
      integer*4     ifld3(mxqso) ! id # of "field" 

      real*4        xplot(mxqso),yplot(mxqso)
      real*4        ra_2(mxqso),dec2(mxqso)

      real*4        ra_3(mxqso),dec3(mxqso),redsh3(mxqso)

      real*4        ra0(2),dec0(2) ! the real ra,dec according to a-ph/0003206
      real*4        ralim(2),declim(2,2)

      real*4        xcirc(20),ycirc(20)

      logical*4     doneraz ! Have all ra & z been done?


      data readascii /.false./ !.true./ !
      data writebin   /.false./ !.true./   !
      data readbin   /.false./ !.true./ !

      data dodec    /.true./ !.false./ !
      data writedec   /.false./ !.true./   !
      data readdec   /.true./ !.false./ !

      data writeasc_out /.false./  !.true./ !
      data readasc_out /.false./ !.true./ !


      data fileasc /'tslandwedge4.ps'/
      data filebin /'2dF0003206.dat'/
c      data filedec /'2dF0003206_3d.dat'/
      data filedec /'2dF0003206_3d.datlittleendian'/
      data fileasc_out /'2dF_0003206.txt'/

c      data fileasc /'2dFwedge000628.ps'/
c      data filebin /'2dF_Smith000628.datlittleendian'/
c      data filedec /'2dF_Smith000628_3d.dat'/
c      data fileasc_out /'2dF_000628.txt'/

      integer*4   n1a,n1b,n2a,n2b ! definition of points representings qso's

c     ---- to find these limits, use the   read(5,*)n1,m   option below ---
      data  n1a,n1b,n2a,n2b /1,3426,3613,7033/
c      data  n1a,n1b,n2a,n2b /1,6840,7028,13277/

c     ---- to find the pixel limits, find the last "0 0 255 C" for
c     one "ra-dec" box; the other is at the end of the file ----
c     'tslandwedge.ps' (arXiv:astro-ph/0003206)
      data  ralim /547.0,1969.0/ 
      data  declim /93.0,177.0,2190.0,2285.0/

c      data ralim /

c      data  ra0/-32.5, 147.5/
      data  ra0/-35.0, 147.5/ ! 26/07/00

      data  dec0/-32.5,-2.5/

c         n1a=1
c         n1b=3426
c         n2a=3613
c         n2b=7033

      if(readdec)then
         open(1,file=filedec,
     _        access='sequential',status='old',
     _        form='unformatted')
         read(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
         read(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
         close(1)
         print*,'have read ',filedec
         print*,'nqso=',nqso

         print*,'nfldtot=',nfldtot
         jj=0
         do i=1,nfldtot
            jj=jj+npfld(i)
         enddo
         print*,'read2dF: double check, jj=',jj


         if(writeasc_out)then
            open(1,file=fileasc_out,
     _           access='sequential',status='unknown',
     _           form='formatted')
            write(1,'(a)')
     _           'Downloaded from  '
            write(1,'(a)')
     _           'http://www.mso.anu.edu.au/~rsmith/QSO_Survey/'//
     _           'Downloads/wedge.ps'
            write(1,'(a)')' '
            write(1,'(a)')'converted by B.F. Roukema '//
     _           'boud@iucaa.ernet.in  dd/mm/yy'
            write(1,'(a)')' '
            write(1,'(a,i10)')' nqso=',nqso
            write(1,'(a,i10)')' nfldtot=',nfldtot
            write(1,'(a)')'------------------------------- '
            write(1,'(a)')
     _           "read(1,'(2f13.5,f8.3)')ra_(j),dec(j),redsh(j)"
            do j=1,nqso
               write(1,'(2f13.5,f8.3)')ra_(j),dec(j),redsh(j)
            enddo
            do i=1,nfldtot
               write(1,'(i10)')npfld(i)
            enddo
            do j=1,nqso
               write(1,'(i10)')ifld(j)
            enddo

            
c            write(1,'(a)')'------------------------------- '
c            write(1,'(a,i10)')' nfldtot=',nfldtot
c            write(1,'(a)')'The information on subfields  nfldtot '//
c     _           'should be taken with caution, '
c            write(1,'(a)')'and may not be useful.'
c            do i=
c            write(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
            close(1)
         endif

         return
      endif


      i=0
      if(readascii)then
         open(1,file=fileasc,access='sequential',status='old',
     _        form='formatted')

c     ---- read in x-y versions of right ascension & z ----
         doneraz=.false.
         idivider=0
         do while(1+1.eq.2.and.(.not.(doneraz)))
            read(1,'(a)',err=666,end=666)line
c            print*,'line=',line
c           read(line,'(2i4,a1,2i4,a1)',err=333)
            ps1='*'
            ps2='*'
c            read(line,'(2i,a1,2i,a1)',err=333)
            read(line,*,err=333)
     _           ix1,iy1,ps1,ix2,iy2,ps2
 333        continue
            if(ps1.eq.'M'.and.ps2.eq.'L')then
               i=i+1
c               print*,'line=',line
c               print*,ix1,iy1,ps1,ix2,iy2,ps2
               ix(i)=ix1
               iy(i)=iy1
            endif
            ps1='*'
c            read(line,'(3i,a1)',err=399)
            read(line,*,err=399)  !! works on SUN, not on DEC !!
     _           ix1,iy1,iz1,ps1
            if(ix1.eq.0.and.iy1.eq.0.and.iz1.eq.255.and.ps1.eq.'C')
     _           then
               idivider=idivider+1
               if(idivider.eq.3)doneraz=.true.  ! stop searching for ra,z
            endif
 399        continue

         enddo
 666     continue

         print*,'Number of ra,z points read = ',i
         np1=i

c     ---- read in x-y versions of right ascension & declination ----
         i=0
         do while(1+1.eq.2)
            read(1,'(a)',err=999,end=999)line
            ps1='*'
            ps2='*'
c            read(line,'(2i,a1)',err=444) 
            read(line,*,err=444)  !! works on SUN, not on DEC !!
     _           ix1,iy1,ps1
 444        continue
            if(ps1.eq.'P')then
               i=i+1
c               print*,'line=',line
c               print*,ix1,iy1,ps1
               jx(i)=ix1
               jy(i)=iy1
            endif
         enddo
 999     continue

         close(1)

         print*,'Number of points ra,dec points read = ',i
         np2=i

      endif

      if(readasc_out)then
         open(1,file=fileasc_out,
     _        access='sequential',status='old',
     _        form='formatted')
         do i=1,9
            line='                                        '
            read(1,'(a)')line
            print*,i,'-th header line= ',line
            if(i.eq.6)then
               read(line(7:16),'(i)')nqso
               print*,'nqso=',nqso
            endif
            if(i.eq.7)then
               read(line(10:19),'(i)')nfldtot
               print*,'nfldtot=',nfldtot
            endif
         enddo

         do j=1,nqso
            read(1,'(2f13.5,f8.3)')ra_(j),dec(j),redsh(j)
         enddo
         do i=1,nfldtot
            read(1,'(i10)')npfld(i)
         enddo
         do j=1,nqso
            read(1,'(i10)')ifld(j)
         enddo

         print*,'nqso=',nqso," qso's read."
         print*,'nfldtot=',nfldtot

         close(1)


         if(writedec)then
            open(1,file=filedec,
     _           access='sequential',status='unknown',
     _           form='unformatted')
            write(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
            write(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
            close(1)
            print*,'have written ',filedec
         endif

         return
      endif


      if(writebin)then
         open(1,file=filebin,access='sequential',status='unknown',
     _           form='unformatted')
         write(1)np1,(ix(i),iy(i),i=1,np1)
         write(1)np2,(jx(i),jy(i),i=1,np2)
         close(1)
         print*,'have written ',filebin
      endif

      if(readbin)then
         open(1,file=filebin,access='sequential',status='old',
     _           form='unformatted')
         read(1)np1,(ix(i),iy(i),i=1,np1)
         read(1)np2,(jx(i),jy(i),i=1,np2)
         close(1)
         print*,'have read ',filebin,' np1,np2=',np1,np2
      endif


c      if(.not.(readasc_out))then
c     ---- some analysis of postscript file relevant to both useful
c     version of data and plotting version of data ----

         xmin=9e9
         xmax=-9e9
         ymin=9e9
         ymax=-9e9

c     --- centre using pgdisp

         xc=1259.0
         yc=1180.0

         x_z3= 611.0
         y_z3= 460.0
         dhMpc=3000.0

         scale= dhMpc/sqrt( (xc-x_z3)*(xc-x_z3) + 
     _        (yc-y_z3)*(yc-y_z3) )

c     ---- convert from postscript integers to x-y real*4 ----
         do i=1,np1
            xplot(i)=ix(i)
            xmin=min(xmin,xplot(i))
            xmax=max(xmax,xplot(i))
            yplot(i)=iy(i)
            ymin=min(ymin,yplot(i))
            ymax=max(ymax,yplot(i))
         enddo

c     ---- evaluation for use by other subroutines, programmes ----
         qin= 0.5
         Hin=100.0
         ccin= 0.0
         j=0

         do k=min(n1a,n2a),max(n1b,n2b)
            jofi(k)=0
            ifld(k)=0
         enddo
         nfldtot=0

         
         do ihemisph=1,2
            if(ihemisph.eq.1)then
               i1=n1a
               i2=n1b
            elseif(ihemisph.eq.2)then
               i1=n2a
               i2=n2b
            endif
            ramax=-9e9
            ramin=9e9
            do i=i1,i2
               j=j+1
               xx=xplot(i)-xc
               yy=yplot(i)-yc
               d1= sqrt(xx*xx+yy*yy)*scale

               z= zofpdW(qin,Hin,ccin, d1)
               redsh(j)= z
               
               if(max(abs(xx),abs(yy)).lt.1e-4)then
                  print*,'read2dF WARNING: i,j,xx,yy=',i,j,xx,yy
               endif
               
               if(abs(xx).gt.1e-4)then
                  theta=atan(yy/xx) /pi_180
                  if(xx.lt.0.0)then
                     theta=theta+ 180.0
                  elseif(xx.gt.0.0.and.yy.lt.0.0)then
                     theta=theta+ 360.0
                  endif
               else
                  if(yy.gt.1e-4)then
                     theta=90.0
                  elseif(yy.le.-1e-4)then
                     theta=270.0
                  else
                     print*,'read2dF WARNING: i,j,xx,yy=',
     _                    i,j,xx,yy
                  endif
               endif
               
c     ! warning: following is a very rough delta only
               if(yy.gt.0.0)then
                  dec(j)=0.0
               else
                  dec(j)=-30.0
               endif

c     ! warning: precision is _not_ real*8 precision !
c     ! warning: following is not the correct r.a., but is OK for
c     internal calculation

               ra_(j)= theta    !*cos(dec(j)*pi_180)
               ramax=max(ramax,real(ra_(j)))
               ramin=min(ramin,real(ra_(j)))


               if((1+1.eq.3).and.(i.eq.i1.or.i.eq.i2))then
                  print*,'read2dF: i=',i
                  print*,'j,redsh(j),ra_(j),dec(j)=',
     _                 j,redsh(j),ra_(j),dec(j)
               endif

            enddo               !      do i=i1,i2

            
            print*,'read2dF: ihemisph, ramax,ramin,ramax-ramin=', 
     _           ihemisph, ramax,ramin,ramax-ramin

c     ==== search for correpondance ra-z <-> ra-dec ====
            if(dodec)then
               if(ihemisph.eq.1)then
                  k1=1
                  k2=i2-i1+1
               else
                  k1=k2 + 1
                  k2=k2 + i2-i1+1
               endif
               print*,'read2dF: ihemisph, k1,k2=',ihemisph, k1,k2
               if(k2.ne.j)then
                  print*,'WARNING, possible ERROR: k2,j = ',k2,j 
               endif

c     -- set up ra estimates --

c     ---- "hard-wired" corrections ----
               if(ihemisph.eq.1)ramin=ramin+0.2
               if(ihemisph.eq.2)then
                  ramin=ramin-0.2   - 0.1
                  ramax=ramax       - 0.1
               endif

               rascale=(ramax-ramin)/(ralim(2)-ralim(1))

               if(ihemisph.eq.1)then
                  decmin=dec0(1) !-32.5
                  do k=k1,k2
                     ra_2(k)= ramin + 
     _                    ( real(jx(k))-ralim(1) )*rascale
                     dec2(k)= decmin + ( real(jy(k))-declim(1,1) )
     _                    *rascale
     _                    /cos(30.0*pi_180) !! error by Shanks et al. !!

                  enddo
               else
                  decmin=dec0(2) !-2.5
                  do k=k1,k2
                     ra_2(k)= ramin + 
     _                    ( ralim(2)-real(jx(k)) )*rascale
                     dec2(k)= decmin + ( real(jy(k))-declim(1,2) )
     _                    *rascale
                  enddo
               endif

               ifldmin=30
               tolalpha=0.5

               print*,'will call finddec...'
               call finddec(i1,i2,k1,k2,ifldmin,tolalpha,ra_2,
     _              jofi)       ! ,nfldtot,ifld)

               xx=0.0
               xxsd=0.0
               xxmax=-9e9

               ifound=0
               do k=k1,k2
                  if(jofi(k).gt.0)then
                     xx=xx+  abs( real(ra_(k)) - ra_2(jofi(k)) )
                     xxsd=xxsd+  ( real(ra_(k)) - ra_2(jofi(k)) )
     _                    * ( real(ra_(k)) - ra_2(jofi(k)) )
                     xxmax=max(xxmax,  
     _                    ( real(ra_(k)) - ra_2(jofi(k)) ))
                     ifound=ifound+1
                  endif
               enddo
               if(ifound.gt.1)then
                  print*,'ihemisph,xx/real(ifound),ifound=',
     _                 ihemisph,xx/real(ifound),ifound
                  print*,'sqrt(xxsd/real(ifound-1)),xxmax=',
     _                 sqrt(xxsd/real(ifound-1)),xxmax
               endif
               if(ihemisph.eq.1)then
                  idec1=ifound
               elseif(ihemisph.eq.2)then
                  idec2=ifound
               endif

c     ---- convert ra from x-y plotting angle to real ra ----
               do k=k1,k2
                  if(jofi(k).gt.0)then
                     ra_2(k)=ra_2(k) -ramin + ra0(ihemisph)
                  endif
               enddo

            endif               ! if(dodec)then

         enddo                  !      do ihemisph=1,2




         print*,'idec1,idec2=',idec1,idec2
         nqso=j
         print*,'read2df: no of qsos nqso=',nqso

c      endif                     !      if(.not.(readasc_out))then

      if(dodec)then
         if(writedec)then
            j=0
c            do k=k1,k2
            do k=1,n2b
               if(jofi(k).gt.0)then
                  j=j+1
c                  ra_3(j)=ra_(k)
                  ra_3(j)=ra_2(k)  ! more precise than ra_(k)
                  redsh3(j)= redsh(k)
                  
c                  dec3(j)= dec2(j)
                   dec3(j)= dec2(k) ! j->k corrected 17/05/00 from above line
                   ifld3(j)= ifld(k)
               endif
            enddo
            nqso=j
            print*,'Will write filedec with nqso=',nqso
            do j=1,nqso
               ra_(j)=ra_3(j)
               dec(j)=dec3(j)
               redsh(j)=redsh3(j)
               ifld(j)=ifld3(j)
            enddo

            open(1,file=filedec,
     _           access='sequential',status='unknown',
     _           form='unformatted')
            write(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
            write(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
            close(1)
            print*,'have written ',filedec

         endif

         if(readdec)then
            open(1,file=filedec,
     _           access='sequential',status='old',
     _           form='unformatted')
            read(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
            read(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
            close(1)
            print*,'have read ',filedec

         endif

      endif


      if(1+1.eq.3)then
         xmin=-400.0             ! 300.0
         xmax=2800.0 !2300.0
         ymin=xmin
         ymax=xmax

         fact=1.5
         yheight=3100.0 *fact
         cvt_Mpc_inch= 1.0/ ( 3000.0/(123.0/25.4) )
         cvt_Mpc_inch=cvt_Mpc_inch /fact

cc     ---- to find pixel centres xc,yc, ralim, declim ----
c         fact=1.0
c         yheight= 

         ymin= -yheight
         ymax=  yheight
         xmin= -yheight*0.7
         xmax= yheight*0.7

         q_0=-0.55!0.5 ! 
         H_0=100.0
         cc_0=0.7 !0.0! 


         vy1=0.4
         vy2=vy1+(ymax-ymin)* cvt_Mpc_inch
         vx1=0.2
         vx2=vx1+ (xmax-xmin)* cvt_Mpc_inch


         do i=1,np1
            call cvtcurv(0.5,H_0,0.0,xc,yc, scale, !x_z3,y_z3, dhMpc,
     _           xplot(i),yplot(i), 
     _           q_0,H_0,cc_0,xout,yout)
            xplot(i)=xout 
            yplot(i)=yout
         enddo
            
         call pgbegin(0,'?',1,1)
         call pgslw(3)
         call pgscf(2)
c         call pgvsize(1.0,7.0,1.0,7.0)

         call pgvsize(vx1,vx2,vy1,vy2)
         call pgwindow(xmin,xmax,ymin,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)

c         n1a=1
c         n1b=3426
c         n2a=3613
c         n2b=7033

         call pgpoint(n1b-n1a+1,xplot(n1a),yplot(n1a),1)
         call pgpoint(n2b-n2a+1,xplot(n2a),yplot(n2a),1)
         ntot=n1b-n1a +1 + n2b-n2a+1
         print*,'ntot=',ntot

         n1=5000

         m=100
c         write(6,'(a)')'Enter n1, m: '
c         read(5,*)n1,m


c         call pgpoint(n1,xplot,yplot,1)
         do i=1,-22
            write(6,'(a,5i7)')
     _           'n1,m,i,n1+(i-1)*m+1), ... =',
     _           n1,m,i,n1+(i-1)*m+1, n1+(i-1)*m +m
            call pgpoint(m,xplot(n1+(i-1)*m+1),yplot(n1+(i-1)*m+1),1)
            read(5,'(a)')ch1
         enddo

         x0= -2000.0
         y0= 0.0
         radius=130.0/2.0
c         pi=3.1415926536
         do i=1,20
            xcirc(i)=x0 + radius* cos(2.0*pi*real(i-1)/19.0)
            ycirc(i)=y0 + radius* sin(2.0*pi*real(i-1)/19.0)
         enddo
         call pgline(20-1, xcirc,ycirc)

         x0= -5000.0
         radius=130.0/2.0
         y0= -radius
c         pi=3.1415926536
         do i=1,20
            xcirc(i)=x0 + radius* cos(2.0*pi*real(i-1)/19.0)
            ycirc(i)=y0 + radius* sin(2.0*pi*real(i-1)/19.0)
         enddo
         call pgline(20-1, xcirc,ycirc)

         radius=130.0/2.0
         x0= -5000.0 +radius
         y0= radius
c         pi=3.1415926536
         do i=1,20
            xcirc(i)=x0 + radius* cos(2.0*pi*real(i-1)/19.0)
            ycirc(i)=y0 + radius* sin(2.0*pi*real(i-1)/19.0)
         enddo
         call pgline(20-1, xcirc,ycirc)


         write(ch5a,'(f5.1)')2.0*(q_0+cc_0)
         write(ch5b,'(f5.1)')cc_0
         call pgsch(1.0)
         call pgptxt(500.0,0.0,0.0,0.0,
     _        '\\gW\\d0\\u='//ch5a//', \\gl\\d0\\u='//ch5b)

         call pgend
      endif ! end of testing section

      return
      end




      subroutine cvtcurv(qin,Hin,ccin,xc,yc, scale, !x_z3,y_z3, dhMpc,  !inputs
     _     xin,yin,             !inputs
     _     q_0,H_0,cc_0,xout,yout) !outputs

c     ==== based on the euclidean distance from (xc,yc) to (xin,yin)
c     assuming (qin,Hin,ccin) for the z-pdWein relation, i.e. 
c     assuming no tangential corrections for curvature, 
c     and assuming 
c     that  scale  gives the scale in h^1Mpc/psplot units
c     %%%%that the point (x_z3,y_z3) is at a distance of  dhMpc
c
c     in order to get the scale correct, 
c     the 
c     z-pdWein relation is recalculated for (q_0,H_0,cc_0) in order
c     to give (xout,yout)

      real*4   scale   ! (h^-1 Mpc) per plot unit

c      save   ifirst,scale

c      if(ifirst.ne.12345)then
c         ifirst=12345
c         scale= dhMpc/sqrt( (xc-x_z3)*(xc-x_z3) + 
c     _        (yc-y_z3)*(yc-y_z3) )
c      endif

      xx=xc-xin
      yy=yc-yin
      d1= sqrt(xx*xx+yy*yy)*scale

      z= zofpdW(qin,Hin,ccin, d1)
      d2= pdWein(q_0,H_0,cc_0, z)
      if(d1.gt.1e-4)then
         ratio=d2/d1
      else
         ratio=0.0
      endif
      
c      xout= xc + ratio* (xin-xc)
c      yout= yc + ratio* (yin-yc)
      xout=  ratio* (xin-xc) *scale
      yout=  ratio* (yin-yc) *scale
 
      return
      end


      subroutine finddec(i1,i2,k1,k2,ifldmin,tolalpha,ra_2, ! input 
     _     jofi) !,nfldtot,ifld)      ! output

c     ==== compares lists of ra estimates among two lists and
c     gives the best resulting matches via the index  jofi ====


C     INPUTS:
      include 'mxqso.dec' ! has declaration for mxqso= and ra_(mxqso)
      real*4        ra_2(mxqso)

C     INPUTS + OUTPUTS:
      integer*4     nfld
      integer*4     jofi(mxqso) ! j values corresponding to i values      
c      integer*4     ifld(mxqso) ! id # of "field" 

C     LOCAL:
      integer*4     iadvmin
      real*4        raplot(mxqso),dplot(mxqso)


      iadvmin=3
      
      ntest=ifldmin
      k0=k1
      ioff1=-3500
      ioff2=3500
c      ioff1=-7000
c      ioff2=7000

      do while(k0+ifldmin-1.le.i2)
         xxmin=9e9
         xxsd0=9e9
         xxmax0=-9e9

c     ---- find set for which  ntest values match within  tolapha ---
         do ioffset=ioff1,ioff2
            xx=0.0
            xxsd=0.0
            xxmax=-9e9
            itested=0
            do k=k0,k0+ntest-1
               if(i1.le.k+ioffset.and.k+ioffset.le.i2)then
                  xx=xx+ abs( real(ra_(k)) - ra_2(k+ioffset) )
                  xxsd=xxsd+ ( real(ra_(k)) - ra_2(k+ioffset) )
     _                 *( real(ra_(k)) - ra_2(k+ioffset) )
                  xxmax=max(xxmax, 
     _                 abs( real(ra_(k)) - ra_2(k+ioffset) ))
                  itested=itested+1
               endif
            enddo
            if(itested.gt.1.and.xx/(real(itested)).lt.xxmin)then
               xxmin=xx/(real(itested))
               xxsd0=sqrt( xxsd/(real(itested-1)) )
               xxmax0=xxmax
               ioff0=ioffset
               itest0=itested
            endif
         enddo

         if(1+1.eq.3)then
            print*,'k0,xxmin,xxsd0,xxmax0,ioff0=',
     _           k0,xxmin,xxsd0,xxmax0,ioff0
         endif
c         print*,'itest0=',itest0

         k=k0
         diff=abs( real(ra_(k)) - ra_2(k+ioff0) )
         do while(k.lt.k0+ntest-1.and.diff.gt.tolalpha)
            k=k+1
            diff=abs( real(ra_(k)) - ra_2(k+ioff0) )
         enddo
         if(k.gt.k0.and.k.lt.k0+ntest-1)then
            k0_1 = k-1
         else
            k0_1 = k
         endif

c     ---- find "middle" subset, 
c     plus extra remaining members of set which match with same
c     offset ----
         k=k0_1 !+ 1
         xxmax=abs( real(ra_(k)) - ra_2(k+ioff0) )
         do while(k.lt.k2.and.xxmax.le.tolalpha)
            k=k+1
            xxmax=max(xxmax, 
     _           abs( real(ra_(k)) - ra_2(k+ioff0) ))
         enddo
         if(k.gt.k0_1.and.k.lt.k2)then
            k0_2=k-1
         else
            k0_2=k
         endif

c     ---- evaluate index  jofi ----
         if(k0_2-k0_1+1.ge.ifldmin)then
            nfldtot=nfldtot+1
            do k=k0_1,k0_2
               jofi(k)=k+ioff0
               ifld(k)=nfldtot
            enddo
            npfld(nfldtot)= k0_2-k0_1+1

c            print*,'k0_1,k0_2,ioff0=',k0_1,k0_2,ioff0,'  OK',
c     _           '       k0_2-k0_1+1=',k0_2-k0_1+1
         else
            k0_2=max(k0_2, k0_1 + iadvmin)  ! iadvmin is min for advancing
            do k=k0_1,k0_2
               jofi(k)=-99
               ifld(k)=-99
            enddo
c            print*,'k0_1,k0_2,ioff0=',k0_1,k0_2,ioff0,' NOT ok'
         endif
         
c     ---- double check ----
c         if(k0_2-k0_1+1.ge.ifldmin)then
         if(jofi(k0_2).gt.0)then
            do k=k0_1,k0_2
               diff=real(ra_(k)) - ra_2(jofi(k))
               if(abs(diff).gt.tolalpha)then
                  print*,'WARNING: k1,k2,k0_1,k0_2,k=',
     _                 k1,k2,k0_1,k0_2,k
                  print*,'jofi(k),ra_(k),ra_2(jofi(k))=',
     _                 jofi(k),ra_(k),ra_2(jofi(k))
               endif
            enddo
         endif

         k0=k0_2+1
         
      enddo                     !      do while(k0+ifldmin-1.le.k2)

      if(1+1.eq.3)then
         xmin=real(k1)-1.0
         xmax=real(k2)+1.0
         ymax=-9e9
         print*,'will plot k=k1,k2; k1,k2=',k1,k2
         do k=k1,k2
            raplot(k)=real(k)
            if(jofi(k).gt.0)then
               dplot(k)= ra_2(jofi(k))-real(ra_(k))
            else
               dplot(k)=-99.9
            endif
c            if(ihemisph.eq.2.and.1+1.eq.3)then
c               print*,'test: k,ioff0,ra_2(k+ioff0),ra_(k)=',
c     _              k,ioff0,ra_2(k+ioff0),ra_(k)
c            endif
            if(dplot(k).gt.-99.0)ymax=max(ymax,dplot(k))
         enddo

         ymax= 1.0!0.5! 250.0!

c         if(ihemisph.eq.1)then
c            xmin=0.0! 800.0
c            xmax=3500.0! 1200.0
c            ymax=0.5
c         else
c            xmin=3500.0!4200.0
c            xmax=6900.0! 4800.0
c            ymax=0.5
c         endif

         call pgbegin(0,'?',1,1)
         call pgslw(3)
         call pgscf(2)
         call pgvsize(1.0,7.0,1.0,7.0)
         call pgwindow(xmin,xmax,-ymax,+ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgpoint(k2-k1+1,raplot(k1),dplot(k1),22)
         call pglabel('i','\\ga\\d2\\u - \\ga\\d1\\u',' ')
         call pgend
      endif

      print*,'end of finddec: nfldtot=',nfldtot

      return
      end




      subroutine read2dF_0104_10K

      real*8   pi,pi_180
      parameter(pi=3.1415926536d0,pi_180=pi/180.0d0)

      include 'mxqso.dec'

      character*256 fileasc,filebin

      logical*4  readascii,writebin,readbin  

      data readascii /.false./ !.true./   !
      data writebin   /.false./ !.true./  !
      data readbin   /.true./ !.false./  !

      data fileasc /'2qz10k.dat'/
      data filebin /'2QZ0104_10K.dat'/


C=============================================================================
C     F77-compliant program generated by readme2f_1.0, on 2001-May-01
C=============================================================================
*     This code was generated from the ReadMe file documenting a catalogue
*     according to the "Standard for Documentation of Astronomical Catalogues"
*     currently in use by the Astronomical Data Centers (CDS, ADC, A&amp;A)
*     (see full documentation at URL <A HREF="http://vizier.u-strasbg.fr/doc/catstd.htx">http://vizier.u-strasbg.fr/doc/catstd.htx</A>)
*     Please report problems or questions to   <A HREF="mailto:question@simbad.u-strasbg.fr">question@simbad.u-strasbg.fr</A>
C=============================================================================

c      implicit none
*     Unspecified or NULL values, generally corresponding to blank columns,
*     are assigned one of the following special values:
*     XrNULLX    for unknown or NULL floating-point values
*     XiNULLX    for unknown or NULL   integer      values
      real*4     XrNULLX
      integer*4  XiNULLX
      parameter  (XrNULLX=-1.e37) ! NULL real number
      parameter  (XiNULLX=-2147483647) ! NULL int  number

C=============================================================================
C     at. VII/223       The 2dF QSO Redshift Survey. V. The 10k catalogue   (Croom+ 2001)
*================================================================================
*     The 2dF QSO Redshift Survey - V. The 10k catalogue.
*     Croom S.M., Smith R.J., Boyle B.J., Shanks T., Loaring N.S., Miller L.,
*     Lewis I.J.
*     &lt;Mon. Not. R. Astron. Soc. 322, L29 (2001)&gt;
*     =2001MNRAS.322L..29C
C=============================================================================

C     Internal variables

      integer*4 i__

c     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

C     Declarations for '2qz10k.dat'	
c     ! List of object properties including position,
c     ! identification and redshift

      integer*4 XnrX
      parameter (XnrX=20590)	! Number of records
      character*199 XarX   	! Full-size record

      character*3   XXXX       (XnrX) ! [2QZ] Name of Survey
      character*16  Nametwoq       (XnrX) ! Nametwoq of the source in 2QZ
      integer*4     RAh        (XnrX) ! (h) Right ascension (J2000)
      integer*4     RAm        (XnrX) ! (min) Right ascension (J2000)
      real*4        RAs        (XnrX) ! (s) Right ascension (J2000)
      character*1   DE_        (XnrX) ! Declination sign
      integer*4     DEd        (XnrX) ! (deg) Declination (J2000)
      integer*4     DEm        (XnrX) ! (arcmin) Declination (J2000)
      real*4        DEs        (XnrX) ! (arcsec) Declination (J2000)
      real*8        RArad      (XnrX) ! (rad) Right ascension (J2000)
      real*8        DErad      (XnrX) ! (rad) Declination (J2000)
      real*4        bJmag      (XnrX) ! (mag) b_J_ magnitude
      real*4        u_bJ       (XnrX) ! (mag) u-b_J_ colour
      real*4        bJ_r       (XnrX) ! (mag) b_J_-r colour (1)
      integer*4     o_bJmag    (XnrX) ! Number of observations (2)
      real*4        z1         (XnrX) ! Redshift from first spectrum
      integer*4     q_z1       (XnrX) ! Quality flag for first spectrum (3)
      character*11  id1        (XnrX) ! Identification for first spectrum (4)
      character*10  date1      (XnrX) ! ("D/M/Y") Date of observation for first spectrum (5)
      integer*4     fld1       (XnrX) ! field and spectrograph for first spectrum (6)
      real*4        sn1        (XnrX) ! Signal-to-noise ratio for first spectrum (7)
      real*4        z2         (XnrX) ! ?=0 Redshift from second spectrum
      integer*4     q_z2       (XnrX) ! Quality flag for second spectrum (3)
      character*11  id2        (XnrX) ! Identification for second spectrum  (4)
      character*10  date2      (XnrX) ! ("D/M/Y") ?Date of observation for second spectrum (5)
      integer*4     fld2       (XnrX) ! field and spectrograph for second spectrum (6)
      real*4        sn2        (XnrX) ! Signal-to-noise ratio for second spectrum (7)
      real*4        zprev      (XnrX) ! ?=0 Redshift if previously known (8)
      real*4        F21cm      (XnrX) ! (mJy) ?=0 Flux at 1.4GHz from NVSS (9)
      real*8        FRASS      (XnrX) ! (mW/m2) ?=0 Flux at 0.1-2.4keV x 10^-13 from RASS (10)
      real*4        E_B_V      (XnrX) ! (mag) Reddening E(B-V) from Schegel et al. 1998 (11)
*     Note (1): In the case of an object having only an upper limit in the r-band,
*     the b_J_-r colour is defined as (b_J_-r_lim_)-10. All r-band
*     detections have b_J_-r&gt;-1.5 while this definition gives all upper
*     limits b_J_-r&lt;-9.8.
*     Note (2): The number of independent spectra taken.
*     The highest quality spectrum is always spectrum 1.
*     Note (3): Both redshift and identification are given separate quality flags:
*     1 for a high-quality identification or redshift
*     2 for a low-quality identification or redshift
*     3 for an unclassifiable identification or redshift
*     The quality flag is set as
*     identification quality x 10 + redshift quality
*     Note (4): There are six main classifications:
*     QSO   for a spectrum with broad emission lines
*     NELG  (narrow-emission line galaxy) for a spectrum with narrow
*     emission lines
*     gal   a galaxy spectrum with no emission lines
*     star  a Galactic star spectrum
*     cont  a high signal-to-noise (S/N&gt;10) spectrum with no identifiable
*     emission of absorption features
*     ??    an unclassifiable spectrum
*     Sub-classes are contained within parentheses after the main classifications:
*     DA    a DA white dwarf
*     DB    a DB white dwarf
*     DO    a DO white dwarf
*     DZ    a DZ white dwarf
*     CV    a star with string hydrogen Balmer emission lines
*     DAM   a DA white dwarf - M-dwarf binary
*     DBM   a DB white dwarf - M-dwarf binary
*     BAL   a broad absoprtion line QSO
*     For example QSO(BAL), star(DA), star(CV).
*     If the identification has a class 2 quality then there is a ?
*     appended to the end of the identification.
*     Note (5): The date is given in the format dd/mm/yyyy.
*     Note (6): The 2dF field number (&lt;1000) x 10 + the 2dF spectrograph number
*     (1 or 2). e.g. field number 218 and spectrograph 2 gives 2182.
*     Note (7): Signal-to-noise calculated in a 400nm to 490nm band
*     Note (8): The previously known redshift is taken from:
*     Quasars and Active Galactic Nuclei (9th Ed.) Veron-Cetty M.P.,
*     Veron P., 2000, ESO Scientific Report 19, Cat. &lt;VII/215&gt;
*     Note (9): the 1.4GHz radio flux is taken from the  NRAO VLA Sky Survey (NVSS),
*     Condon et al., 1998AJ....115.1693C, Cat. &lt;VIII/65&gt;
*     Note (10): The X-ray flux is taken from the ROSAT All Sky Survey, Voges et al.,
*     1999A&amp;A...349..389V, Cat. &lt;IX/10&gt;; Voges et al., 2000IAUC.7432....3V.
*     Counts/s in the 0.1 to 2.4keV band were converted to flux in
*     erg/s/cm^2^ (or equivalently mW/m^2^) assuming a photon index of -2
*     giving a conversion  factor of 5.6x10^-12.
*     Note (11): The reddening for a source is taken from Schlegel et al.,
*     1998ApJ...500..525S

C=============================================================================



      if(readascii)then

C     Loading file '2qz10k.dat'	! List of object properties including position,
*     identification and redshift

C     Format for file interpretation

 1       format(
     +        A3,1X,A16,1X,I2,1X,I2,1X,F5.2,
     _        1X,A1,I2,1X,I2,1X,F4.1,1X,F8.6,
     +        1X,F9.6,1X,F5.2,1X,F5.2,1X,F6.2,
     _        1X,I1,1X,F5.3,1X,I2,1X,A11,1X,
     +        A10,1X,I4,1X,F6.2,1X,F5.3,1X,I2,
     _        1X,A11,1X,A10,1X,I4,1X,F6.2,
     +        1X,F5.3,1X,F6.1,1X,F7.4,1X,F5.3)

C     Effective file loading

         open(unit=1,file='2qz10k.dat', status='old')
         write(6,*) '....Loading file: 2qz10k.dat'
         do i__=1,20590
            read(1,'(A199)')XarX
            read(XarX,1)
     +           XXXX(i__),Nametwoq(i__),RAh(i__),
     _           RAm(i__),RAs(i__),DE_(i__),
     +           DEd(i__),DEm(i__),DEs(i__),RArad(i__),
     _           DErad(i__),bJmag(i__),
     +           u_bJ(i__),bJ_r(i__),o_bJmag(i__),
     _           z1(i__),q_z1(i__),id1(i__),
     +           date1(i__),fld1(i__),sn1(i__),
     _           z2(i__),q_z2(i__),id2(i__),
     +           date2(i__),fld2(i__),sn2(i__),
     _           zprev(i__),F21cm(i__),
     +           FRASS(i__),E_B_V(i__)
c     ..............Just test output...........
c     write(6,1)
c     +  XXXX(i__),Nametwoq(i__),RAh(i__),RAm(i__),RAs(i__),DE_(i__),
c     +  DEd(i__),DEm(i__),DEs(i__),RArad(i__),DErad(i__),bJmag(i__),
c     +  u_bJ(i__),bJ_r(i__),o_bJmag(i__),z1(i__),q_z1(i__),id1(i__),
c     +  date1(i__),fld1(i__),sn1(i__),z2(i__),q_z2(i__),id2(i__),
c     +  date2(i__),fld2(i__),sn2(i__),zprev(i__),F21cm(i__),
c     +  FRASS(i__),E_B_V(i__)
c     .......End.of.Just test output...........
         end do
         close(1)

C=============================================================================
         
         iq=0
         nfldtot=-99

         do ix=1,XnrX

            if( 
     _           (11.le.q_z1(ix).and.q_z1(ix).le.22.and.
     _           (id1(ix)(1:3).eq.'QSO')) !.or.id1(ix)(1:4).eq.'NELG'))
     _           .or.
     _           (11.le.q_z2(ix).and.q_z2(ix).le.22.and.
     _           (id2(ix)(1:3).eq.'QSO'))! .or.id2(ix)(1:4).eq.'NELG'))
     _           )then
               
               iq=iq+1

               name(iq)=nametwoq(ix)
               ra_(iq)= RArad(ix) /pi_180 !!!!/15.0d0
               if(ra_(iq).gt.315.0d0) ra_(iq)= ra_(iq)-360.0d0 ! continuity through 0h !
               
               dec(iq)= DErad(ix) /pi_180

               zz=0.0
               iz=0
               ifld(iq)= -99
               if(11.le.q_z2(ix).and.q_z2(ix).le.22.and.
     _              (id2(ix)(1:3).eq.'QSO')
c     _              .or.id2(ix)(1:4).eq.'NELG'
     _              )then
                  zz=zz+z2(ix)
                  iz=iz+1
c                  ifld(iq)= fld2(ix)
               endif

               if(11.le.q_z1(ix).and.q_z1(ix).le.22.and.
     _              (id1(ix)(1:3).eq.'QSO')
c     _              .or.id1(ix)(1:4).eq.'NELG'
     _              )then
                  zz=zz+z1(ix)
                  iz=iz+1
                  ifld(iq)= fld1(ix)/10
c    [ comment caduc : overrides fld2 if both present -> should be OK ]
               endif
               nfldtot=max(nfldtot,ifld(iq))

               if(iz.le.0)then
                  print*,'ERROR in read2dF... !!'
                  redsh(iq)= -99.9
               else
                  redsh(iq)= zz/real(iz)
               endif

               redsh(iq)=z1(ix)
                  
c               print*,'test:',real(ra_(iq)),real(dec(iq)),
c     _              q_z1(ix),z1(ix) !,q_z2(ix),z2(ix)


            endif               ! if(11.le.q_z1(ix).and. [etc.]
         enddo                  !      do ix=1,XnrX
         
         nqso=iq

         print*,'nqso=',nqso
         print*,'nfldtot=',nfldtot

         do ifd=1,nfldtot
            npfld(ifd)=0
         enddo
         do iq=1,nqso
            if(1.le.ifld(iq).and.ifld(iq).le.nfldtot)then
               npfld(ifld(iq))=npfld(ifld(iq))+1
            else
               print*,'Warning: iq, ifld(iq)=',iq, ifld(iq)
            endif
         enddo
         print*,'(npfld(i),i=1,nfldtot)'
         print*,(npfld(i),i=1,nfldtot)

         print*,'Have finished analysing 2QZ input ascii file.'
         print*,' '
      endif                     !if(readascii)then

      if(writebin)then
         open(1,file=filebin,
     _        access='sequential',status='unknown',
     _        form='unformatted')
         write(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
         write(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
         close(1)
         print*,'have written ',filebin
      endif


      if(readbin)then
         open(1,file=filebin,
     _        access='sequential',status='old',
     _        form='unformatted')
         read(1)nqso,(ra_(j),dec(j),redsh(j),j=1,nqso)
         read(1)nfldtot,(npfld(i),i=1,nfldtot),(ifld(j),j=1,nqso)
         close(1)
         print*,'have read ',filebin
      endif

      return
      end

