c      program load_ReadMe
      subroutine load_ReadMe

      parameter(pi=3.14159265359,pi_180=pi/180.0)
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'
      
      include 'lyabs/mxlyabs.dec'


C     INTERNAL:
      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)
      real*4        pdW(mxqso)
      real*4        Bmag(mxqso)
      real*4        xwed(mxqso,2),ywed(mxqso,2) 

c     --- boundaries of wedge ---
      parameter(mxc=30)
      real*4        circle(mxc,2,2) !
      real*4        edge(mxc,2,2)

c     --- circle of size \llss for illustration ---
      real*4        xcirc(20,2),ycirc(20,2)

      integer*4     irefs(mxqso)
      parameter(conh=3000.0,tolcurv=0.01)

      character*256  string

      logical*4     domagplot
      logical*4     dogalplot ! gal coords plot

      logical*4     do_abs ! add "lyabs" absorbers
      logical*4     do_arb ! add "arbitrary" points


      data domagplot / .false./ !.true. / !
      data dogalplot / .false./ !.true. / !
      data do_abs   / .false./ !.true. / !
      data do_arb   /.true. / ! .false./ !


c      call readVeron
      call readIovino
      call smooIov! added 16/06/00

c      if(do_abs)call readlyabs

c      call bkupVeron

c      call read2dF_0003206

c      do i=1,nqso
c         print*,name(i),ra_(i),dec(i),l_z(i),z(i)
c      enddo

c      call cleanVeron

      zmax1=-9e9
      do i=1,nqso
         zmax1=max(zmax1,redsh(i))
      enddo
      print*,'zmax1=',zmax1

c      call cutVeron(320.0,326.0,-47.0,-42.0)
c      call cutVeron(329.0,335.0,-22.0,-16.0)
c      call cutVeron(155.0,260.0,46.2,47.8)
c      call cutVeron(-0.1,361.0,10.0,20.0)

c      call cutVeron(10.0,30.0,-42.5,-37.0)

c      call cutVeron(10.0,16.0, -43.0,-26.0)
c      call cutVeron(172.0,190.0,-11.5,-11.0) !7  ! the -11 slice !

c      call cutzVeron(1.8,2.4)

      irefs(1)=729
      irefs(2)=433
      nref=2
c      call cutrefVeron(1,irefs(1))
      print*,'After cutrefVeron: nqso=',nqso

      do i=1,0 !nqso !,100
         write(6,'(i4,a18,2f6.1,a2,f7.2,3i6)')
     _        i,name(i),ra_(i),dec(i),l_z(i),redsh(i),
     _        FC(i),r_Vmag(i),r_z(i)
         print*,ra_(i),dec(i),r_z(i)
      enddo
      

C      i1=icount8Veron(nqso,ra_, 10.0d0, 16.0d0)
C      i2=icount8Veron(nqso,ra_, 16.0d0, 23.0d0)
C      i3=icount8Veron(nqso,ra_, 23.0d0, 30.0d0)
C      
C      call ranx8Veron(i1,ra_(1),10.0d0, 16.0d0)
C      call ranx8Veron(i2,ra_(i1+1),16.0d0, 23.0d0)
C      call ranx8Veron(i3,ra_(i1+i2+1),23.0d0, 30.0d0)

      i1=icount8Veron(nqso,dec, -43.0d0, -37.0d0)
      i2=icount8Veron(nqso,dec, -37.0d0, -31.0d0)
      i3=icount8Veron(nqso,dec, -31.0d0, -26.0d0)
      
c      call ranx8Veron(i1,dec(1), -43.0d0, -37.0d0)
c      call ranx8Veron(i2,dec(i1+1),-37.0d0, -31.0d0)
c      call ranx8Veron(i3,dec(i1+i2+1),-31.0d0, -26.0d0)


      print*,'i1+i2+i3, nqso=',i1+i2+i3, nqso

      string='PG'
      len=2
      string='PKS'
      len=3
c      call cutzVeron(0.0,1.8)
c      call subcatVeron(len,string)

      print*,'nqso=',nqso

c      do iq=1,nqso
c         print*,name(iq)
c      enddo


c      call cutzVeron(1.6,2.6)
c      call cutzVeron(0.0,1.8)

      print*,'test: ra_(5)=',ra_(5)
c      call ranzVeron
c      call GauzVeron
      print*,'test B: ra_(5)=',ra_(5)

c      call ranraVeron(100.0,300.0)
c      call ranx8Veron(nqso,ra_,100.0d0,300.0d0)

c      call bootVeron

      print*,'nqso=',nqso

      zmax=5.0
      nbins=100
      ymax=200.0 !50.0 !30.0! 600.0 !

c      call pgbegin(0,'?',1,1)
      call pgbegin(0,'zN.ps/vps',1,1)
      call pgvsize(1.0,6.0,1.0,6.0)
      call pgscf(2)
      call pgslw(3)
      
      call pgwindow(0.0,zmax,0.0,ymax)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)

      call pghist(nqso,redsh,0.0,zmax,nbins,5)
      call pglabel('z','N',' ')
      call pgend

c     --------- Bmag distribution -----
      if(domagplot)then

         xmin=9e9
         xmax=-9e9
         do i=1,nqso
            Bmag(i)= Vmag(i)+B_V(i)
c     print*,'i: ',i,Vmag(i),B_V(i),Bmag(i)
            xmin=min(xmin,Vmag(i))
            xmax=max(xmax,Vmag(i))
         enddo

         nbins=100
         ymax=200.0             !50.0 !30.0! 600.0 !

         call pgbegin(0,'/vps',1,1)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgscf(2)
         call pgslw(3)
         
         call pgwindow(xmin,xmax,0.0,ymax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)

         call pghist(nqso,Vmag,xmin,xmax,nbins,5)
         call pglabel('V','N',' ')
         call pgend
      endif
c     ---------

      om_0=0.3 !0.6 !1.0 !0.55
      cc_0=0.7 !0.9 !0.4 !0.0 !0.45
      q_0=om_0/2.0 - cc_0
      H_0=100.0
      do iq=1,nqso
         pdW(iq)= pdWein(q_0,H_0,cc_0, redsh(iq))
      enddo
      pdWmax= pdWein(q_0,H_0,cc_0, zmax)

      call pgbegin(0,'pdW.ps/vps',1,1)
      call pgvsize(1.0,6.0,1.0,6.0)
      call pgscf(2)
      call pgslw(3)
      
      call pgwindow(0.0,pdWmax,0.0,ymax)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)

      call pghist(nqso,pdW,0.0,pdWmax,nbins,5)
      call pglabel('d (h\\u-1\\d Mpc)','N',' ')

      rlss=2.0*130.0
      ph=0.5
      do i=1, int(pdWmax/rlss)
         call pgmove(real(i)*rlss+ph*rlss,0.0)
         call pgdraw(real(i)*rlss+ph*rlss,ymax)
      enddo

      call pgend



c     ==== sky plots ====
      
      if(dogalplot)then
         do i=1,nqso
            ra_4(i)=real(ra_(i))
            dec4(i)=real(dec(i))
            call j2000_b1950(ra_4(i)/15.0,dec4(i),xx,yy)
            call b1950_gal(xx,yy,gall(i),galb(i))
         enddo
      endif

c      call cutgVeron(-1.0,361.0,-91.0,91.0,gall,galb)
c      call cutgVeron(-1.0,361.0,10.0,22.0,gall,galb)
c      print*,'Have converted coords'

c      call ranx4Veron(nqso,galb,20.0,90.0)

      do while(1+1.eq.2)
c      do jj=1,0


c     ---- wedge diagram ----
         z1=1.84! 1.8! 1.0 !0.8 ! 0.2! 
         z2=2.4 !3.0 !2.1 ! 2.18! 1.3! 

c         call rdmemVeron
c         call cutzVeron(1.8,2.4) !(1.0,3.0) !
c         call cutzVeron(0.0,1.8)
c         call cutzVeron(0.8,2.1)

         call cutzVeron(z1,z2)

         string='PKS'
         len=3
c         call subcatVeron(len,string)
c         call cutrefVeron(1,irefs(1))! for wedge

c         call cutVeron(10.5,29.75,-42.0,-37.5)

c     ---  right ascension sample ---
c         rr2=42.0/4.0
c         rr2=15.0 !! for 3-D, i.e. exclusive subsets case 
c         rr1=119.0/4.0
c         dd1=-42.0
c         dd2=-37.5

c     --- for the [HB89]~0122-380 absorbers ---
         rr1_0= (82.0+2.0/60.0) /4.0
         abswidth=2.0 !1.0!0.5 !
         rr2= rr1_0 -abswidth
         rr1= rr1_0 +abswidth
         dd1=-38.0 -abswidth
         dd2=min(-37.5,-38.0 +abswidth)


c     ---  declination sample ---
c         rr2=42.0/4.0
c         rr1=60.0/4.0
c         dd1=-42.0
c         dd2=-28.0

c     ---- 2dF 0003206 ----
c         rr2=192.0 !260.0
c         rr1=210.0 !300.0
c         dd1=-3.0 !-33.0
c         dd2=3.0 !-27.0

c     ---- 2dF 000628 R.~Smith ----
c     NGP
c         rr2=147.5
c         rr1=222.0
c         dd1=-3.0
c         dd2=3.0
c     SGP
c         rr2=-35.0
c         rr1=49.0
c         dd1=-33.0
c         dd2=-27.0

c     ---- Giraffe 10 Hammer
c         alpha0= (9.0+51.0/60.0+26.0/3600.0) *15.0
c         delta0= -21.0
c     ---- Giraffe 16 Hammer
c         alpha0= (16.0) *15.0
c         delta0= 10.0 +20.0/60.0 
c         abswidth=2.0 ! 25.0/60.0 !1.0!0.5 !
c         rr2= alpha0 - abswidth
c         rr1= alpha0 + abswidth
c         dd1= delta0 -abswidth
c         dd2= delta0 +abswidth

         call cutVeron(rr2,rr1,dd1,dd2)! for wedge
         print*,'after rr2,rr1,dd1,dd2 cut: nqso=',nqso

c         z2=1.8

         ra1=10.5
         dec1=-23.0 !-28.0
         sch=0.3!0.6! 1.0 !
c         om_0= 1.0 !0.25!
c         cc_0=0.0 !1.0-om_0

c         write(6,'(a,$)')'Enter om_0,cc_0,sch,ra1,dec1,z1: '
c         read(5,*,end=666)om_0,cc_0,sch,ra1,dec1,z1
         ra1=-999.9
         q_0=om_0/2.0 - cc_0
c         write(6,'(a,$)')'Enter sch: '
c         read(5,*,end=666)sch


         curv0= om_0+cc_0 -1.0
         if(curv0.lt.-tolcurv)then
            kcurv=-1
            rcurv= conh/(H_0/100.0) /sqrt( -curv0 )
         elseif(curv0.gt.tolcurv)then
            kcurv=+1
            rcurv= conh/(H_0/100.0) /sqrt( curv0 )
C     --- following unnecessary if Om, lam < 1 and z < 8 ----
c     _                       rcurv*thetamax)
         else
            kcurv=0
            rcurv=9e9
         endif
         print*,'om_0,cc_0,kcurv,rcurv=',om_0,cc_0,kcurv,rcurv

c            print*,
c     _        'WARNING: flat Universe assumed !!!! Distorsion not yet',
c     _        ' implemented !!'


c         rr2= 35.0/4.0
c         rr1= (35.0+90.0)/4.0
c         dd1= -44.0
c         dd2= -26.0

c     ---- add lyabs list ----
         if(do_abs)then
            do iq=nqso+1,nqso+nly
               ra_(iq)=ra_ly(iq-nqso)
               dec(iq)=decly(iq-nqso)
               redsh(iq)=redshly(iq-nqso)
c               print*,'lyabs: ra_(iq),dec(iq),redsh(iq)=',
c     _              real(ra_(iq)),real(dec(iq)),redsh(iq)
            enddo
            nall=nqso+nly
         elseif(do_arb)then
            iq=nqso+1
            rrh= (1.0+53.0/60.0)
            dd= -39.0
            call j2000_b1950(rrh,dd,rrh3,dd3)
            rr3=rrh3*15.0

            ra_(iq)=rr3
            dec(iq)=dd3
            redsh(iq)=z1

            iq=nqso+2
            ra_(iq)=rr3
            dec(iq)=dd3
            redsh(iq)=z2
            narb=2

            nall=nqso+narb
         else
            nall=nqso
         endif
c     ----

         H_0=100.0
c         do iq=1,nqso
         do iq=1,nall
            pdW(iq)= pdWein(q_0,H_0,cc_0, redsh(iq))
         enddo
         ram= (rr1+rr2)/2.0
         decm= (dd1+dd2)/2.0
         cosdecm= cos(decm*pi_180) 
         print*,'ram,decm,cosdecm=',ram,decm,cosdecm

         pdWmax= pdWein(q_0,H_0,cc_0, z2)
         thmax= max( abs(rr2-rr1)*pi_180 *cosdecm,
     _        (dd2-dd1)*pi_180 ) ! radians

         thmax0=thmax

         if(kcurv.gt.0)then
            thmax=thmax* sin(pdWmax/rcurv)*rcurv/pdWmax
         elseif(kcurv.lt.0)then
            thmax=thmax* sinh(pdWmax/rcurv)*rcurv/pdWmax
         endif

         print*,'pdWmax, thmax = ',pdWmax,thmax


c         do iq=1,nqso
         do iq=1,nall
            ith=1
            th= (real(ra_(iq))- ram) *pi_180 *cosdecm !+pi/2.0
c            th= -(real(ra_(iq))- ram) *pi_180 *cosdecm !+pi/2.0
            if(kcurv.gt.0)then
               th=th* sin(pdW(iq)/rcurv)*rcurv/pdW(iq)
            elseif(kcurv.lt.0)then
               th=th* sinh(pdW(iq)/rcurv)*rcurv/pdW(iq)
            endif
            th=th+pi/2.0

c            if(iq.gt.nqso)then !! test only !!
c               print*,'test: nqso,iq,pdW(iq)=',nqso,iq,pdW(iq)
c            endif

            xwed(iq,ith)= pdW(iq)*cos(th)
            ywed(iq,ith)= pdW(iq)*sin(th)

            ith=2
            th= (real(dec(iq))- decm) *pi_180 !+pi/2.0
c            th= -(real(dec(iq))- decm) *pi_180 !+pi/2.0 
            if(kcurv.gt.0)then
               th=th* sin(pdW(iq)/rcurv)*rcurv/pdW(iq)
            elseif(kcurv.lt.0)then
               th=th* sinh(pdW(iq)/rcurv)*rcurv/pdW(iq)
            endif
            th=th+pi/2.0

            xwed(iq,ith)= pdW(iq)*cos(th)
            ywed(iq,ith)= pdW(iq)*sin(th)
         enddo


         
         pdWz1= pdWein(q_0,H_0,cc_0, z1)

c         xxmax= thmax*pdWmax/2.0 *1.1
         xxmax= sin(thmax/2.0)*pdWmax *1.03 ! modified 09/12/99
c         xxmax= 410.0 ! modified 16/06/00
         yy1= pdWz1*0.98 ! 0.0
     _        *cos(thmax/2.0) !modified 27/07/00

         yy2= pdWmax*1.02
         print*,'pdWz1,pdWmax=',pdWz1,pdWmax

         ratio= (yy2-yy1)/(2.0*xxmax)
         dvsize= 3.0 !5.0 !9.0! 0.5 !
         dvsize= dvsize*abswidth/3.0

         thm1=  thcurv( thmax0, kcurv, pdWmax, rcurv)
         dth=thm1/real(mxc-1)
         do i=1,mxc
            th= -thm1/2.0 + (real(i-1)*dth) +pi/2.0
            circle(i,1,1)= pdWmax* cos(th) ! x 
            circle(i,2,1)= pdWmax* sin(th) ! y 
         enddo
         thm1=  thcurv( thmax0, kcurv, pdWz1, rcurv)
         dth=thm1/real(mxc-1)
         do i=1,mxc
            th= -thm1/2.0 + (real(i-1)*dth) +pi/2.0
            circle(i,1,2)= pdWz1* cos(th) ! x 
            circle(i,2,2)= pdWz1* sin(th) ! y 
         enddo


         dpdW0= (pdWmax-pdWz1)/real(mxc-1)
         do ic=1,mxc
            pdW0= pdWz1 + (real(ic-1)*dpdW0)
            th= thcurv( thmax0/2.0, kcurv, pdW0, rcurv)
            edge(ic,1,1)= pdW0*cos(pi/2.0-th)
            edge(ic,2,1)= pdW0*sin(pi/2.0-th)
            edge(ic,1,2)= pdW0*cos(pi/2.0+th)
            edge(ic,2,2)= pdW0*sin(pi/2.0+th)
         enddo


         x0= -xxmax*0.8
         y0= yy1+ 0.15*(yy2-yy1)
         radius=130.0/2.0
c         pi=3.1415926536
         do i=1,20
            xcirc(i,1)=x0 + radius* cos(2.0*pi*real(i-1)/19.0)
            ycirc(i,1)=y0 + radius* sin(2.0*pi*real(i-1)/19.0)
         enddo

         x0= -xxmax*0.8
         y0= yy1+ 0.30*(yy2-yy1)
         radius=130.0/2.0/2.0
c         pi=3.1415926536
         do i=1,20
            xcirc(i,2)=x0 + radius* cos(2.0*pi*real(i-1)/19.0)
            ycirc(i,2)=y0 + radius* sin(2.0*pi*real(i-1)/19.0)
         enddo

         do ith=1,2
            call pgbegin(0,'?',1,1)

            call pgvsize(1.0,1.0+dvsize,1.0,1.0+ratio*dvsize)
c            call pgscf(2)
            call pgscf(1)
            call pgslw(4)
            
c            call pgwindow( -xxmax, xxmax, yy1,yy2)
            call pgwindow( xxmax, -xxmax, yy1,yy2)

            call pgsch(1.2)
            call pgbox('bcnts',0.,0,'bcnts',0.,0)
            call pgsch(1.0)
            call pgsch(sch)

               
            call pgpoint(nqso,xwed(1,ith),ywed(1,ith),17)
            if(do_abs.or.do_arb)then
               call pgsci(2)
               call pgsch(2.0)
               if(do_abs)then
                  call pgpoint(nly,
     _                 xwed(nqso+1,ith),ywed(nqso+1,ith),17)
               else
c                  call pgpoint(narb,
c     _                 xwed(nqso+1,ith),ywed(nqso+1,ith),17)
                  call pgmove(
     _                 xwed(nqso+1,ith),ywed(nqso+1,ith))
                  call pgdraw(
     _                 xwed(nqso+2,ith),ywed(nqso+2,ith))
               endif
               call pgsch(sch)

               call pgsci(1)
            endif
c


            call pgsch(1.2)
            call pglabel('x (h\\u-1\\dMpc)','y (h\\u-1\\dMpc)',' ')
            
            call pgqlw(iqlw)
            call pgslw(8)
c            call pgptxt(500.0,2700.0,0.0,0.0,'b.') !'a.')
            call pgslw(iqlw)
            call pgsch(1.0)



c            if(ith.eq.1)then
c               call pgptxt(-0.9*xxmax, yy1+0.1*(yy2-yy1), 
c     _              0.0,0.0, '\\ga')
c            elseif(ith.eq.2)then
c               call pgptxt(-0.9*xxmax, yy1+0.1*(yy2-yy1), 
c     _              0.0,0.0, '\\gd')
c            endif
            

c            call pgmove(pdWmax*cos(pi/2.0 -thmax/2.0),
c     _           pdWmax*sin(pi/2.0 -thmax/2.0))
c            call pgdraw(0.0,0.0)
c            call pgdraw(pdWmax*cos(pi/2.0 +thmax/2.0),
c     _           pdWmax*sin(pi/2.0 +thmax/2.0))


c     ---- edges
            call pgline(mxc,edge(1,1,1),edge(1,2,1))
            call pgline(mxc,edge(1,1,2),edge(1,2,2))

c     ---- arcs
            call pgline(mxc,circle(1,1,1),circle(1,2,1))
            call pgline(mxc,circle(1,1,2),circle(1,2,2))

c     ---- draw circles
c            call pgline(20,xcirc(1,1),ycirc(1,1))
c            call pgline(20,xcirc(1,2),ycirc(1,2))
            call pgend
         enddo

c     ---- unrolled, or else simply angular (sky) distribution ----

         if(ra1.gt.-99.0)
     _        call unrollVeron(q_0,H_0,cc_0,z1,z2,ra1,dec1)
         do i=1,nqso
            ra_4(i)=real(ra_(i))
            dec4(i)=real(dec(i))
         enddo

         rr1=360.0
         rr2=0.0
         dd1=-90.0
         dd2=90.0

c         rr1=33.0
c         rr2=7.0
c         dd1=-46.0
c         dd2=-34.0

c         rr1=18.0
c         rr2=8.0
c         dd1=-46.0
c         dd2=-23.0
         
c         rr2= 35.0/4.0
c         rr1= (35.0+90.0)/4.0
c         dd1= -44.0
c         dd2= -26.0


c         write(6,'(a,$)')'Enter rr1,rr2,dd1,dd2: '
c         read(5,*,end=666)rr1,rr2,dd1,dd2

         call pgbegin(0,'?',1,1)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgscf(2)
         call pgslw(3)
         
c         call pgwindow(360.0,0.0,-90.0,90.0)
         call pgwindow(rr1,rr2,dd1,dd2)
c     call pgwindow(40.0,0.0,-50.0,-20.0)
c     call pgwindow(330.0,305.0,-50.0,-40.0)
c     call pgwindow(340.0,305.0,-25.0,-10.0)

c         call pgwindow(rr1*240.0,rr2*240.0,
         call pgwindow(rr1*240.0,rr2*240.0+0.1, ! to avoid "-0.0"
     _        dd1*3600.0,dd2*3600.0)

         call pgsch(1.2)
c         call pgtbox('bcntszhyxo',0.,0,'bcntszd',0.,0)
         call pgtbox('bcntszhyo',0.,0,'bcntszd',0.,0)  ! to put "24.0" not "0.0"
         call pgsch(1.0)

c         call pgvsize(6.0,7.0,1.0,6.0)
c         call pgwindow(-0.1, 0.9*240.0,
c     _        dd1*3600.0,dd2*3600.0)
c         call pgsch(1.2)
c         call pgtbox('nzhyo',0.,0,' ',0.,0)  ! to put "0.0"
c         call pgsch(1.0)

c     --- back to normal ---
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgwindow(rr1,rr2,dd1,dd2)

         call pgpoint(nqso,ra_4,dec4,1)

         call pgsch(sch)
c         call pgpoint(nqso,ra_4,dec4,17) ! for big points
         call pgsch(1.0)
         call pglabel('\\ga (J2000)','\\gd (J2000)',' ')

         if(1+1.eq.2)then
c     _     10.0,30.0,-42.5,-37.0, ! 1 +2+3  ! using  -42.5 not -43.0
c     _     10.0,16.0, -42.5,-32.5, ! 2+4

            call pgslw(4)
            call pgsls(1)
            call pgmove(10.5,-42.0)
c            call pgdraw(29.2,-42.0)
c            call pgdraw(29.2,-37.5)
            call pgdraw(29.75,-42.0)
            call pgdraw(29.75,-37.5)
            call pgdraw(10.5,-37.5)
            call pgdraw(10.5,-42.0)
c            call pgsls(2)
            call pgslw(2)
            call pgmove(16.75,-42.0)
            call pgdraw(16.75,-37.5)
            call pgmove(23.25,-42.0)
            call pgdraw(23.25,-37.5)

            call pgslw(4)
            call pgsls(1)
            call pgmove(10.5,-42.0)
            call pgdraw(15.0,-42.0)
            call pgdraw(15.0,-28.0)
            call pgdraw(10.5,-28.0)
            call pgdraw(10.5,-42.0)

            call pgslw(2)            
            call pgmove(10.5,-32.5)
            call pgdraw(15.0,-32.5)
            

            call pgslw(3)
         endif
         
         call pgend

      enddo  !??? of ??    do while(1+1.eq.2)
 666  continue

      call pgbegin(0,'?',1,1)
      call pgvsize(1.0,6.0,1.0,6.0)
      call pgscf(2)
      call pgslw(3)
      
      call pgwindow(360.0,0.0,-90.0,90.0)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)

      call pgpoint(nqso,gall,galb,1)
      call pglabel('l\\uII','b\\uII',' ')

      call pgslw(2)
      call pgmove(360.0,10.0)
      call pgdraw(0.0,10.0)
      call pgmove(360.0,20.0)
      call pgdraw(0.0,20.0)
      call pgslw(3)


      call pgend


      end


      subroutine readVeron

C=============================================================================
C  F77-compliant program generated by readme2f_1.0, on 1999-Oct-08
C=============================================================================
*  This code was generated from the ReadMe file documenting a catalogue
*  according to the "Standard for Documentation of Astronomical Catalogues"
*  currently in use by the Astronomical Data Centers (CDS, ADC, A&amp;A)
*  (see full documentation at URL <A HREF="http://vizier.u-strasbg.fr/doc/catstd.htx">http://vizier.u-strasbg.fr/doc/catstd.htx</A>)
*  Please report problems or questions to   <A HREF="mailto:question@simbad.u-strasbg.fr">question@simbad.u-strasbg.fr</A>
C=============================================================================

      implicit none
*  Unspecified or NULL values, generally corresponding to blank columns,
*  are assigned one of the following special values:
*     rNULL_    for unknown or NULL floating-point values
*     iNULL_    for unknown or NULL   integer      values
      real*4     rNULL_
      integer*4  iNULL_
      parameter  (rNULL_=-1.e37)     	! NULL real number
      parameter  (iNULL_=-2147483647)	! NULL int  number

C=============================================================================
Cat. VII/207            Quasars and Active Galactic Nuclei (8th Ed.)  (Veron+ 1998)
*================================================================================
*Quasars and Active Galactic Nuclei (8th Ed.)
*     Veron-Cetty M.P., Veron P.
*    &lt;ESO Scientific Report 18 (1998)&gt;
*    =1998ESOSR..18....1V
C=============================================================================

C  Internal variables

      integer*4 i_

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

C  Declarations for 'table1.dat'	! Quasars (brighter than absolute magnitude -23)

      integer*4 mxqso,nqso,idum
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'
      character*142 ar_   	! Full-size record

c      real*8        RA_        (mxqso) ! (deg) Right Ascension J2000
c      real*8        Dec        (mxqso) ! (deg)     Declination J2000
      character*1   notRadio   (mxqso) ! [*] '*' if not detected in radio (1)
c      character*17  Name       (mxqso) ! Most common name of the object
      integer*4     RAh        (mxqso) ! (h) Right Ascension J2000 (hours) (see also n_RAh)
      integer*4     RAm        (mxqso) ! (min) Right Ascension J2000 (minutes)
      real*4        RAs        (mxqso) ! (s) Right Ascension J2000 (seconds)
      character*1   DE_        (mxqso) ! Declination J2000 (sign)
      integer*4     DEd        (mxqso) ! (deg) Declination J2000 (degrees)
      integer*4     DEm        (mxqso) ! (arcmin) Declination J2000 (minutes)
      integer*4     DEs        (mxqso) ! (arcsec) Declination J2000 (seconds)
      character*1   n_RAh      (mxqso) ! [AOR] Approximative/Optical/Radio position (2)
      real*4        F6cm       (mxqso) ! (Jy) ? 6cm (5GHz) flux
      integer*4     r_F6cm     (mxqso) ! [1,1863]? Reference of 6cm Flux
      real*4        F11cm      (mxqso) ! (Jy) ? 11cm (2.7GHz) flux (Jy)
      integer*4     r_F11cm    (mxqso) ! [1,1863]? Reference of 11cm flux
c      character*1   l_z        (mxqso) ! [&gt;*] limit or method flag on z (4)
c      real*4        redsh          (mxqso) ! ? redshift
      character*4   Sp         (mxqso) ! [S0-9?HPBLbhin. ] Spectrum classification (3)
      character*1   n_Vmag     (mxqso) ! [*RI] '*' for photographic, 'R' for red Vmag
c      real*4        Vmag       (mxqso) ! (mag) ? magnitude, V or other (see n_Vmag)
c      real*4        B_V        (mxqso) ! (mag) ? colour index
      real*4        U_B        (mxqso) ! (mag) ? colour index
      real*4        Mabs       (mxqso) ! (mag) ? Absolute magnitude
c      integer*4     FC         (mxqso) ! [1,1863]? Reference of the Finding Chart
c      integer*4     r_Vmag     (mxqso) ! [1,1863]? Reference of the Photometry
c      integer*4     r_z        (mxqso) ! [1,1863]? Reference of the redshift
      integer*4     RA1950h    (mxqso) ! (h) Right Ascension B1950 (hours)
      integer*4     RA1950m    (mxqso) ! (min) Right Ascension B1950 (minutes)
      real*4        RA1950s    (mxqso) ! (s) Right Ascension B1950 (seconds)
      character*1   DE1950_    (mxqso) ! Declination B1950 (sign)
      integer*4     DE1950d    (mxqso) ! (deg) Declination B1950 (degrees)
      integer*4     DE1950m    (mxqso) ! (arcmin) Declination B1950 (minutes)
      integer*4     DE1950s    (mxqso) ! (arcsec) Declination B1950 (seconds)
*Note (1): this flag is blank if the object has been detected as a
*    radio source, and is '*' if not.
*Note (2): this flag related to the position takes the values:
*     'O' for an Optical position with an accuracy better than 1arcsec
*     'R' for a Radio position with an accuracy better than 1arcsec
*     'A' for an approximative position
*Note (3): the classification of the object is
*     S1:  Seyfert 1 spectrum
*     S1h: broad polarized Balmer lines detected
*     S1i: broad Paschen lines observed in the infrared
*     S1n: narrow-line Seyfert 1
*     S1.0, S1.2, S1.5, S1.8, S1.9: intermediate Seyfert galaxies
*     S2:  Seyfert 2 spectrum
*     S3:  Seyfert 3 or liner
*     S :  unclassified Seyfert
*     S?:  possibly a Seyfert
*     H2:  nuclear HII region
*     HP:  high optical polarization (&gt;3%)
*     BL:  confirmed BL Lac object
*Note (4): n_z may indicate a lower limit on z, or
*     '*', if the redshift is measured by slitless spectroscopy.


c      common /Vercomm/ nqso, idum,ra_,dec,redsh,Vmag,B_V,l_z,name,
c     _     FC,r_Vmag,r_z


C=============================================================================

C  Loading file 'table1.dat'	! Quasars (brighter than absolute magnitude -23)

C  Format for file interpretation

    1 format(
     +  1X,A1,A17,2X,I2,1X,I2,1X,F4.1,1X,A1,I2,1X,I2,1X,I2,1X,A1,2X,
     +  F6.3,1X,I4,2X,F5.2,1X,I4,1X,A1,F5.3,1X,A4,1X,A1,F5.2,1X,F5.2,
     +  1X,F5.2,1X,F5.1,1X,I4,1X,I4,1X,I4,2X,I2,1X,I2,1X,F4.1,1X,A1,
     +  I2,1X,I2,1X,I2)

      nqso=mxqso

C  Effective file loading

      open(unit=1,file='table1.dat', status='old')
      write(6,*) '....Loading file: table1.dat'
      do i_=1,mxqso !11358
        read(1,'(A142)')ar_
        read(ar_,1)
     +  notRadio(i_),Name(i_),RAh(i_),RAm(i_),RAs(i_),DE_(i_),
     +  DEd(i_),DEm(i_),DEs(i_),n_RAh(i_),F6cm(i_),r_F6cm(i_),
     +  F11cm(i_),r_F11cm(i_),l_z(i_),redsh(i_),Sp(i_),n_Vmag(i_),
     +  Vmag(i_),B_V(i_),U_B(i_),Mabs(i_),FC(i_),r_Vmag(i_),
     +  r_z(i_),RA1950h(i_),RA1950m(i_),RA1950s(i_),DE1950_(i_),
     +  DE1950d(i_),DE1950m(i_),DE1950s(i_)
        if(ar_(46:51) .EQ. ' ') F6cm(i_) = rNULL_
        if(ar_(53:56) .EQ. ' ') r_F6cm(i_) = iNULL_
        if(ar_(59:63) .EQ. ' ') F11cm(i_) = rNULL_
        if(ar_(65:68) .EQ. ' ') r_F11cm(i_) = iNULL_
        if(ar_(71:75) .EQ. ' ') redsh(i_) = rNULL_
        if(ar_(83:87) .EQ. ' ') Vmag(i_) = rNULL_
        if(ar_(89:93) .EQ. ' ') B_V(i_) = rNULL_
        if(ar_(95:99) .EQ. ' ') U_B(i_) = rNULL_
        if(ar_(101:105) .EQ. ' ') Mabs(i_) = rNULL_
        if(ar_(107:110) .EQ. ' ') FC(i_) = iNULL_
        if(ar_(112:115) .EQ. ' ') r_Vmag(i_) = iNULL_
        if(ar_(117:120) .EQ. ' ') r_z(i_) = iNULL_
c       Derive coordinates RA_ and Dec from input data
c       (RA_ and Dec are set to rNULL_ when unknown)
        RA_(i_) = RAh(i_)
        if(RAh(i_) .GE. 0) RA_(i_)=RAh(i_)*15.
        if(RAm(i_) .GE. 0) RA_(i_)=RA_(i_)+RAm(i_)/4.
        if(RAs(i_) .GE. 0) RA_(i_)=RA_(i_)+RAs(i_)/240.
        Dec(i_) = DEd(i_)
        if(DEm(i_) .GE. 0) Dec(i_)=Dec(i_)+DEm(i_)/60.
        if(DEs(i_) .GE. 0) Dec(i_)=Dec(i_)+DEs(i_)/3600.
        if(DE_(i_).EQ.'-'.AND.Dec(i_).GE.0) Dec(i_)=-Dec(i_)
c    ..............Just test output...........
        if(1+1.eq.3)then
           write(6,1)
     +          notRadio(i_),Name(i_),RAh(i_),RAm(i_),RAs(i_),DE_(i_),
     +          DEd(i_),DEm(i_),DEs(i_),n_RAh(i_),F6cm(i_),r_F6cm(i_),
     +          F11cm(i_),r_F11cm(i_),l_z(i_),redsh(i_),Sp(i_),
     +          n_Vmag(i_),
     +          Vmag(i_),B_V(i_),U_B(i_),Mabs(i_),FC(i_),r_Vmag(i_),
     +          r_z(i_),RA1950h(i_),RA1950m(i_),RA1950s(i_),
     +          DE1950_(i_),
     +          DE1950d(i_),DE1950m(i_),DE1950s(i_)
           write(6,'(6H Pos: 2F8.4)') RA_(i_),Dec(i_)
        endif
c    .......End.of.Just test output...........
      end do
      close(1)

      return
      end



      subroutine readIovino

C     !!! warning: not yet converted from b1950 to j2000. !!

C=============================================================================
C  F77-compliant program generated by readme2f_1.0, on 2000-Apr-26
C=============================================================================
*  This code was generated from the ReadMe file documenting a catalogue
*  according to the "Standard for Documentation of Astronomical Catalogues"
*  currently in use by the Astronomical Data Centers (CDS, ADC, A&amp;A)
*  (see full documentation at URL <A HREF="http://vizier.u-strasbg.fr/doc/catstd.htx">http://vizier.u-strasbg.fr/doc/catstd.htx</A>)
*  Please report problems or questions to   <A HREF="mailto:question@simbad.u-strasbg.fr">question@simbad.u-strasbg.fr</A>
C=============================================================================

      implicit none
*  Unspecified or NULL values, generally corresponding to blank columns,
*  are assigned one of the following special values:
*     rNULL_    for unknown or NULL floating-point values
*     iNULL_    for unknown or NULL   integer      values
      real*4     rNULL_
      integer*4  iNULL_
      parameter  (rNULL_=-1.e37)     	! NULL real number
      parameter  (iNULL_=-2147483647)	! NULL int  number

C=============================================================================
Cat. J/A+AS/119/265      High probability quasar candidates (Iovino+, 1996)
*================================================================================
*A large sample of objective prism quasar candidate.
*      Iovino A., Clowes R., Shaver P.
*     &lt;Astron. Astrophys. Suppl. Ser. 119, 265 (1996)&gt;
*     =1996A&amp;AS..119..265I      (SIMBAD/NED BibCode)
C=============================================================================

C  Internal variables

      integer*4 i_

c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

C     declaration common to declaration for Veron-Cetty, Veron catalogue 
c     read-in subroutine "readVeron":

      integer*4 mxqso,nqso,idum,i,j
      include 'mxqso.dec'

C  Declarations for 'table3'	! List of high probability candidates

      integer*4 nr_
      parameter (nr_=1592)	! Number of records
      character*80 ar_   	! Full-size record

c      real*8        RA_        (nr_) ! (deg) Right Ascension 1950
c      real*8        Dec        (nr_) ! (deg)     Declination 1950
      integer*4     RAh        (nr_) ! (h) Right ascension (1950)
      integer*4     RAm        (nr_) ! (min) Right ascension (1950)
      real*4        RAs        (nr_) ! (s) Right ascension (1950)
      character*1   DE_        (nr_) ! Declination sign
      integer*4     DEd        (nr_) ! (deg) Declination (1950)
      integer*4     DEm        (nr_) ! (arcmin) Declination (1950)
      integer*4     DEs        (nr_) ! (arcsec) Declination (1950)
      real*4        mcosmos    (nr_) ! (mag) Prism instrumental magnitude
      real*4        Vcosmos    (nr_) ! (mag) Indicative magnitude in the V band
      real*4        zlya       (nr_) ! Tentative redshift
      real*4        GRADE      (nr_) ! Grade
      character*3   Notes      (nr_) ! [?*QXR ] Notes (1)
*Note (1): ? - possible overlapping spectrum
*          * - good quality candidate
*          Q - known quasar
*          X - known ROSAT X--ray source
*          R - known radio source

C=============================================================================

C  Loading file 'table3'	! List of high probability candidates

C  Format for file interpretation

    1 format(
     +  2X,I2,1X,I2,1X,F4.1,2X,A1,I2,1X,I2,1X,I2,3X,F5.2,3X,F5.2,3X,
     +  F4.2,3X,F4.2,4X,A3)

C  Effective file loading

      open(unit=1,file='table3_Iov96.dat', status='old')
      write(6,*) '....Loading file: table3'
      do i_=1,1592
        read(1,'(A80)')ar_
        read(ar_,1)
     +  RAh(i_),RAm(i_),RAs(i_),DE_(i_),DEd(i_),DEm(i_),
     +  DEs(i_),mcosmos(i_),Vcosmos(i_),zlya(i_),GRADE(i_),
     +  Notes(i_)
c       Derive coordinates RA_ and Dec from input data
c       (RA_ and Dec are set to  rNULL when unknown)
        RA_(i_) = RAh(i_)
        if(RAh(i_) .GE. 0) RA_(i_)=RAh(i_)*15.
        if(RAm(i_) .GE. 0) RA_(i_)=RA_(i_)+RAm(i_)/4.
        if(RAs(i_) .GE. 0) RA_(i_)=RA_(i_)+RAs(i_)/240.
        Dec(i_) = DEd(i_)
        if(DEm(i_) .GE. 0) Dec(i_)=Dec(i_)+DEm(i_)/60.
        if(DEs(i_) .GE. 0) Dec(i_)=Dec(i_)+DEs(i_)/3600.
        if(DE_(i_).EQ.'-'.AND.Dec(i_).GE.0) Dec(i_)=-Dec(i_)
c    ..............Just test output...........
c        write(6,1)
c     +  RAh(i_),RAm(i_),RAs(i_),DE_(i_),DEd(i_),DEm(i_),
c     +  DEs(i_),mcosmos(i_),Vcosmos(i_),zlya(i_),GRADE(i_),
c     +  Notes(i_)
c        write(6,'(6H Pos: 2F8.4)') RA_(i_),Dec(i_)
c    .......End.of.Just test output...........
      end do
      close(1)

      nqso= nr_
      print*,'readIovino: nqso=',nqso
      do i=1,nqso
         redsh(i)= zlya(i)
         name(i)='IovCS96_         '
         write(name(i)(9:13),'(i5)')i
         do j=9,13
            if(name(i)(j:j).eq.' ')name(i)(j:j)='0'
         enddo
         Vmag(i)=Vcosmos(i)
      enddo


C=============================================================================
c      stop

      return
      end


      subroutine cleanVeron
C     ==== to "clean up" the Veron catalogue of bad redshifts, close
C     pairs, etc. ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'
      real*4        ra_4(mxqso),dec4(mxqso)!,gall(mxqso),galb(mxqso)
      integer*4     index(mxqso)


C     INTERNAL:
      parameter(pi=3.14159265359,pi_180=pi/180.0)
      real*4        x(mxqso),y(mxqso),z(mxqso)

      rednull=100.0
      redmin=0.01
      i=0
      do iq=1,nqso
         if(abs(redsh(iq)).lt.rednull.and.redsh(iq).gt.redmin
     _        .and.l_z(iq).ne.'>')then
            i=i+1
            ra_(i)=ra_(iq) ! i.le.iq  must be true to avoid overwriting
            dec(i)=dec(iq)
            redsh(i)=redsh(iq)
            Vmag(i)=Vmag(iq)
            B_V(i)=B_V(iq)
            name(i)=name(iq)
            FC(i)=FC(iq)
            r_Vmag(i)=r_Vmag(iq)
            r_z(i)=r_z(iq)
         endif
      enddo
      print*,'cleanVeron: old nqso=',nqso
      nqso=i
      print*,'cleanVeron: new nqso=',nqso

      ilimit=0
      do i=1,nqso
         x(i)=cos(real(dec(i))*pi_180) *cos(real(ra_(i))*pi_180)
         y(i)=cos(real(dec(i))*pi_180) *sin(real(ra_(i))*pi_180)
         z(i)=sin(real(dec(i))*pi_180) 
         ra_4(i)=real(ra_(i))
         dec4(i)=real(dec(i))
         index(i)=i
c         if(l_z(i).eq.'>')then
c            ilimit=ilimit+1
c            print*,'l_z(i),ra_(i),dec(i),redsh(i)='
c            print*,l_z(i),ra_(i),dec(i),redsh(i)
c         endif
      enddo
      print*,'cleanVeron: ilimit=',ilimit
      
      call risort(nqso,dec4,index)
      
      mxsec= 10.0
      degmax= 1.0/3600.0 * mxsec
      radmax= degmax*pi_180
      dzmax= 0.01


C     ---- warning: will fail if nqso= mxqso and array-out-of-bounds
C     protection is in operation. rewrite more pedantically in that
C     case. ----

      print*,'cleanVeron: removing close (3D) pairs...'
      do i=1,nqso-1
         j=i+1
         do while(j.le.nqso.and.
     _        dec4(index(j))-dec4(index(i)).lt.degmax)
            aa=angle( x(index(i)),y(index(i)),z(index(i)),
     _           x(index(j)),y(index(j)),z(index(j)) )
            if(aa.lt.radmax.and. 
     _           abs(redsh(index(i))-redsh(index(j))).lt.dzmax
     _           )then
               print*,'cleanVeron: will remove i,j:'
               print*,'name(index(j)),ra_(index(j)),dec(index(j)),',
     _              'redsh(index(j))'
               print*,name(index(i)),ra_(index(i)),dec(index(i)),
     _              redsh(index(i))
               print*,name(index(j)),ra_(index(j)),dec(index(j)),
     _              redsh(index(j))
               redsh(index(j))= -9e9
               print*,' '
            endif
            j=j+1
         enddo
         j=j-1
      enddo
            
      i=0
      do iq=1,nqso
         if(abs(redsh(iq)).lt.rednull.and.redsh(iq).gt.redmin)then
            i=i+1
            ra_(i)=ra_(iq) ! i.le.iq  must be true to avoid overwriting
            dec(i)=dec(iq)
            redsh(i)=redsh(iq)
            Vmag(i)=Vmag(iq)
            B_V(i)=B_V(iq)
            name(i)=name(iq)
            FC(i)=FC(iq)
            r_Vmag(i)=r_Vmag(iq)
            r_z(i)=r_z(iq)
         endif
      enddo
      print*,'cleanVeron: old nqso=',nqso
      nqso=i
      print*,'cleanVeron: new nqso=',nqso

      return
      end


      subroutine clean2dF
C     ==== to "clean up" the 2dF catalogue of close
C     pairs, etc. ====
      
      integer*4 mxqso,nqso
      include 'mxqso.dec'
      real*4        ra_4(mxqso),dec4(mxqso)!,gall(mxqso),galb(mxqso)
      integer*4     index(mxqso)


C     INTERNAL:
      parameter(pi=3.14159265359,pi_180=pi/180.0)
      real*4        x(mxqso),y(mxqso),z(mxqso)

      rednull=100.0
      redmin=0.01

      print*,'clean2dF: will calculate local variables:'

      do i=1,nqso

c         print*,'clean2dF: i,ra_(i),dec(i)=',i,ra_(i),dec(i) !! test only !!

         x(i)=cos(real(dec(i))*pi_180) *cos(real(ra_(i))*pi_180)
         y(i)=cos(real(dec(i))*pi_180) *sin(real(ra_(i))*pi_180)
         z(i)=sin(real(dec(i))*pi_180) 
         ra_4(i)=real(ra_(i))
         dec4(i)=real(dec(i))
         index(i)=i
      enddo
      
      print*,'clean2dF: will call risort:'
      call risort(nqso,dec4,index)
      
      mxsec= 10.0
      degmax= 1.0/3600.0 * mxsec
      radmax= degmax*pi_180
      dzmax= 0.01


C     ---- warning: will fail if nqso= mxqso and array-out-of-bounds
C     protection is in operation. rewrite more pedantically in that
C     case. ----

      print*,'clean2dF: removing close (3D) pairs...'
      do i=1,nqso-1
         j=i+1
         do while(j.le.nqso.and.
     _        dec4(index(j))-dec4(index(i)).lt.degmax)
            aa=angle( x(index(i)),y(index(i)),z(index(i)),
     _           x(index(j)),y(index(j)),z(index(j)) )
            if(aa.lt.radmax.and. 
     _           abs(redsh(index(i))-redsh(index(j))).lt.dzmax
     _           )then
c               print*,'clean2dF: will remove i,j:'
c               print*,'name(index(j)),ra_(index(j)),dec(index(j)),',
c     _              'redsh(index(j))'
c               print*,name(index(i)),ra_(index(i)),dec(index(i)),
c     _              redsh(index(i))
c               print*,name(index(j)),ra_(index(j)),dec(index(j)),
c     _              redsh(index(j))
c
c               print*,' '

               redsh(index(j))= -9e9
            endif
            j=j+1
         enddo
         j=j-1
      enddo
            
      i=0
      do iq=1,nqso
         if(abs(redsh(iq)).lt.rednull.and.redsh(iq).gt.redmin)then
            i=i+1
            ra_(i)=ra_(iq) ! i.le.iq  must be true to avoid overwriting
            dec(i)=dec(iq)
            redsh(i)=redsh(iq)
            Vmag(i)=Vmag(iq)
            B_V(i)=B_V(iq)
            name(i)=name(iq)
            FC(i)=FC(iq)
            r_Vmag(i)=r_Vmag(iq)
            r_z(i)=r_z(iq)
            ifld(i)=ifld(iq)
         endif
      enddo
      print*,'clean2dF: old nqso=',nqso
      nqso=i
      print*,'clean2dF: new nqso=',nqso

      return
      end





      subroutine complete2dF(comp_min)
C     ==== to remove "incomplete" areas of the 2dF catalogue ====

c     INPUTS:
      real*4   comp_min ! minimum completeness for qso to be accepted !
c     range = (0,1) ???


      integer*4 mxqso,nqso
      include 'mxqso.dec'
      real*4        ra_4(mxqso),dec4(mxqso)!,gall(mxqso),galb(mxqso)
      integer*4     index(mxqso)


C     INTERNAL:
      parameter(pi=3.14159265359,pi_180=pi/180.0)

      integer ifirst
      save    ifirst
      character*256  complete_n,complete_s

      parameter(ncat=2,mxra=4510,mxdec=320)
      real*4   complete(mxra,mxdec,ncat),comp_half(mxra,mxdec)
      real*4   ramin(ncat),decmin(ncat),rastep(ncat),decstep(ncat) 
      integer*4  nra,ndec
      
      logical*4  test_readin,test_complete
      character*1 ch1
      character*3 ch3
      real*4     tr(6)

      real*4     pointcomplete(mxqso) ! coverage completeness per quasar


      data complete_n/'n_completeJ2000little'/ ! little endian version
      data complete_s/'s_completeJ2000little'/ ! little endian version

      data test_readin/.false. / !.true./ !
      data test_complete/.false. / !.true./ !


      rednull=100.0
      redmin=0.01

      

      print*,'complete: will remove "low completeness quasars": '
      print*,'completeness minimum:  comp_min=',comp_min

      if(ifirst.ne.12345)then
         ifirst=12345
         do icat=1,ncat
            if(icat.eq.1)then
               open(1,file=complete_n,access='sequential',status='old',
     _              form='unformatted')
            else
               open(1,file=complete_s,access='sequential',status='old',
     _              form='unformatted')
            endif
            read(1)ramin(icat)
            read(1)decmin(icat)
            read(1)nra
            read(1)ndec
            if(nra.ne.mxra.or.ndec.ne.mxdec)then
               print*,'complete2dF WARNING: ',
     _              'icat, ramin(icat), decmin(icat),nra,ndec=',
     _              icat, ramin(icat), decmin(icat),nra,ndec
            endif
            read(1)rastep(icat)
            read(1)decstep(icat)
            
            read(1)comp_half
            close(1)
            print*,'have closed completeness file'
            
            do j=1,ndec
               do i=1,nra
                  complete(i,j,icat)=comp_half(i,j)
               enddo
            enddo

            if(test_readin)then
               write(ch1,'(i1)')icat
               call pgbegin(0,'complete'//ch1//'.ps/vps',1,1)
               call pgvsize(1.0,7.0,1.0,2.0)

               tr(3)=0.0
               tr(5)=0.0
               tr(1)=ramin(icat)
               tr(4)=decmin(icat)
               tr(2)=rastep(icat)
               tr(6)=decstep(icat)

               call pgwindow(ramin(icat),
     _              ramin(icat)+nra*rastep(icat),
     _              decmin(icat),decmin(icat)+ndec*decstep(icat))
               call pgbox('bcntsi',0.,0,'bcntsi',0.,0)

               c_plot=0.8
               call pggray(complete(1,1,icat),nra,ndec,
     _              1,nra, 1,ndec, 1.0, c_plot,tr)

               
               write(ch3,'(i3)')nint(c_plot*100.0)

               call pglabel('\\ga','\\gd',
     _              'completeness cat '//ch1//'  > '//ch3//'%')

               call pgend
               
               print*,'Have written plot:  complete'//ch1//'.ps'
            endif               ! if(test_readin)then
         enddo                  ! do icat=1,ncat
      endif                     !if(ifirst.ne.12345)then



      do j=1,nqso
         pointcomplete(j)=-0.099
      enddo

c     ====
      print*,'complete 2dF: removing "incomplete" quasar '//
     _     'positions...'

      do icat=1,ncat
         do j=1,nqso
            ira= (real(ra_(j))-ramin(icat))/rastep(icat)+1
            idec= (real(dec(j))-decmin(icat))/decstep(icat)+1

            if(1.le.ira.and.ira.le.nra
     _           .and.1.le.idec.and.idec.le.ndec)then
               if( complete(ira,idec,icat).lt.comp_min ) ! cond. for elim. !
     _              then
                  redsh(j)= -9e9  ! invalidate quasar
               endif
               pointcomplete(j)= complete(ira,idec,icat)
            endif
         enddo                  ! do j=1,nqso
      enddo                     !do icat=1,ncat
            

c     ---- distribution of "coverage completeness" per quasar ----

      call pgbegin(0,'completedist.ps/vps',1,1)
      call pgslw(3)
      call pgscf(2)

      call pgvsize(1.0,6.0,1.0,6.0)
c      call pgwindow(-0.2,1.2, 
c        call pgbox('bcntsi',0.,0,'bcntsi',0.,0)

      call pghist(nqso,pointcomplete,-0.2,1.2,200,0)

      call pgmove(0.8,0.0)
      call pgdraw(0.8,100.0)

      call pglabel('"coverage completeness"','fraction',' ')
      call pgend

c     ---- remove "incomplete" quasars from the list ----
      i=0
      do iq=1,nqso
         if(abs(redsh(iq)).lt.rednull.and.redsh(iq).gt.redmin)then
            i=i+1
            ra_(i)=ra_(iq) ! i.le.iq  must be true to avoid overwriting
            dec(i)=dec(iq)
            redsh(i)=redsh(iq)
            Vmag(i)=Vmag(iq)
            B_V(i)=B_V(iq)
            name(i)=name(iq)
            FC(i)=FC(iq)
            r_Vmag(i)=r_Vmag(iq)
            r_z(i)=r_z(iq)
            ifld(i)=ifld(iq)
         endif
      enddo

      print*,'complete2dF: old nqso=',nqso
      nqso=i
      print*,'complete2dF: new nqso=',nqso

      if(test_complete)then
         do ii=1,nqso
            ra_4(ii)=real(ra_(ii))
            dec4(ii)=real(dec(ii))
         enddo

         do icat=1,ncat
            write(ch1,'(i1)')icat
            call pgbegin(0,'comp_'//ch1//'.ps/vps',1,1)
            call pgvsize(1.0,7.0,1.0,2.0)

            call pgwindow(ramin(icat),
     _           ramin(icat)+nra*rastep(icat),
     _           decmin(icat),decmin(icat)+ndec*decstep(icat))
            call pgbox('bcnts',0.,0,'bcnts ',0.,0)

            call pgpoint(nqso,ra_4,dec4,1)
            call pglabel('\\ga','\\gd',
     _           'remaining qsos'//ch1)

            call pgend
         enddo 
         print*,'have written plot  comp_'//ch1//'.ps'
      endif




      return
      end



      subroutine cutVeron(ra1,ra2,dec1,dec2)
C     ==== to extract a subset of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)
c      integer*4     index(mxqso)

      inew=0
      do iq=1,nqso
         if(ra1.lt.real(ra_(iq)).and.
     _        real(ra_(iq)).lt.ra2.and.
     _        dec1.lt.real(dec(iq)).and.
     _        real(dec(iq)).lt.dec2)then
            inew=inew+1
            ra_(inew)=ra_(iq)
            dec(inew)=dec(iq)
            redsh(inew)=redsh(iq)
            Vmag(inew)=Vmag(iq)
            B_V(inew)=B_V(iq)

            name(inew)=name(iq)
            FC(inew)=FC(iq)
            r_Vmag(inew)=r_Vmag(iq)
            r_z(inew)=r_z(iq)
         endif
      enddo
      nqso=inew
      print*,'cutVeron: nqso=',nqso
      return
      end

      subroutine excluVeron(ra1,ra2,dec1,dec2,z1,z2)
C     ==== to _remove_ a subset of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)
c      integer*4     index(mxqso)

      inew=0
      do iq=1,nqso
         if(ra1.gt.real(ra_(iq)).or.
     _        real(ra_(iq)).gt.ra2.or.
     _        dec1.gt.real(dec(iq)).or.
     _        real(dec(iq)).gt.dec2.or.
     _        z1.gt.redsh(iq).or.
     _        redsh(iq).gt.z2
     _        )then
            inew=inew+1
            ra_(inew)=ra_(iq)
            dec(inew)=dec(iq)
            redsh(inew)=redsh(iq)
            Vmag(inew)=Vmag(iq)
            B_V(inew)=B_V(iq)

            name(inew)=name(iq)
            FC(inew)=FC(iq)
            r_Vmag(inew)=r_Vmag(iq)
            r_z(inew)=r_z(iq)
         endif
      enddo
      nqso=inew
      print*,'excluVeron: nqso=',nqso
      return
      end


      subroutine cutgVeron(gl1,gl2,gb1,gb2,gall,galb)
C     ==== to extract a subset of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

C     OUPUTS:
      real*4        gall(mxqso),galb(mxqso)


      real*4        ra_4(mxqso),dec4(mxqso)
c      integer*4     index(mxqso)


      do i=1,nqso
         ra_4(i)=real(ra_(i))
         dec4(i)=real(dec(i))
         call j2000_b1950(ra_4(i)/15.0,dec4(i),xx,yy)
         call b1950_gal(xx,yy,gall(i),galb(i))
      enddo
      print*,'Have converted coords'

      inew=0
      do iq=1,nqso
         if(gl1.lt.(gall(iq)).and.
     _        (gall(iq)).lt.gl2.and.
     _        gb1.lt.(galb(iq)).and.
     _        (galb(iq)).lt.gb2)then
            inew=inew+1
            gall(inew)=gall(iq)
            galb(inew)=galb(iq)
            ra_(inew)=ra_(iq)
            dec(inew)=dec(iq)
            redsh(inew)=redsh(iq)
            Vmag(inew)=Vmag(iq)
            B_V(inew)=B_V(iq)

            name(inew)=name(iq)
            FC(inew)=FC(iq)
            r_Vmag(inew)=r_Vmag(iq)
            r_z(inew)=r_z(iq)
         endif
      enddo
      nqso=inew
      print*,'cutVeron: nqso=',nqso
      return
      end


      subroutine cutzVeron(z1,z2)
C     ==== to extract a subset of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)
c      integer*4     index(mxqso)


      inew=0
      do iq=1,nqso
         if(z1.lt.redsh(iq).and.redsh(iq).lt.z2)then
            inew=inew+1
            ra_(inew)=ra_(iq)
            dec(inew)=dec(iq)
            redsh(inew)=redsh(iq)
            Vmag(inew)=Vmag(iq)
            B_V(inew)=B_V(iq)

            name(inew)=name(iq)
            FC(inew)=FC(iq)
            r_Vmag(inew)=r_Vmag(iq)
            r_z(inew)=r_z(iq)
            ifld(inew)=ifld(iq)
         endif
      enddo
      nqso=inew
      print*,'cutzVeron: nqso=',nqso
      return
      end

      subroutine cutrefVeron(nref,irefs)
C     ==== to extract a subset of the Veron catalogue ====

C     INPUTS:
      integer*4     nref,irefs(*)

C     COMMON:
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

C     INTERNAL:
      logical*4     refOK

      inew=0
      do iq=1,nqso
         refOK=.false.
         do iref=1,nref
            if(r_z(iq).eq.irefs(iref))refOK=.true.
         enddo

         if(refOK)then
            inew=inew+1
            ra_(inew)=ra_(iq)
            dec(inew)=dec(iq)
            redsh(inew)=redsh(iq)
            Vmag(inew)=Vmag(iq)
            B_V(inew)=B_V(iq)

            name(inew)=name(iq)
            FC(inew)=FC(iq)
            r_Vmag(inew)=r_Vmag(iq)
            r_z(inew)=r_z(iq)
         endif
      enddo
      nqso=inew
      print*,'cutrefVeron: nqso=',nqso
      return
      end


      subroutine ranzVeron
C     ==== randomly redistributes the redshifts of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'
c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)

C     INTERNAL:
      integer*4     index(mxqso)
      real*4        rindex(mxqso)
      real*4        red2(mxqso)
c      real*8        ra_2(mxqso) ! test only !


      print*,'Starting  ranzVeron...'

      do iq=1,nqso
         red2(iq)=redsh(iq)
c         ra_2(iq)=ra_(iq)
         index(iq)=iq
      enddo

      nflush=238719!234127
      do i=1,nflush
         xyz=randt()
      enddo
      
      print*,'ranzVeron: nqso=',nqso

c     ==== this was an old version ====
      do iq=1,0 !nqso*10  
         iran= int(randt()*real(nqso)*0.9999 +0.00005)+1
         if(iran.lt.1.or.iran.gt.nqso)then
            print*,'ranzVeron WARNING',
     _        ' iran=',iran
         endif

         jran= int(randt()*real(nqso)*0.9999 +0.00005)+1
         if(jran.lt.1.or.jran.gt.nqso)then
            print*,'ranzVeron WARNING',
     _        ' jran=',jran
         endif
         iran=max(1,min(iran,nqso))

         jran=max(1,min(jran,nqso))
         if(iran.eq.jran)then
            if(iran.lt.nqso)then
               jran=iran+1
            else
               jran=iran-1
            endif
         endif
c     ---- swap indices for iran & jran ----
         ii=index(iran)
         index(iran)=index(jran)
         index(jran)=ii
      enddo

c     ==== new algorithm to permute a list ===
      do iq=1,nqso
         rindex(iq)=randt()
         index(iq)=iq
      enddo
      call risort(nqso,rindex,index)

c      dranz=0.3
      do iq=1,nqso
c         ddz= (randt()*2.0 -1.0)*dranz
c
c         redsh(iq)=max(0.002, red2(index(iq)) + ddz )
         redsh(iq)=red2(index(iq))
cc         ra_(iq)=ra_2(iran) !randt()*360.0  !
      enddo

      print*,'Done ranzVeron.'
      return
      end


      subroutine GauzVeron
C     ==== randomly reselects the redshifts of the Veron catalogue,
C     from a smoothed version of the redshift distribution ====

      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'


c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)

C     INTERNAL:
c      integer*4     index(mxqso)
c      real*4        red2(mxqso)
      parameter(mxbins=100)
      real*4        zb(mxbins),dN(mxbins),dNsmoo(mxbins)
 2    parameter(pi=3.14159265359)



      print*,'Starting  GauzVeron...'

      ioob=20
      zmax=5.0
      nbins=100
      call mkbins(nqso,0.0,zmax, redsh, nbins,
     _     zb,bmin,bmax, dN, ioob)
      
      ismoo=2 ! ismoo=2 => 2/100 * 5.0
      fact=1.0/sqrt(2.0*pi) /real(ismoo)
      
      dNmax=-9e9
      dNmaxsm=-9e9
      do i=1,nbins
         dNsmoo(i)=0.0
         do j=max(1,i-2*ismoo),min(i+2*ismoo,nbins) ! -> 2 sigma
            dd= real(j-i)
            xx= exp(-0.5*dd*dd/real(ismoo*ismoo))
            dNsmoo(i)=dNsmoo(i)+ xx*dN(j)   
         enddo
         dNmax=max(dNmax,dN(i))

         dNsmoo(i)=dNsmoo(i)*fact 
         dNmaxsm=max(dNmaxsm,dN(i))

      enddo
      print*,'GauzVeron: dNmax=',dNmax,' dNmaxsm=',dNmaxsm

      nflush=238719!234127
      do i=1,nflush
         xyz=randt()
      enddo
      
      print*,'GauzVeron: nqso=',nqso

      dz= zb(2)-zb(1)
      if(abs(dz).lt.1e-4)print*,'readVeron Error: dz=',dz

      do iq=1,nqso
         jtry=0
         izz=1
         dd=1e9
         do while(jtry.lt.100.and.dd.gt.dNsmoo(izz))
            jtry=jtry+1
            zz=randt()*zmax
            izz= max(1, min(nbins, int(zz/dz)))
            dd=randt()*dNmaxsm
         enddo
         if(dd.gt.dNsmoo(izz))print*,'GauzVeron WARNING: ',
     _        'jtry,zz,izz,dd,dNsmoo(izz)=',
     _        jtry,zz,izz,dd,dNsmoo(izz)

c         ddz= (randt() -0.5)*dz 

c         redsh(iq)=max(0.002, zb(izz) + ddz)
         redsh(iq)=max(0.002, zz)  ! modif 02/11/99 -> check OK. Yes OK.
      enddo

      print*,'Done GauzVeron.'
      return
      end



      subroutine ranx4Veron(n,x,x1,x2)

C     ==== uniformly randomly redistributes variable  x  ====
      
C     INPUTS:
      integer*4     n
      real*4        x(*), x1,x2
      

      nflush= 241561
      do i=1,nflush
         xyz=randt()
      enddo
      
      print*,'ranx4Veron: n,x1,x2=',n,x1,x2
      dx=x2-x1
      do i=1,n
         x(i)= x1+randt()*dx
      enddo
      return
      end


      subroutine ranx8Veron(n,x,x1,x2)
C     ==== uniformly randomly redistributes variable  x  ====
      
C     INPUTS:
      integer*4     n
      real*8        x(*), x1,x2 !! WARNING all three in real*8

C     INTERNAL:
      real*8        dx

      nflush= 632091 !321123 !241561 !
      do i=1,nflush
         xyz=randt()
      enddo
      
c      print*,'ranx8Veron: n,x1,x2=',n,x1,x2
      dx=x2-x1
      do i=1,n
         x(i)= x1+dble(randt())*dx
      enddo
      return
      end


      integer*4  function icount8Veron(n,x,x1,x2)
C     ==== counts values of  variable  x  within limits  
C     x1 \le  x  <   x2     ====
      
C     INPUTS:
      integer*4     n
      real*8        x(*), x1,x2 !! WARNING all three in real*8
      
c      print*,'icount8Veron: n,x1,x2=',n,x1,x2
      ic=0
      do i=1,n
         if(x1.le.x(i).and.x(i).lt.x2)ic=ic+1
      enddo
      icount8Veron=ic

      return
      end




      subroutine ranraVeron(ra1,ra2) !! WARNING superceded by ranx4Veron, ranx8Veron
      real*4        ra1,ra2

      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)

      print*,'Starting  ranraVeron...'


      nflush= 341561! 238719!234127
      do i=1,nflush
         xyz=randt()
      enddo
      
      print*,'ranraVeron: nqso=',nqso
      dr=ra2-ra1
      do iq=1,nqso
         ra_(iq)= dble( ra1+ randt()*dr )
      enddo

      print*,'Done ranraVeron.'
      return
      end


      subroutine subcatVeron(len,string)
C     ==== to extract a subset of the Veron catalogue ====
      
C     INPUTS:
      integer*4      len
      character*256  string

      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

      inew=0
      do iq=1,nqso
         isearch=0
         do i=1,17-len+1
            if(isearch.eq.0.and.
     _           name(iq)(i:i+len-1).eq.string(1:1+len-1))then
               isearch=1
               inew=inew+1
               ra_(inew)=ra_(iq)
               dec(inew)=dec(iq)
               redsh(inew)=redsh(iq)
               Vmag(inew)=Vmag(iq)
               B_V(inew)=B_V(iq)

               name(inew)=name(iq)
               FC(inew)=FC(iq)
               r_Vmag(inew)=r_Vmag(iq)
               r_z(inew)=r_z(iq)
            endif
         enddo
      enddo
      nqso=inew
      print*,'subcatVeron: nqso=',nqso
      return
      end


      subroutine bootVeron
C     ==== randomly resamples the points of the Veron catalogue ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

c      real*4        ra_4(mxqso),dec4(mxqso),gall(mxqso),galb(mxqso)

C     INTERNAL:
      integer*4     index(mxqso)
      real*4        red2(mxqso)
      real*8        ra_2(mxqso),dec2(mxqso)
c      character*17  name2(mxqso)

      print*,'Starting  bootVeron...'

      nflush=321123 !734122 !238719!234127 !
      do i=1,nflush
         xyz=randt()
      enddo

      do iq=1,nqso
         ra_2(iq)=ra_(iq)
         dec2(iq)=dec(iq)
         red2(iq)=redsh(iq)
         index(iq)= max(1,min(nqso, nint(randt()*nqso) )) ! the bootstrap 
      enddo

      do iq=1,nqso
         ra_(iq)=ra_2(index(iq))
         dec(iq)=dec2(index(iq))
         redsh(iq)=red2(index(iq))
      enddo

      print*,'Done bootVeron.'
      return
      end


      subroutine bkupVeron
C     ==== make a "backup" copy of Veron data in memory ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'



      integer*4 nqsobk
c      parameter (mxqso=11358)	! Number of records
c      include 'mxqso.dec'
      real*8        ra_bk        (mxqso) ! (deg) Right Ascension J2000
      real*8        decbk        (mxqso) ! (deg)     Declination J2000
      character*17  namebk       (mxqso) ! Most common name of the object
      character*1   l_zbk        (mxqso) ! [&gt;*] limit or method flag on z (4)
      real*4        redshbk          (mxqso) ! ? redshift
      real*4        Vmagbk(mxqso), B_Vbk(mxqso) ! Vmag, B_V
      integer*4     FCbk      (mxqso) ! [1,1863]? Reference of the Finding Chart
      integer*4     r_Vmagbk     (mxqso) ! [1,1863]? Reference of the Photometry
      integer*4     r_zbk        (mxqso) ! [1,1863]? Reference of the redshift


      common /Verbkup/ nqsobk, idumbk,ra_bk,decbk,redshbk,
     _     Vmagbk,B_Vbk,l_zbk,namebk,
     _     FCbk,r_Vmagbk,r_zbk

      nqsobk=nqso
      do iq=1,nqsobk
         ra_bk(iq)=ra_(iq)
         decbk(iq)=dec(iq)
         redshbk(iq)=redsh(iq)
         Vmagbk(iq)=Vmag(iq)
         B_Vbk(iq)=B_V(iq)

         namebk(iq)=name(iq)
         l_zbk(iq)=l_z(iq)
         FCbk(iq)=FC(iq)
         r_Vmagbk(iq)=r_Vmag(iq)
         r_zbk(iq)=r_z(iq)
      enddo

      print*,'bkupVeron: nqsobk=',nqsobk
      return
      end


      subroutine rdmemVeron
C     ==== read a "backup" copy of Veron data from memory ====
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'


      integer*4 nqsobk
c      parameter (mxqso=11358)	! Number of records
c      include 'mxqso.dec'
      real*8        ra_bk        (mxqso) ! (deg) Right Ascension J2000
      real*8        decbk        (mxqso) ! (deg)     Declination J2000
      character*17  namebk       (mxqso) ! Most common name of the object
      character*1   l_zbk        (mxqso) ! [&gt;*] limit or method flag on z (4)
      real*4        redshbk          (mxqso) ! ? redshift
      real*4        Vmagbk(mxqso), B_Vbk(mxqso) ! Vmag, B_V
      integer*4     FCbk      (mxqso) ! [1,1863]? Reference of the Finding Chart
      integer*4     r_Vmagbk     (mxqso) ! [1,1863]? Reference of the Photometry
      integer*4     r_zbk        (mxqso) ! [1,1863]? Reference of the redshift


      common /Verbkup/ nqsobk, idumbk,ra_bk,decbk,redshbk,
     _     Vmagbk,B_Vbk,l_zbk,namebk,
     _     FCbk,r_Vmagbk,r_zbk


      nqso=nqsobk
      do iq=1,nqso
         ra_(iq)=ra_bk(iq)
      enddo
      do iq=1,nqso
         dec(iq)=decbk(iq)
      enddo

      do iq=1,nqso
         redsh(iq)=redshbk(iq)
      enddo
      do iq=1,nqso
         Vmag(iq)=Vmagbk(iq)
      enddo
      do iq=1,nqso
         B_V(iq)=B_Vbk(iq)
      enddo

      do iq=1,nqso
         l_z(iq)=l_zbk(iq)
      enddo
      do iq=1,nqso
         name(iq)=namebk(iq)
      enddo

      do iq=1,nqso
         FC(iq)=FCbk(iq)
      enddo
      do iq=1,nqso
         r_Vmag(iq)=r_Vmagbk(iq)
      enddo
      do iq=1,nqso
         r_z(iq)=r_zbk(iq)
      enddo

      print*,'rdmemVeron: nqso=',nqso
      return
      end




      subroutine unrollVeron(q_0,H_0,cc_0,z1,z2,ra1,dec1)
C     ==== modify ra_, dec  by ratios of  X-Y distances  to the 
C     X-Y distances at  (z1+z2)/2 ====

C     INPUTS:
      real*4        q_0,H_0,cc_0,z1,z2, ra1,dec1
      
      integer*4 mxqso,nqso
c      parameter (mxqso=11358)	! Number of records
      include 'mxqso.dec'

      parameter(conh=3000.0,tolcurv=0.01)

      curv0= 2.0*q_0 + 3.0*cc_0 -1.0

      if(curv0.lt.-tolcurv)then
         kcurv=-1
         rcurv= conh/(H_0/100.0) /sqrt( -curv0 )
      elseif(curv0.gt.tolcurv)then
         kcurv=+1
         rcurv= conh/(H_0/100.0) /sqrt( curv0 )
C     --- following unnecessary if Om, lam < 1 and z < 8 ----
c     _                       rcurv*thetamax)
      else
         kcurv=0
         rcurv=9e9
      endif

      pmid= pdWein(q_0,H_0,cc_0, (z1+z2)/2.0 )
c      pmid= pdWein(q_0,H_0,cc_0, z1 )
      if(kcurv.lt.0)then
         pmid= rcurv*sinh(pmid/rcurv) 
      elseif(kcurv.gt.0)then
         pmid= rcurv*sin(pmid/rcurv)
      else
         continue
      endif
      
      do iq=1,nqso
         pp= pdWein(q_0,H_0,cc_0, redsh(iq))         
         if(kcurv.lt.0)then
            pp= rcurv*sinh(pp/rcurv) /pmid
         elseif(kcurv.gt.0)then
            pp= rcurv*sin(pp/rcurv)/ pmid
         else
            pp= pp /pmid
         endif

         ra_(iq)=dble(ra1) + dble(pp)*(ra_(iq)-dble(ra1)) 
         dec(iq)=dble(dec1) + dble(pp)*(dec(iq)-dble(dec1)) 
      enddo

      print*,'unrollVeron: nqso=',nqso
      return
      end

      subroutine smooIov
c     ==== adds a uniform random number to smooth out discreteness 
c     in cited redshifts of Iovino catalogue ====
c     written B.F.Roukema 16/06/00 boud@iucaa.ernet.in


      include 'mxqso.dec'

c     LOCAL:
      parameter(mxdisc=1000)
      integer*4  jzdisc(mxdisc,3) ! 1=median, 2= lower limit, 3 = upp lim
      integer*4  ifact  ! factor to convert from real to integer
      logical*4  new, test

      ifact=1000
      zsm=0.03
      test= .false.!.true. !

c     ---- find all the discrete values ----
      if(test)print*,'smooIov starting...'
      ndisc=0
      do iq=1,nqso
         jj=nint( redsh(iq)*real(ifact) )
         new=.true.
         do id=1,ndisc
            if(jj.eq.jzdisc(id,1))new=.false. ! is it new or old ?
         enddo
         if(new)then ! if new then add it to the list
            ndisc=ndisc+1
            jzdisc(ndisc,1)=jj
         endif
      enddo


      if(test)then
         print*,'smooIov: found ndisc=',ndisc, ' discrete values'
         print*,'(real(jzdisc(i,1))/real(ifact),i=1,ndisc)='
         print*,(real(jzdisc(i,1))/real(ifact),i=1,ndisc)
      endif

      if(test)print*,'smooIov: will sort...'
c      call sort(ndisc,jzdisc(1,1))
      call iisort(ndisc,jzdisc(1,1),jzdisc(1,2)) ! 2nd just a dummy !

c     --- decide on interval limits --
      if(test)print*,'smooIov: will decide interval limits...'
c     --- foll. section moved and corrected 05/09/00 ---
c      if(ndisc.gt.1)then
c         jzdisc(1,2)= - (jzdisc(1,1)+jzdisc(2,1))/2.0
c         jzdisc(ndisc,3)= (jzdisc(ndisc,1)+jzdisc(ndisc-1,1))/2.0
c      else
c         print*,'smooIov WARNING: only one z value !!'
c         return
c      endif

      do id=1,ndisc-1
         xx= (jzdisc(id+1,1)-jzdisc(id,1))/2.0
         jzdisc(id,3)= xx
         jzdisc(id+1,2)= -xx
      enddo

      if(ndisc.gt.1)then
         jzdisc(1,2)= jzdisc(2,2)
         jzdisc(ndisc,3)= jzdisc(ndisc-1,3)
      else
         print*,'smooIov WARNING: only one z value !!'
         return
      endif

      if(test)then
         print*,'smooIov: found ndisc=',ndisc, ' discrete values'
         print*,'(real(jzdisc(i,2))/real(ifact),i=1,ndisc)='
         print*,(real(jzdisc(i,2))/real(ifact),i=1,ndisc)
         print*,'(real(jzdisc(i,3))/real(ifact),i=1,ndisc)='
         print*,(real(jzdisc(i,3))/real(ifact),i=1,ndisc)
      endif


      if(test)print*,'smooIov: will modify redshifts...'
      do iq=1,nqso
         jj=nint( redsh(iq)*real(ifact) )
         id=1
         do while(jzdisc(id,1).ne.jj.and.id.lt.ndisc)
            id=id+1
         enddo
         if(jzdisc(id,1).ne.jj)then
            print*,'smooIov Warning: redsh(iq), id,jzdisc(id,1)=',
     _           redsh(iq), id,jzdisc(id,1)
            print*,'i.e., discrete redshift value not found'
         endif

         if(test)then
            write(6,'(i,f8.3,a,$)')iq,redsh(iq),' -> '
         endif
         xx=randt()
         if(xx.lt.0.5)then
            redsh(iq)=redsh(iq) 
     _           + randt()*real(jzdisc(id,2))/real(ifact) 
         else
            redsh(iq)=redsh(iq) 
     _           + randt()*real(jzdisc(id,3))/real(ifact)
         endif
         if(test)print*,redsh(iq)
      enddo

      return
      end


      real*4  function thcurv(th,kcurv,pdW0,rcurv)
c     --- converts a measured angle to a "constant scale" angle ---
      if(kcurv.gt.0)then
         thcurv=th* sin(pdW0/rcurv)*rcurv/pdW0
      elseif(kcurv.lt.0)then
         thcurv=th* sinh(pdW0/rcurv)*rcurv/pdW0
      else
         thcurv=th
      endif
      return
      end
